<?php use_helper('I18N', 'Date') ?>
<?php include_partial('article/assets') ?>

<div id="sf_admin_container">
  <h1><?php echo __('Reporting de l\'import des articles', array(), 'messages') ?></h1>
  <?php include_partial('article/flashes') ?>
  <div id="sf_admin_content">
    <?php echo form_tag('@article_export') ?>
    <h2>Les articles incorrect</h2>
    <table cellspacing="0">
      <thead>
        <tr>
	  <th class="sf_admin_text sf_admin_list_th_reference_ths">Ligne</th>
	  <th class="sf_admin_text sf_admin_list_th_reference_ths">Champs obligatoire manquant</th>
	  <th class="sf_admin_text sf_admin_list_th_detail">Détail</th>
        </tr>
      </thead>
      <tbody>
	<?php foreach ($sf_data->getRaw('champsObligatoire') as $ligne => $reference): ?>
	    <tr class="sf_admin_row odd">
		<td class="sf_admin_text sf_admin_list_td_reference_ths"><?php echo $ligne; ?></td>
		<td class="sf_admin_text sf_admin_list_td_reference_ths"><?php echo implode(", ", $reference['fields']); ?></td>
		<td><span class="voir_detail">Voir le détail</span><p class="detail" style="display:none;"><?php echo implode(';', $reference['data']); ?></p></td>
	    </tr>
	<?php endforeach; ?>
      </tbody>
    </table>
    
    <h2>Les nouveaux articles</h2>
    <table cellspacing="0">
      <thead>
        <tr>
	  <th class="sf_admin_text sf_admin_list_th_reference_ths">Reference ths</th>
	  <th class="sf_admin_text sf_admin_list_th_reference_ths_sage">Reference ths sage</th>
	  <th class="sf_admin_text sf_admin_list_th_prix_vente_ht">Prix vente ht</th>
	  <th class="sf_admin_text sf_admin_list_th_prix_vente_web">Prix de vente WEB</th>
	  <th class="sf_admin_text sf_admin_list_th_coefficient_vente_ths">Coefficient de vente THS</th>
	  <th class="sf_admin_text sf_admin_list_th_designation_courte">Designation courte</th>
	  <th class="sf_admin_text sf_admin_list_th_designation_detaillee">Designation détaillée</th>
	  <th class="sf_admin_text sf_admin_list_th_detail">Détail</th>
        </tr>
      </thead>
      <tbody>
	<?php foreach ($sf_data->getRaw('nouvellesReferences') as $reference): ?>
	    <tr class="sf_admin_row odd">
		<td class="sf_admin_text sf_admin_list_td_reference_ths"><?php echo $reference[0]; ?></td>
		<td class="sf_admin_text sf_admin_list_td_reference_ths_sage"><?php echo $reference[3]; ?></td>
		<td class="sf_admin_text sf_admin_list_td_prix_vente_ht"><?php echo $reference[11]; ?></td>
		<td class="sf_admin_text sf_admin_list_td_prix_vente_ht"><?php echo $reference[14]; ?></td>
		<td class="sf_admin_text sf_admin_list_td_prix_vente_ht"><?php echo $reference[15]; ?></td>
		<td class="sf_admin_text sf_admin_list_td_designation_courte"><?php echo $reference[29]; ?></td>
		<td class="sf_admin_text sf_admin_list_td_designation_detaillee"><?php echo $reference[28]; ?></td>
		<td><span class="voir_detail">Voir le détail</span><p class="detail" style="display:none;"><?php echo implode(';', $reference); ?></p></td>
	    </tr>
	<?php endforeach; ?>
      </tbody>
    </table>
    
    <h2>Référence fournisseur en doublon</h2>
    <table cellspacing="0">
      <thead>
        <tr>
	  <th class="sf_admin_text sf_admin_list_th_reference_fournisseur">Référence</th>
	  <th class="sf_admin_text sf_admin_list_th_detail">Détail</th>
        </tr>
      </thead>
      <tbody>
	<?php foreach ($sf_data->getRaw('referenceFournisseurDoublon') as $reference): ?>
	    <tr class="sf_admin_row odd">
		<td class="sf_admin_text sf_admin_list_td_reference_ths"><?php echo $reference['reference']; ?></td>
		<td>
		    <table>
			<thead>
			    <tr>
				<th>Ligne</th>
				<th>Voir le détail</th>
			    </tr>
			</thead>
			<tbody>
			    <?php foreach ($reference['data'] as $line => $data): ?>
			    <tr>
				<td><?php echo $line; ?></td>
				<td><span class="voir_detail">Voir le détail</span><p class="detail" style="display:none;"><?php echo implode(';', $data); ?></p></td>
			    </tr>
			    <?php endforeach; ?>
			</tbody>
		    </table>
		</td>
	    </tr>
	<?php endforeach; ?>
      </tbody>
    </table>
    
    <h2>Référence THS Sage en doublon</h2>
    <table cellspacing="0">
      <thead>
        <tr>
	  <th class="sf_admin_text sf_admin_list_th_reference_fournisseur">Référence</th>
	  <th class="sf_admin_text sf_admin_list_th_detail">Détail</th>
        </tr>
      </thead>
      <tbody>
	<?php foreach ($sf_data->getRaw('referenceTHSSageDoublon') as $reference): ?>
	    <tr class="sf_admin_row odd">
		<td class="sf_admin_text sf_admin_list_td_reference_ths"><?php echo $reference['reference']; ?></td>
		<td>
		    <table>
			<thead>
			    <tr>
				<th>Ligne</th>
				<th>Voir le détail</th>
			    </tr>
			</thead>
			<tbody>
			    <?php foreach ($reference['data'] as $line => $data): ?>
			    <tr>
				<td><?php echo $line; ?></td>
				<td><span class="voir_detail">Voir le détail</span><p class="detail" style="display:none;"><?php echo implode(';', $data); ?></p></td>
			    </tr>
			    <?php endforeach; ?>
			</tbody>
		    </table>
		</td>
	    </tr>
	<?php endforeach; ?>
      </tbody>
    </table>
    
    <h2>Référence THS Site en doublon</h2>
    <table cellspacing="0">
      <thead>
        <tr>
	  <th class="sf_admin_text sf_admin_list_th_reference_fournisseur">Référence</th>
	  <th class="sf_admin_text sf_admin_list_th_detail">Détail</th>
        </tr>
      </thead>
      <tbody>
	<?php foreach ($sf_data->getRaw('referenceTHSSiteDoublon') as $reference): ?>
	    <tr class="sf_admin_row odd">
		<td class="sf_admin_text sf_admin_list_td_reference_ths"><?php echo $reference['reference']; ?></td>
		<td>
		    <table>
			<thead>
			    <tr>
				<th>Ligne</th>
				<th>Voir le détail</th>
			    </tr>
			</thead>
			<tbody>
			    <?php foreach ($reference['data'] as $line => $data): ?>
			    <tr>
				<td><?php echo $line; ?></td>
				<td><span class="voir_detail">Voir le détail</span><p class="detail" style="display:none;"><?php echo implode(';', $data); ?></p></td>
			    </tr>
			    <?php endforeach; ?>
			</tbody>
		    </table>
		</td>
	    </tr>
	<?php endforeach; ?>
      </tbody>
    </table>
    
    <h2>Les articles modifiées</h2>
    <table cellspacing="0">
      <thead>
        <tr>
	  <th class="sf_admin_text sf_admin_list_th_reference_ths">Reference ths</th>
	  <th class="sf_admin_text sf_admin_list_th_reference_ths_sage">Reference ths sage</th>
	  <th class="sf_admin_text sf_admin_list_th_prix_vente_ht">Prix vente ht</th>
	  <th class="sf_admin_text sf_admin_list_th_prix_vente_web">Prix de vente WEB</th>
	  <th class="sf_admin_text sf_admin_list_th_coefficient_vente_ths">Coefficient de vente THS</th>
	  <th class="sf_admin_text sf_admin_list_th_designation_courte">Designation courte</th>
	  <th class="sf_admin_text sf_admin_list_th_designation_detaillee">Designation détaillée</th>
	  <th class="sf_admin_text sf_admin_list_th_detail">Détail</th>
        </tr>
      </thead>
      <tbody>
	<?php foreach ($sf_data->getRaw('modifies') as $object): ?>
	    <?php $reference = $object['data']; ?>
	    <tr class="sf_admin_row odd">
		<td class="sf_admin_text sf_admin_list_td_reference_ths"><?php echo $reference[0]; ?></td>
		<td class="sf_admin_text sf_admin_list_td_reference_ths_sage"><?php echo $reference[3]; ?></td>
		<td class="sf_admin_text sf_admin_list_td_prix_vente_ht"><?php echo $reference[11]; ?></td>
		<td class="sf_admin_text sf_admin_list_td_prix_vente_ht"><?php echo $reference[14]; ?></td>
		<td class="sf_admin_text sf_admin_list_td_prix_vente_ht"><?php echo $reference[15]; ?></td>
		<td class="sf_admin_text sf_admin_list_td_designation_courte">OLD: <?php echo $object['designation_courte_old']; ?><br>NEW: <?php echo $reference[29]; ?></td>
		<td class="sf_admin_text sf_admin_list_td_designation_detaillee">OLD: <?php echo $object['designation_detaillee_old']; ?><br>NEW: <?php echo $reference[28]; ?></td>
		<td><span class="voir_detail">Voir le détail</span><p class="detail" style="display:none;"><?php echo implode(';', $reference); ?></p></td>
	    </tr>
	<?php endforeach; ?>
      </tbody>
    </table>
    
    <h2>Les articles non modifiés</h2>
    <table cellspacing="0">
      <thead>
        <tr>
	  <th class="sf_admin_text sf_admin_list_th_reference_ths">Reference ths</th>
	  <th class="sf_admin_text sf_admin_list_th_reference_ths_sage">Reference ths sage</th>
	  <th class="sf_admin_text sf_admin_list_th_prix_vente_ht">Prix vente ht</th>
	  <th class="sf_admin_text sf_admin_list_th_prix_vente_web">Prix de vente WEB</th>
	  <th class="sf_admin_text sf_admin_list_th_coefficient_vente_ths">Coefficient de vente THS</th>
	  <th class="sf_admin_text sf_admin_list_th_designation_courte">Designation courte</th>
	  <th class="sf_admin_text sf_admin_list_th_designation_detaillee">Designation détaillée</th>
	  <th class="sf_admin_text sf_admin_list_th_detail">Détail</th>
        </tr>
      </thead>
      <tbody>
	<?php foreach ($sf_data->getRaw('nonModifies') as $reference): ?>
	    <tr class="sf_admin_row odd">
		<td class="sf_admin_text sf_admin_list_td_reference_ths"><?php echo $reference[0]; ?></td>
		<td class="sf_admin_text sf_admin_list_td_reference_ths_sage"><?php echo $reference[3]; ?></td>
		<td class="sf_admin_text sf_admin_list_td_prix_vente_ht"><?php echo $reference[11]; ?></td>
		<td class="sf_admin_text sf_admin_list_td_prix_vente_ht"><?php echo $reference[14]; ?></td>
		<td class="sf_admin_text sf_admin_list_td_prix_vente_ht"><?php echo $reference[15]; ?></td>
		<td class="sf_admin_text sf_admin_list_td_designation_courte"><?php echo $reference[29]; ?></td>
		<td class="sf_admin_text sf_admin_list_td_designation_detaillee"><?php echo $reference[28]; ?></td>
		<td><span class="voir_detail">Voir le détail</span><p class="detail" style="display:none;"><?php echo implode(';', $reference); ?></p></td>
	    </tr>
	<?php endforeach; ?>
      </tbody>
    </table>
    
    <ul class="sf_admin_actions">
	<input  type="hidden" name="fichier" value="<?php echo $fichier; ?>">
	<input type="submit" name="btnAnnuler" value="Annuler">
	<input type="submit" name="btnExporter" value="Exporter">
    </ul>
    </form>
  </div>
</div>

<script>
    $(document).ready(function() {
	$('.voir_detail').click(function() {
	    $this = $(this);
	    $detail = $this.parent().find('.detail');
	    
	    if ($detail.css('display') == 'none') {
		$detail.show();
		$this.html('Cacher le détail');
	    } else {
		$detail.hide();
		$this.html('Voir le détail');
	    }
	});
    });
</script>