<?php

require_once dirname(__FILE__).'/../lib/familleGeneratorConfiguration.class.php';
require_once dirname(__FILE__).'/../lib/familleGeneratorHelper.class.php';

/**
 * famille actions.
 *
 * @package    sf_sandbox
 * @subpackage famille
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class familleActions extends autoFamilleActions
{
	protected function processForm(sfWebRequest $request, sfForm $form)
	{
		$form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
		if ($form->isValid())
		{
			// On vérifie que le libelle et la position n'existent pas déjà en base de données
			$unique = true;
			if(FamilleTable::existeLibelle($form->getValue("id_famille"), $form->getValue("libelle")))
			{
				$unique = false;
				$message = "Le libelle saisi existe déjà";
			}
			else if(FamilleTable::existeOrdre($form->getValue("id_famille"), $form->getValue("ordre")))
			{
				$unique = false;
				$message = "La position saisie existe déjà";
			}
				
			if(!$unique)
			{
				$this->getUser()->setFlash('error', $message);
				return sfView::SUCCESS;
			}
				
			$notice = $form->getObject()->isNew() ? 'The item was created successfully.' : 'The item was updated successfully.';

			try
			{
				$famille = $form->save();
			}
			catch (Doctrine_Validator_Exception $e)
			{

				$errorStack = $form->getObject()->getErrorStack();

				$message = get_class($form->getObject()) . ' has ' . count($errorStack) . " field" . (count($errorStack) > 1 ?  's' : null) . " with validation errors: ";
				foreach ($errorStack as $field => $errors)
				{
					$message .= "$field (" . implode(", ", $errors) . "), ";
				}
				$message = trim($message, ', ');

				$this->getUser()->setFlash('error', $message);
				return sfView::SUCCESS;
			}

			$this->dispatcher->notify(new sfEvent($this, 'admin.save_object', array('object' => $famille)));

			if ($request->hasParameter('_save_and_add'))
			{
				$this->getUser()->setFlash('notice', $notice.' You can add another one below.');

				$this->redirect('@famille_new');
			}
			else
			{
				$this->getUser()->setFlash('notice', $notice);

				$this->redirect(array('sf_route' => 'famille_edit', 'sf_subject' => $famille));
			}
		}
		else
		{
			$this->getUser()->setFlash('error', 'The item has not been saved due to some errors.', false);
		}
	}
}
