<?php use_helper('I18N', 'Date') ?>
<?php include_partial('fournisseur/assets') ?>

<div id="sf_admin_container">
  <h1><?php echo __('Edition du fournisseur', array(), 'messages') ?></h1>

  <?php include_partial('fournisseur/flashes') ?>

  <div id="sf_admin_header">
    <?php include_partial('fournisseur/form_header', array('fournisseur' => $fournisseur, 'form' => $form, 'configuration' => $configuration)) ?>
  </div>

  <div id="sf_admin_content">
    <?php include_partial('fournisseur/form', array('fournisseur' => $fournisseur, 'form' => $form, 'configuration' => $configuration, 'helper' => $helper)) ?>
  </div>

  <div id="sf_admin_footer">
    <?php include_partial('fournisseur/form_footer', array('fournisseur' => $fournisseur, 'form' => $form, 'configuration' => $configuration)) ?>
  </div>
  
  <h1>Gestion des coefficients</h1>
  <div id="sf_admin_content">
    <div class="sf_admin_list">
	    <table cellspacing="0">
		    <thead>
			    <tr>
				    <th class="sf_admin_text sf_admin_list_th_id_zone">Id</th>
				    <th class="sf_admin_text sf_admin_list_th_libelle">Coefficient</th>
				    <th class="sf_admin_text sf_admin_list_th_prix_min">Prix min</th>
				    <th class="sf_admin_text sf_admin_list_th_prix_max">Prix max</th>
				    <th id="sf_admin_list_th_actions">Actions</th>
			    </tr>
		    </thead>
		    <tfoot>
			    <tr>
				    <th colspan="5"><?php echo count($fournisseurCoefficient); ?> résultats</th>
			    </tr>
		    </tfoot>
		    <tbody>
			    <?php if (count($fournisseurCoefficient) > 0): ?>
				    <?php foreach ($fournisseurCoefficient as $object): ?>
					    <tr class="sf_admin_row odd">
						    <td class="sf_admin_text sf_admin_list_td_id_zone"><?php echo $object->getId(); ?></td>
						    <td class="sf_admin_text sf_admin_list_td_coefficient"><?php echo $object->getCoefficient(); ?></td>
						    <td class="sf_admin_text sf_admin_list_td_prix_min"><?php echo $object->getPrixMin(); ?></td>
						    <td class="sf_admin_text sf_admin_list_td_prix_max"><?php echo $object->getPrixMax(); ?></td>
						    <td>
							    <ul class="sf_admin_td_actions">
								    <li class="sf_admin_action_edit"><a href="<?php echo url_for('@fournisseurcoefficient_edit?id='.$object->getId()); ?>">Modifier</a></li>
								    <li class="sf_admin_action_delete"><a href="<?php echo url_for('@fournisseurcoefficient_delete?id='.$object->getId()); ?>" onclick="return confirm('Etes vous sûr ?')">Supprimer</a></li>
							    </ul>
						    </td>
					    </tr>
				    <?php endforeach; ?>
			    <?php else: ?>
					    <tr><td colspan="5">Aucun coefficient</td></tr>
			    <?php endif; ?>
		    </tbody>
	    </table>
	    <ul class="sf_admin_actions">
		    <li class="sf_admin_action_new"><?php echo link_to(__('Ajouter un coefficient', array(), 'messages'), '@fournisseurcoefficient_new', array('query_string' => 'id_fournisseur='.$fournisseur->getId())) ?></li>
	    </ul>
    </div>
</div>
