<?php

require_once dirname(__FILE__).'/../lib/fraisdeportGeneratorConfiguration.class.php';
require_once dirname(__FILE__).'/../lib/fraisdeportGeneratorHelper.class.php';

/**
 * fraisdeport actions.
 *
 * @package    sf_sandbox
 * @subpackage fraisdeport
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class fraisdeportActions extends autoFraisdeportActions
{
	public function executeEdit(sfWebRequest $request)
	{
		$this->transporteur = Doctrine::getTable('Transporteur')->find($request->getParameter("id_transporteur"));
		$this->transporteur->setForfaitEmballage(Utils::doubleEnToFr($this->transporteur->getForfaitEmballage()));
		$this->form = $this->configuration->getForm($this->transporteur);
			
		$this->zone = new Zone();
		$this->zoneDepartements = array();
		$this->zoneTarifs = array();

		// Action pour la liste des zones
		if($request->hasParameter("mode"))
		{
			if($request->getParameter("mode") == "delete")
			{
				$zone = Doctrine::getTable('Zone')->find($request->getParameter("id_zone"));
				$zone->delete();
				$this->getUser()->setFlash('notice_zone', 'L\'objet a été supprimé avec succès.');
			}
			else if($request->getParameter("mode") == "update")
			{
				$this->zone = Doctrine::getTable('Zone')->find($request->getParameter("id_zone"));

				foreach($this->zone->getDepartements() as $dep)
				{
					$this->zoneDepartements[$dep->getIdDepartement()] = $dep->getIdDepartement();
				}

				foreach($this->zone->getZoneTarifs() as $tarif)
				{
					$this->zoneTarifs[$tarif->getIdPoids()] = str_replace(".", ",", $tarif->getTarif());
				}
			}
		}

		if($request->isMethod("POST"))
		{
			$values = $request->getPostParameter("zone");
			if($values["id_zone"] != "")
			{
				$this->zone = Doctrine::getTable('Zone')->find($values["id_zone"]);
			}

			$this->zone->setLibelle($values["libelle"]);

			$this->zone->setStatut(false);
			if(isset($values["statut"]))
			{
				$this->zone->setStatut(true);
			}

			$this->zone->setIdTransporteur($values["id_transporteur"]);

			if(isset($values["departements_list"]))
			{
				if($this->zone->existeDepartements($values["departements_list"]))
				{
					$this->getUser()->setFlash('error_zone', 'Vous ne pouvez pas ajouter dans deux zones différentes un même département.');
				}
				else
				{
					$this->zone->save();
						
					$this->zone->deleteDepartements();
					$this->zone->addDepartements($values["departements_list"]);
	
					$this->zone->deleteTarifs();
					$this->zone->addTarifs($values["poids_list"]);
					$this->getUser()->setFlash('notice_zone', 'L\'objet a été mis à jour avec succès.');
				}
			}
			else
			{
				$this->zone->save();
						
				$this->zone->deleteDepartements();
	
				$this->zone->deleteTarifs();
				$this->zone->addTarifs($values["poids_list"]);
				$this->getUser()->setFlash('notice_zone', 'L\'objet a été mis à jour avec succès.');
			}
			
			foreach($this->zone->getDepartements() as $dep)
			{
				$this->zoneDepartements[$dep->getIdDepartement()] = $dep->getIdDepartement();
			}

			foreach($this->zone->getZoneTarifs() as $tarif)
			{
				$this->zoneTarifs[$tarif->getIdPoids()] = $tarif->getTarif();
			}
		}

		$this->listeZone = $this->transporteur->Zones;
		$this->listeDepartement = Doctrine::getTable('Departement')->findAll();
		$this->listePoids = Doctrine::getTable('Poids')->findAll();
	}

	protected function processForm(sfWebRequest $request, sfForm $form)
	{
		$values = $request->getParameter($form->getName());
		$values["forfait_emballage"] = Utils::doubleFrToEn($values["forfait_emballage"]);

		$form->bind($values, $request->getFiles($form->getName()));
		if ($form->isValid())
		{
			$notice = $form->getObject()->isNew() ? 'The item was created successfully.' : 'The item was updated successfully.';

			try
			{
				$transporteur = $form->save();
			}
			catch (Doctrine_Validator_Exception $e)
			{
				$errorStack = $form->getObject()->getErrorStack();

				$message = get_class($form->getObject()) . ' has ' . count($errorStack) . " field" . (count($errorStack) > 1 ?  's' : null) . " with validation errors: ";
				foreach ($errorStack as $field => $errors)
				{
					$message .= "$field (" . implode(", ", $errors) . "), ";
				}
				$message = trim($message, ', ');

				$this->getUser()->setFlash('error', $message);
				return sfView::SUCCESS;
			}

			$this->dispatcher->notify(new sfEvent($this, 'admin.save_object', array('object' => $transporteur)));

			if ($request->hasParameter('_save_and_add'))
			{
				$this->getUser()->setFlash('notice', $notice.' You can add another one below.');

				$this->redirect('@transporteur_fraisdeport_new');
			}
			else
			{
				$this->getUser()->setFlash('notice', $notice);

				$this->redirect(array('sf_route' => 'transporteur_fraisdeport_edit', 'sf_subject' => $transporteur));
			}
		}
		else
		{
			$this->getUser()->setFlash('error', 'The item has not been saved due to some errors.', false);
		}
	}

	public function executeCalcul(sfWebRequest $request)
	{
		$this->form = new CalculFraisDePortForm();
		if($request->isMethod("POST"))
		{
			$values = $request->getParameter($this->form->getName());
			$values["poids"] = Utils::doubleFrToEn($values["poids"]);
			$this->form->bind($values);
			if($this->form->isValid())
			{
				$hors_gabarit = false;
				if(isset($values["hors_gabarit"]))
				{
					$hors_gabarit = true;
				}
				$poids = $values["poids"] * 1000;
				$this->resultats = ZoneTarifTable::calculFraisDePort($poids, $hors_gabarit, $values["code_postal"]);
			}
		}
	}
}
