<?php

require_once dirname(__FILE__).'/../lib/mail_sujetGeneratorConfiguration.class.php';
require_once dirname(__FILE__).'/../lib/mail_sujetGeneratorHelper.class.php';

/**
 * mail_sujet actions.
 *
 * @package    sf_sandbox
 * @subpackage mail_sujet
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class mail_sujetActions extends autoMail_sujetActions
{
	public function executeFilter(sfWebRequest $request)
  {
    $this->setPage(1);

    if ($request->hasParameter('_reset'))
    {
      $this->setFilters($this->configuration->getFilterDefaults());

      $this->redirect('@mail_sujet');
    }

    $this->filters = $this->configuration->getFilterForm($this->getFilters());
    
    $parameters = $request->getParameter($this->filters->getName());
    
    if($this->getUser()->hasCredential('Commercial')) {
	    $parameters['id_user'] = $this->getUser()->getAttribute('user_id', null, 'sfGuardSecurityUser');
    }

    $this->filters->bind($parameters);
    if ($this->filters->isValid())
    {
      $this->setFilters($this->filters->getValues());

      $this->redirect('@mail_sujet');
    }

    $this->pager = $this->getPager();
    $this->sort = $this->getSort();

    $this->setTemplate('index');
  }
  
	public function executeMesMails(sfWebRequest $request)
	{
		// sorting
		if ($request->getParameter('sort') && $this->isValidSortColumn($request->getParameter('sort'))) {
			$this->setSort(array($request->getParameter('sort'), $request->getParameter('sort_type')));
		}

		// pager
		if ($request->getParameter('page')) {
			$this->setPage($request->getParameter('page'));
		}
		
		
		// set filters
		$this->setFilters(array(
			'id_user' => $this->getUser()->getAttribute('user_id', null, 'sfGuardSecurityUser')
		));

		$this->pager = $this->getPager();
		$this->sort = $this->getSort();
		
		$this->setTemplate('index');
	}
	
	public function executeUpdate(sfWebRequest $request)
	{
		$this->mail_sujet = $this->getRoute()->getObject();
		$this->form = $this->configuration->getForm($this->mail_sujet);
		
		$parameter = $request->getParameter($this->form->getName());
		
		$mail = Doctrine_Core::getTable("MailSujet")->find($parameter['id']);
		$mail->setIdUser($parameter['id_user']);
		$mail->setDateAssignation(date("Y-m-d H:i:s"));
		$mail->setStatut(MailSujet::STATUT_ASSIGNE);
		$mail->save();
		
		$user = Doctrine_Core::getTable("SfGuardUser")->find($parameter['id_user']);
		
		$sender = sfConfig::get("app_contact_email");
		$objet = 'Support : un message vous a été assigné';
		$body = "Bonjour ".$user->getFirstName()." ".$user->getLastName().",<br><br>
Le message numéro ".$parameter['id']." vient de vous être assigné.<br><br>
Veuillez en prendre connaissance et répondre au client.<br><br>
Cordialement,<br>
L'équipe THS.<br>
http://www.haute-pression.com";
		
		$receiver = $user->getEmailAddress();
		$mailing = $this->getMailer()->compose($sender, $receiver, $objet, '')->setBody($body, 'text/html');
		$this->mailEnvoye = $this->getMailer()->send($mailing);
		
		$this->form = $this->configuration->getForm($mail);

		$this->setTemplate('edit');
	}
	
	protected function processForm(sfWebRequest $request, sfForm $form)
	{
		$form->bind($request->getParameter($form->getName()), $request->getFiles($form->getName()));
		
		if ($form->isValid()) {
			$notice = $form->getObject()->isNew() ? 'The item was created successfully.' : 'The item was updated successfully.';

			try {
				$mail_sujet = $form->save();
			} catch (Doctrine_Validator_Exception $e) {

				$errorStack = $form->getObject()->getErrorStack();

				$message = get_class($form->getObject()) . ' has ' . count($errorStack) . " field" . (count($errorStack) > 1 ?  's' : null) . " with validation errors: ";
				foreach ($errorStack as $field => $errors) {
				    $message .= "$field (" . implode(", ", $errors) . "), ";
				}
				$message = trim($message, ', ');

				$this->getUser()->setFlash('error', $message);
				return sfView::SUCCESS;
			}

			$this->dispatcher->notify(new sfEvent($this, 'admin.save_object', array('object' => $mail_sujet)));

			if ($request->hasParameter('_save_and_add'))
			{
				$this->getUser()->setFlash('notice', $notice.' You can add another one below.');

				$this->redirect('@mail_sujet_new');
			}
			else
			{
				$this->getUser()->setFlash('notice', $notice);

				$this->redirect(array('sf_route' => 'mail_sujet_edit', 'sf_subject' => $mail_sujet));
			}
		      }
		      else
		      {
			$this->getUser()->setFlash('error', 'The item has not been saved due to some errors.', false);
		      }
	}
	
	public function executeRepondre(sfWebRequest $request)
	{
		$sujet_id = $request->getParameter('id_sujet', null);
		
		$this->forward404If(is_null($sujet_id));
		
		// Récupérer sujet
		$sujet = Doctrine_Core::getTable("MailSujet")->find($sujet_id);
		$this->form = new MailReponseForm();
		
		if ($request->isMethod('post')) {
			if ($request->hasParameter('submit_close_resolved')) {
				$sujet->setStatut(MailSujet::STATUT_RESOLU);
				$sujet->save();
			} elseif ($request->hasParameter('submit_close_not_resolved')) {
				$sujet->setStatut(MailSujet::STATUT_NON_RESOLU);
				$sujet->save();
			} else {
				$this->form->bind($request->getParameter($this->form->getName()), $request->getFiles($this->form->getName()));
				$parameter = $request->getParameter($this->form->getName());

				if ($this->form->isValid()) {
					$dbc = sfContext::getInstance()->getDatabaseManager()->getDatabase('doctrine')->getDoctrineConnection();
					$dbc->beginTransaction();
					
					try {
						$mail_reponse = new MailReponse();
						$mail_reponse->setMessage($parameter['message']);
						$mail_reponse->setIdMailSujet($parameter['id_mail_sujet']);
						$mail_reponse->setDateReponse(date("Y-m-d H:i:s"));
						$mail_reponse->setIdUser($this->getUser()->getAttribute('user_id', null, 'sfGuardSecurityUser'));
						$mail_reponse->save();
						
						for ($i = 1; $i <= 5; $i++) {
							$file = $this->form->getValue('image_'.$i);
							
							if (!is_null($file)) {
								$filename = uniqid().'_'.Utils::slugify($file->getOriginalName());
								$extension = $file->getExtension($file->getOriginalExtension());

								$imageInfo = getimagesize($file->getTempName());
								
								if ($imageInfo[0] > 1024) {
									$thumbnail = new sfThumbnail(1024);
									$thumbnail->loadFile($file->getTempName());
									$thumbnail->save(sfConfig::get('sf_upload_dir').'/mails/'.$filename.$extension, 'image/png');
								} else {
									$file->save(sfConfig::get('sf_upload_dir').'/mails/'.$filename.$extension);
								}
								
								if (file_exists(sfConfig::get('sf_upload_dir').'/mails/'.$filename.$extension)) {
									$thumbnail = new sfThumbnail(100, 100);
									$thumbnail->loadFile(sfConfig::get('sf_upload_dir').'/mails/'.$filename.$extension);
									$thumbnail->save(sfConfig::get('sf_upload_dir').'/mails/thumbnail/'.$filename.$extension, 'image/png');

									$mail_file = new MailFile();
									$mail_file->setName($filename.$extension);
									$mail_file->setType('image');
									$mail_file->setIdMailReponse($mail_reponse->getPrimaryKey());
									$mail_file->save();
								} else {
									throw new Exception("Erreur lors de l'enregistrement de l'image");
								}
							}
							
							$file = $this->form->getValue('pdf_'.$i);

							if (!is_null($file)) {
								$filename = uniqid().'_'.Utils::slugify($file->getOriginalName());
								$extension = $file->getExtension($file->getOriginalExtension());

								if ($file->save(sfConfig::get('sf_upload_dir').'/mails/'.$filename.$extension)) {
									$mail_file = new MailFile();
									$mail_file->setName($filename.$extension);
									$mail_file->setType('pdf');
									$mail_file->setIdMailReponse($mail_reponse->getPrimaryKey());
									$mail_file->save();
								} else {
									throw new Exception("Erreur lors de l'enregistrement du PDF");
								}
							}
						}
						
						
						$sujet->setStatut(MailSujet::STATUT_EN_COURS);
						$sujet->save();
						
						$dbc->commit();
					 
						$receiver = $sujet->getEmail();
						$objet = 'THS : un conseiller vient de vous répondre';
						$body = "<strong>Technique Haute-Pression et Sablage</strong><br>
Le Grand Colombier<br>
24150 - BAYAC<br>
France<br>
Tél: 05 53 61 11 86<br>
Fax: 05 53 58 39 98<br>
<br>
Sarl au capital de 30 200 €. Siret 351617048 00019 - Ape 4669B<br>
<br>
Bonjour ".$sujet->getNom()."<br><br>

Un conseiller vient d'effectuer une réponse au sujet de votre message.<br><br>
Cliquer sur le lien suivant pour voir la réponse : <a href='http://www.haute-pression.com/support?code=".$sujet->getCode()."&email=".$sujet->getEmail()."'>http://www.haute-pression.com/support?code=".$sujet->getCode()."&email=".$sujet->getEmail()."</a>.<br><br>
Cordialement,<br>
".$sujet->getUserAssignation().".<br>
http://www.haute-pression.com";

						$sender = array(sfConfig::get("app_contact_email") => 'Haute-pression.com');
						$mailing = $this->getMailer()->compose($sender, $receiver, $objet, '')->setBody($body, 'text/html');
						$this->mailEnvoye = $this->getMailer()->send($mailing);

						$this->form = new MailReponseForm();
						$this->getUser()->setFlash('notice', "Votre message a bien été enregistré et transmis au client.");
					} catch(Exception $e) {
						$this->form->getErrorSchema()->addError(new sfValidatorError(new sfValidatorString(), $e->getMessage()), 'error_name');
						
						try {
							$dbc->rollback(); 
						} catch (Exception $ex) {
							
						}
					}
				}

				// Récupérer sujet
				$sujet = Doctrine_Core::getTable("MailSujet")->find($sujet_id);
			}
		}
		
		$this->sujet = $sujet;
		$this->templates = Doctrine_Core::getTable("Mail")->findAll();
		
		// Formulaire réponse
		$this->form->setDefault('id_mail_sujet', $sujet_id);
	}
}

