<?php use_stylesheet('/sfDoctrinePlugin/css/global.css', 'first') ?>
<?php use_stylesheet('/sfDoctrinePlugin/css/default.css', 'first') ?>
<?php use_stylesheets_for_form($form) ?>
<?php use_javascripts_for_form($form) ?>
<div id="sf_admin_container">
	<h1><?php echo __('Mes mails', array(), 'messages') ?></h1>
	<div id="sf_admin_content">
		<div class="sf_admin_list">
			<?php echo $form->renderGlobalErrors() ?>
			<?php if ($sf_user->hasFlash('notice')): ?>
				<div class="notice"><?php echo __($sf_user->getFlash('notice'), array(), 'sf_admin') ?></div>
			<?php endif; ?>

			<?php if ($sf_user->hasFlash('error')): ?>
				<div class="error"><?php echo __($sf_user->getFlash('error'), array(), 'sf_admin') ?></div>
			<?php endif; ?>

			<h3>Demande initiale</h3>
			<table style="width: 100%; max-width: 875px; min-width: 405px">
				<tbody>
					<tr class="sf_admin_row">
						<td class="sf_admin_text"><strong>Statut :</strong> <?php echo $sujet->getStatut(); ?></td>
						<td class="sf_admin_text"><strong>Code :</strong> <?php echo $sujet->getCode(); ?></td>
						<td class="sf_admin_text"><strong>Date de réception :</strong> <?php $date = new DateTime($sujet->getDateReception()); echo $date->format("d/m/Y H:i:s"); ?></td>
						<td class="sf_admin_text"><strong>Date d'assignation :</strong> <?php $date = new DateTime($sujet->getDateAssignation()); echo $date->format("d/m/Y H:i:s"); ?></td>
						<td class="sf_admin_text"><strong>Utilisateur assigné :</strong> <?php echo $sujet->getSfGuardUser()->getLastName(); ?> <?php echo $sujet->getSfGuardUser()->getFirstName(); ?></td>
					</tr>
					<tr class="sf_admin_row">
						<td class="sf_admin_text"><strong>Type :</strong> <?php echo $sujet->getType(); ?></td>
						<td class="sf_admin_text"><strong>Nom :</strong> <?php echo $sujet->getNom(); ?></td>
						<td class="sf_admin_text"><strong>Téléphone :</strong> <?php echo $sujet->getTelephone(); ?></td>
						<td class="sf_admin_text"><strong>Email :</strong> <?php echo $sujet->getEmail(); ?></td>
						<td class="sf_admin_text"><strong>Code postal :</strong> <?php echo $sujet->getCodePostal(); ?></td>
					</tr>
					<tr class="sf_admin_row">
						<th class="sf_admin_text" style="width: 30%"><strong>Message</strong></th>
						<td class="sf_admin_text" colspan="4"><?php echo nl2br($sujet->getMessage()); ?></td>
					</tr>
				</tbody>
			</table>
			<h3>Les échanges</h3>
			<?php if (count($sujet->getMailReponses()) > 0): ?>
				<table style="width: 100%; max-width: 875px; min-width: 405px">
					<tbody>
						<?php foreach ($sujet->getMailReponses() as $reponse): ?>
						
							<tr class="sf_admin_row odd">
								<th class="sf_admin_text" style="width: 30%">Réponse <strong><?php if (!is_null($reponse->getIdUser())): ?>de <?php echo $reponse->getSfGuardUser()->getLastName(); ?> <?php echo $reponse->getSfGuardUser()->getFirstName(); ?><?php else: ?>du client<?php endif; ?></strong> <br>le <strong><?php $date = new DateTime($reponse->getDateReponse()); echo $date->format("d/m/Y H:i:s"); ?></strong></th>
								<td class="sf_admin_text">
									<?php echo nl2br(html_entity_decode($reponse->getMessage())); ?>
									<br><br>
									<?php foreach ($reponse->getMailFiles() as $file): ?>
										<?php if ($file->getType() == 'pdf'): ?>
											<a class="mail_download_file" href="<?php echo sfConfig::get('sf_web_dir_name').'/uploads/mails/'.$file->getName(); ?>" target="_blank"><?php echo image_tag('icone_pdf'); ?></a>
										<?php endif; ?>
									<?php endforeach; ?>
										<?php foreach ($reponse->getMailFiles() as $file): ?>
										<?php if ($file->getType() == 'image'): ?>
									<a class="mail_download_file" href="<?php echo sfConfig::get('sf_web_dir_name').'/uploads/mails/'.$file->getName(); ?>" target="_blank"><img src="<?php echo sfConfig::get('sf_web_dir_name').'/uploads/mails/thumbnail/'.$file->getName(); ?>"></a>
										<?php endif; ?>
									<?php endforeach; ?>
								</td>
							</tr>
						<?php endforeach; ?>
					</tbody>
				</table>
			<?php else: ?>
				<p>Aucun échange pour le moment...</p>
			<?php endif; ?>
			<h3>Répondre au client</h3>
			<form action="" method="post" enctype="multipart/form-data">
				<table id="job_form" style="width: 100%; max-width: 875px; min-width: 405px">
					<tbody>
						<tr>
							<th style="width: 30%;">Sélectionner un template de mail</th>
							<td>
								<select id="select_mail_template">
									<option></option>
									<?php foreach ($templates as $template): ?>
										<option value="<?php echo $template->getIdMail(); ?>"><?php echo $template->getLibelle(); ?></option>
									<?php endforeach; ?>
								</select>
							</td>
						</tr>
						<tr>
							<th>Votre réponse</th>
							<td><?php echo $form['message']->render(array('rows' => 20, 'style' => 'width: 100%')) ?></td>
						</tr>
						<tr>
							<th>Envoyer une ou plusieurs images</th>
							<td>
								<?php echo $form['image_1']->renderError(); ?>
								<?php echo $form['image_1']->render(); ?>
								<?php echo $form['image_2']->renderError(); ?>
								<?php echo $form['image_2']->render(); ?>
								<?php echo $form['image_3']->renderError(); ?>
								<?php echo $form['image_3']->render(); ?>
								<?php echo $form['image_4']->renderError(); ?>
								<?php echo $form['image_4']->render(); ?>
								<?php echo $form['image_5']->renderError(); ?>
								<?php echo $form['image_5']->render(); ?>
							</td>
						</tr>
						<tr>
							<th>Envoyer un ou plusieurs PDF</th>
							<td>
								<?php echo $form['pdf_1']->renderError(); ?>
								<?php echo $form['pdf_1']->render(); ?>
								<?php echo $form['pdf_2']->renderError(); ?>
								<?php echo $form['pdf_2']->render(); ?>
								<?php echo $form['pdf_3']->renderError(); ?>
								<?php echo $form['pdf_3']->render(); ?>
								<?php echo $form['pdf_4']->renderError(); ?>
								<?php echo $form['pdf_4']->render(); ?>
								<?php echo $form['pdf_5']->renderError(); ?>
								<?php echo $form['pdf_5']->render(); ?>
							</td>
						</tr>
					</tbody>
					<tfoot>
						<tr>
							<td colspan="4">
								<input type="submit" value="Envoyer la réponse" />
							</td>
						</tr>
					</tfoot>
				</table>
				<?php echo $form->renderHiddenFields(); ?>
			</form>
			<h3>Autres actions</h3>
			<form action="" method="post">
				<input type="hidden" name="id_mail_sujet" value="<?php echo $sujet->getId(); ?>">
				<input type="submit" name="submit_close_resolved" value="Clôturer la demande avec succès" />
				<input type="submit" name="submit_close_not_resolved" value="Clôturer la demande sans solution" />
				<button><a href="<?php echo url_for("@commande_new?id_mail_sujet=".$sujet->getId()); ?>">Etablir un bon de commande</a></button>
			</form>
		</div>
	</div>
</div>
<script>
	$(document).ready(function() {
		var mails = new Array();
		<?php foreach ($templates as $template): ?>
			mails[<?php echo $template->getIdMail(); ?>] = '<?php echo html_entity_decode(addslashes(str_replace(array("\n", "\r"), "", $template->getMail()))); ?>';
		<?php endforeach; ?>
			
		$('#select_mail_template').change(function() {
			tinyMCE.execCommand('mceSetContent', false, mails[$(this).val()]);
		});
	});
</script>