<?php

require_once dirname(__FILE__).'/../lib/mailingproGeneratorConfiguration.class.php';
require_once dirname(__FILE__).'/../lib/mailingproGeneratorHelper.class.php';

/**
 * mailingpro actions.
 *
 * @package    sf_sandbox
 * @subpackage mailingpro
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class mailingproActions extends autoMailingproActions
{
	public function executeIndex(sfWebRequest $request)
	{
		// sorting
		if ($request->getParameter('sort') && $this->isValidSortColumn($request->getParameter('sort')))
		{
			$this->setSort(array($request->getParameter('sort'), $request->getParameter('sort_type')));
		}

		// pager
		if ($request->getParameter('page'))
		{
			$this->setPage($request->getParameter('page'));
		}

		$this->pager = $this->getPager();
		$this->sort = $this->getSort();

		// Formulaire article import
		$this->form = new MailingProImportForm();
	}

	public function executeEdit(sfWebRequest $request)
	{
		$this->mailing_pro = $this->getRoute()->getObject();
		
		$this->visites_pro = Doctrine_Core::getTable("VisitePro")->findByIdMailingPro($this->mailing_pro->getPrimaryKey());
		
		$this->form = $this->configuration->getForm($this->mailing_pro);
	}

	public function executeImport(sfWebRequest $request)
	{
		if($request->isMethod("POST"))
		{
			$form = new MailingProImportForm();
			$form->bind($request->getParameter('mailing_pro_import'), $request->getFiles('mailing_pro_import'));
			if($form->isValid())
			{
				$file = $form->getValue('file');

				$filename = 'uploaded_'.sha1($file->getOriginalName());
				$extension = $file->getExtension($file->getOriginalExtension());
				$file->save(sfConfig::get('sf_upload_dir').'/'.$filename.$extension);

				//Récupère les données
				$fichier = sfConfig::get('sf_upload_dir').'/'.$filename.$extension;

				$connection = Doctrine_Manager::connection();
				$connection->beginTransaction();

				try
				{
					try
					{
						if (($handle = fopen($fichier, "r")) !== FALSE)
						{
							while (($data = fgetcsv($handle, 0, ";")) !== FALSE)
							{
								$objet = Doctrine_Core::getTable("MailingPro")->find($data[26]);

								if(!($objet instanceof MailingPro))
								{
									$objet = new MailingPro();
								}
								$objet->civilite = utf8_encode($data[0]);
								$objet->nom = utf8_encode($data[1]);
								$objet->adresse = utf8_encode($data[2]);
								$objet->code_postal = utf8_encode($data[3]);
								$objet->ville = utf8_encode($data[4]);
								$objet->telephone = utf8_encode($data[5]);
								$objet->fax = utf8_encode($data[6]);
								$objet->gsm = utf8_encode($data[7]);
								$objet->activite = utf8_encode($data[8]);
								$objet->code_acces = utf8_encode($data[9]);
								$objet->date = Utils::dateFrToEn($data[10]);
								$objet->save();
							}
							fclose($handle);
						}
						$connection->commit();
					}
					catch(Exception $e)
					{
						$connection->rollback();
						throw new Exception($e->getMessage());
					}

					$this->getUser()->setFlash('notice', 'L\'importation s\'est déroulé avec succès');
				}
				catch(Exception $e)
				{
					unlink(sfConfig::get('sf_upload_dir').'/'.$filename.$extension);
					$this->getUser()->setFlash('error', $e->getMessage());
					$this->redirect("@mailing_pro");
				}
			}
			else
			{
				$this->getUser()->setFlash('error', 'Erreur lors de l\'importation');
			}
		}
		unlink(sfConfig::get('sf_upload_dir').'/'.$filename.$extension);
		$this->redirect("@mailing_pro");
	}
}
