<div class="sf_admin_list">
  <?php if (!$pager->getNbResults()): ?>
    <p><?php echo __('No result', array(), 'sf_admin') ?></p>
  <?php else: ?>
    <table cellspacing="0">
      <thead>
        <tr>
          <th id="sf_admin_list_batch_actions"><input id="sf_admin_list_batch_checkbox" type="checkbox" onclick="checkAll();" /></th>
          <?php include_partial('nettoyeurhautepression/list_th_tabular', array('sort' => $sort)) ?>
          <th id="sf_admin_list_th_actions"><?php echo __('Actions', array(), 'sf_admin') ?></th>
        </tr>
      </thead>
      <tfoot>
        <tr>
          <th colspan="12">
            <?php if ($pager->haveToPaginate()): ?>
              <?php include_partial('nettoyeurhautepression/pagination', array('pager' => $pager)) ?>
            <?php endif; ?>

            <?php echo format_number_choice('[0] no result|[1] 1 result|(1,+Inf] %1% results', array('%1%' => $pager->getNbResults()), $pager->getNbResults(), 'sf_admin') ?>
            <?php if ($pager->haveToPaginate()): ?>
              <?php echo __('(page %%page%%/%%nb_pages%%)', array('%%page%%' => $pager->getPage(), '%%nb_pages%%' => $pager->getLastPage()), 'sf_admin') ?>
            <?php endif; ?>
          </th>
        </tr>
      </tfoot>
      <tbody>
        <?php foreach ($pager->getResults() as $i => $nettoyeur_haute_pression): $odd = fmod(++$i, 2) ? 'odd' : 'even' ?>
          <tr class="sf_admin_row <?php echo $odd ?>">
           <td>
			  <input type="checkbox" name="ids[]" value="<?php echo $nettoyeur_haute_pression->getPrimaryKey() ?>" class="sf_admin_batch_checkbox" />
			</td>
            <td class="sf_admin_text sf_admin_list_td_id_nettoyeur">
			  <?php echo $nettoyeur_haute_pression->getPrimaryKey() ?>
			</td>
            <td class="sf_admin_text sf_admin_list_td_modele">
			  <?php echo link_to( $nettoyeur_haute_pression->getModele(), 'nettoyeur_haute_pression_edit', $nettoyeur_haute_pression) ?>
			</td>
			<td class="sf_admin_foreignkey sf_admin_list_td_id_marque">
			  <?php if($nettoyeur_haute_pression->id_marque != ""):?><?php echo $nettoyeur_haute_pression->getMarque()->getLibelle() ?><?php endif?>
			</td>
			<td class="sf_admin_text sf_admin_list_td_prix_vente_ht">
			  <?php echo Utils::doubleEnToFr($nettoyeur_haute_pression->getPrixVenteHt()) ?>
			</td>
			<td class="sf_admin_text sf_admin_list_td_prix_vente_ths">
			  <?php echo Utils::doubleEnToFr($nettoyeur_haute_pression->getPrixVenteThs()) ?>
			</td>
			<td class="sf_admin_text sf_admin_list_td_url_article">
			  <a href="<?php echo $nettoyeur_haute_pression->getUrlArticle() ?>" target="_blank"><?php echo $nettoyeur_haute_pression->getUrlArticle() ?></a>
			</td>
			<td class="sf_admin_boolean sf_admin_list_td_actif">
				<?php if ($nettoyeur_haute_pression->getActif()): ?>
				  <?php echo image_tag(sfConfig::get('sf_admin_module_web_dir').'/images/tick.png', array('alt' => __('Checked', array(), 'sf_admin'), 'title' => __('Checked', array(), 'sf_admin'))) ?>
				<?php else: ?>
				  &nbsp;
				<?php endif; ?>
			</td>
			<td class="sf_admin_boolean sf_admin_list_td_disponible_vente">
			  <?php if ($nettoyeur_haute_pression->getDisponibleVente()): ?>
				  <?php echo image_tag(sfConfig::get('sf_admin_module_web_dir').'/images/tick.png', array('alt' => __('Checked', array(), 'sf_admin'), 'title' => __('Checked', array(), 'sf_admin'))) ?>
				<?php else: ?>
				  &nbsp;
				<?php endif; ?>
			</td>
			<td class="sf_admin_boolean sf_admin_list_td_visible_moteur_recherche">
			  <?php if ($nettoyeur_haute_pression->getVisibleMoteurRecherche()): ?>
				  <?php echo image_tag(sfConfig::get('sf_admin_module_web_dir').'/images/tick.png', array('alt' => __('Checked', array(), 'sf_admin'), 'title' => __('Checked', array(), 'sf_admin'))) ?>
				<?php else: ?>
				  &nbsp;
				<?php endif; ?>
			</td>
			<td class="sf_admin_boolean sf_admin_list_td_afficher_prix">
			  <?php if ($nettoyeur_haute_pression->getAfficherPrix()): ?>
				  <?php echo image_tag(sfConfig::get('sf_admin_module_web_dir').'/images/tick.png', array('alt' => __('Checked', array(), 'sf_admin'), 'title' => __('Checked', array(), 'sf_admin'))) ?>
				<?php else: ?>
				  &nbsp;
				<?php endif; ?>
			</td>
			<td class="sf_admin_boolean sf_admin_list_td_plus_fabriquer">
			  <?php if ($nettoyeur_haute_pression->getPlusFabriquer()): ?>
				  <?php echo image_tag(sfConfig::get('sf_admin_module_web_dir').'/images/tick.png', array('alt' => __('Checked', array(), 'sf_admin'), 'title' => __('Checked', array(), 'sf_admin'))) ?>
				<?php else: ?>
				  &nbsp;
				<?php endif; ?>
			</td>
            <td>
		      <ul class="sf_admin_td_actions">
		        <?php echo $helper->linkToEdit($nettoyeur_haute_pression, array(  'params' =>   array(  ),  'class_suffix' => 'edit',  'label' => 'Edit',)) ?>
		        <?php echo $helper->linkToDelete($nettoyeur_haute_pression, array(  'params' =>   array(  ),  'confirm' => 'Are you sure?',  'class_suffix' => 'delete',  'label' => 'Delete',)) ?>
		      </ul>
		    </td>
          </tr>
        <?php endforeach; ?>
      </tbody>
    </table>
  <?php endif; ?>
</div>
<script type="text/javascript">
/* <![CDATA[ */
function checkAll()
{
  var boxes = document.getElementsByTagName('input'); for(var index = 0; index < boxes.length; index++) { box = boxes[index]; if (box.type == 'checkbox' && box.className == 'sf_admin_batch_checkbox') box.checked = document.getElementById('sf_admin_list_batch_checkbox').checked } return true;
}
/* ]]> */
</script>
