<?php

require_once dirname(__FILE__).'/../lib/pompeGeneratorConfiguration.class.php';
require_once dirname(__FILE__).'/../lib/pompeGeneratorHelper.class.php';

/**
 * pompe actions.
 *
 * @package    sf_sandbox
 * @subpackage pompe
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class pompeActions extends autoPompeActions
{
	public function executeEdit(sfWebRequest $request)
	{
		$this->pompe = $this->getRoute()->getObject();

		$this->pompe->setPoids(Utils::doubleEnToFr($this->pompe->getPoids()));

		$this->form = $this->configuration->getForm($this->pompe);
	}

	public function executeDelete(sfWebRequest $request)
	{
		$request->checkCSRFProtection();

		$this->dispatcher->notify(new sfEvent($this, 'admin.delete_object', array('object' => $this->getRoute()->getObject())));

		$filename = Utils::slugify(trim($this->getRoute()->getObject()->getMarque()->getLibelle())).'_'.Utils::slugify(trim($this->getRoute()->getObject()->getModele()));
		$filename = str_replace("-", "_", $filename);

		if ($this->getRoute()->getObject()->delete())
		{
			// Suppression des photos, vidéo et pdf
			unlink(sfConfig::get("pompe_image_dir").DIRECTORY_SEPARATOR.$filename.'.jpg');
			unlink(sfConfig::get("pompe_miniature_dir").DIRECTORY_SEPARATOR.$filename.'.jpg');

			unlink(sfConfig::get("pompe_pdf_doc_commercial_dir").DIRECTORY_SEPARATOR.$filename.'.pdf');
			unlink(sfConfig::get("pompe_pdf_doc_technique_dir").DIRECTORY_SEPARATOR.$filename.'.pdf');
			unlink(sfConfig::get("pompe_pdf_eclate_technique_dir").DIRECTORY_SEPARATOR.$filename.'.pdf');

			$this->getUser()->setFlash('notice', 'The item was deleted successfully.');
		}

		$this->redirect('@pompe');
	}

	protected function processForm(sfWebRequest $request, sfForm $form)
	{
		$values = $request->getParameter($form->getName());
		$values["poids"] = Utils::doubleFrToEn($values["poids"]);

		$form->bind($values, $request->getFiles($form->getName()));
		if ($form->isValid())
		{
			$notice = $form->getObject()->isNew() ? 'The item was created successfully.' : 'The item was updated successfully.';
			
			$modele = str_replace(" ", "_",trim($this->form->getValue('modele')));
			$marque = Doctrine::getTable("Marque")->find($this->form->getValue('id_marque'));
			$marque_libelle = trim($marque->getLibelle());

			// Mise à jour de du champs url_article et balise_title
			$values["url_article"] = "http://www.haute-pression.com/pompe-haute-pression/".Utils::slugify($marque_libelle)."/".Utils::slugify($values["modele"]).".html";
			//$values["balise_title"] = "Pompe ".$marque_libelle." ".$values["modele"]." ".$values["serie"]." - Pompe haute pression";

			$filename_photo_1 = "";
			$filename_doc_commercial = "";
			$filename_doc_technique = "";
			$filename_eclate_technique = "";
			
			$pompe = new Pompe();
			if($this->form->getValue('id_pompe') != "")
			{
				$pompe = Doctrine::getTable("Pompe")->find($this->form->getValue('id_pompe'));

				// Si changement de nom
				if($pompe->getIdMarque() != $form->getValue('id_marque') || $pompe->getModele() != $form->getValue('modele'))
				{
					$filename = str_replace("-", "_", Utils::slugify($marque_libelle)).'_'.str_replace("-", "_", Utils::slugify($form->getValue('modele')));
					$filename = strtolower($filename);
				
					// renommer les fichiers
					if($pompe->getPhoto_1() != "")
					{
						$extension = explode(".", $pompe->getPhoto_1());
						rename(sfConfig::get("pompe_image_dir").DIRECTORY_SEPARATOR.$pompe->getPhoto_1(), sfConfig::get("pompe_image_dir").DIRECTORY_SEPARATOR.$filename.".".$extension[sizeof($extension)-1]);
						$filename_photo_1 = $filename.".".$extension[sizeof($extension)-1];
						
						rename(sfConfig::get("pompe_miniature_dir").DIRECTORY_SEPARATOR.$pompe->getPhoto_1(), sfConfig::get("pompe_miniature_dir").DIRECTORY_SEPARATOR.$filename.".".$extension[sizeof($extension)-1]);
					}
					
					if($pompe->getDocCommercial() != "")
					{
						rename(sfConfig::get("pompe_pdf_doc_commercial_dir").DIRECTORY_SEPARATOR.$pompe->getDocCommercial(), sfConfig::get("pompe_pdf_doc_commercial_dir").DIRECTORY_SEPARATOR.$filename.".pdf");
						$filename_doc_commercial = $filename.".pdf";
					}
					
					if($pompe->getDocTechnique() != "")
					{
						rename(sfConfig::get("pompe_pdf_doc_technique_dir").DIRECTORY_SEPARATOR.$pompe->getDocTechnique(), sfConfig::get("pompe_pdf_doc_technique_dir").DIRECTORY_SEPARATOR.$filename.".pdf");
						$filename_doc_technique = $filename.".pdf";
					}
					
					if($pompe->getEclateTechnique() != "")
					{
						rename(sfConfig::get("pompe_pdf_eclate_technique_dir").DIRECTORY_SEPARATOR.$pompe->getEclateTechnique(), sfConfig::get("pompe_pdf_eclate_technique_dir").DIRECTORY_SEPARATOR.$filename.".pdf");
						$filename_eclate_technique = $filename.".pdf";
					}
				}
			}
			if($values["id_pompe"] != "")
			{
				// On récupère l'ancien objet pour avoir les noms des fichiers à supprimer
				$nhp_old = Doctrine::getTable("Pompe")->find($values["id_pompe"]);

				// Suppression des photos si cases cochées
				if($form->getValue('photo_1_supprimer'))
				{
					unlink(sfConfig::get("pompe_image_dir").DIRECTORY_SEPARATOR.$nhp_old->getPhoto_1());
					unlink(sfConfig::get("pompe_miniature_dir").DIRECTORY_SEPARATOR.$nhp_old->getPhoto_1());
					$pompe->setPhoto_1("");
				}

				if($form->getValue('doc_commercial_supprimer'))
				{
					unlink(sfConfig::get("pompe_pdf_doc_commercial_dir").DIRECTORY_SEPARATOR.$nhp_old->getDocCommercial());
					$pompe->setDocCommercial("");
				}

				if($form->getValue('doc_technique_supprimer'))
				{
					unlink(sfConfig::get("pompe_pdf_doc_technique_dir").DIRECTORY_SEPARATOR.$nhp_old->getDocTechnique());
					$pompe->setDocTechnique("");
				}

				if($form->getValue('eclate_technique_supprimer'))
				{
					unlink(sfConfig::get("pompe_pdf_eclate_technique_dir").DIRECTORY_SEPARATOR.$nhp_old->getEclateTechnique());
					$pompe->setEclateTechnique("");
				}
			}
				
			// Enregistrement des images, vidéo et pdf
			if(!is_null($form->getValue('photo_1')))
			{
				$file = $form->getValue('photo_1');
				$filename = str_replace("-", "_", Utils::slugify($marque_libelle)).'_'.str_replace("-", "_", Utils::slugify($modele));
				$filename = strtolower($filename);
				$extension = $file->getExtension($file->getOriginalExtension());
				$file->save(sfConfig::get('pompe_image_dir').DIRECTORY_SEPARATOR.$filename.$extension);

				// Création de la miniature
				$thumbnail = new sfThumbnail(380, 400, true, true, 100);
				$thumbnail->loadFile(sfConfig::get('pompe_image_dir').DIRECTORY_SEPARATOR.$filename.$extension);
				$thumbnail->save(sfConfig::get('pompe_miniature_dir').DIRECTORY_SEPARATOR.$filename.$extension);
				$filename_photo_1 = $filename.$extension;
			}
			
			if(!is_null($form->getValue('doc_commercial')))
			{
				$file = $form->getValue('doc_commercial');
				$filename = str_replace("-", "_", Utils::slugify($marque_libelle)).'_'.str_replace("-", "_", Utils::slugify($modele));
				$filename = strtolower($filename);
				$extension = $file->getExtension($file->getOriginalExtension());
				$file->save(sfConfig::get('pompe_pdf_doc_commercial_dir').DIRECTORY_SEPARATOR.$filename.$extension);
				$filename_doc_commercial = $filename.$extension;
			}
			
			if(!is_null($form->getValue('doc_technique')))
			{
				$file = $form->getValue('doc_technique');
				$filename = str_replace("-", "_", Utils::slugify($marque_libelle)).'_'.str_replace("-", "_", Utils::slugify($modele));
				$filename = strtolower($filename);
				$extension = $file->getExtension($file->getOriginalExtension());
				$file->save(sfConfig::get('pompe_pdf_doc_technique_dir').DIRECTORY_SEPARATOR.$filename.$extension);
				$filename_doc_technique = $filename.$extension;
			}

			if(!is_null($form->getValue('eclate_technique')))
			{
				$file = $form->getValue('eclate_technique');
				$filename = str_replace("-", "_", Utils::slugify($marque_libelle)).'_'.str_replace("-", "_", Utils::slugify($modele));
				$filename = strtolower($filename);
				$extension = $file->getExtension($file->getOriginalExtension());
				$file->save(sfConfig::get('pompe_pdf_eclate_technique_dir').DIRECTORY_SEPARATOR.$filename.$extension);
				$filename_eclate_technique = $filename.$extension;
			}

			try
			{
				$pompe->setIdPompe($form->getValue('id_pompe'));
				$pompe->setidMarque($form->getValue('id_marque'));
				$pompe->setModele($form->getValue('modele'));
				$pompe->setSerie($form->getValue('serie'));
				$pompe->setPression($form->getValue('pression'));
				$pompe->setDebitLitreMin($form->getValue('debit_litre_min'));
				$pompe->setDebitLitreHeure($form->getValue('debit_litre_heure'));
				$pompe->setVitesseRotation($form->getValue('vitesse_rotation'));
				$pompe->setPuissance($form->getValue('puissance'));
				$pompe->setPoids($form->getValue('poids'));
				$pompe->setDescription($form->getValue('description'));
				$pompe->setUrlArticle($values["url_article"]);
				$pompe->setBaliseTitle($values["balise_title"]);
				$pompe->setBaliseMeta($form->getValue('balise_meta'));

				if(!is_null($form->getValue('photo_1')) || $filename_photo_1 != "")
				{
					$pompe->setPhoto_1($filename_photo_1);
				}

				if(!is_null($form->getValue('doc_commercial')) || $filename_doc_commercial != "")
				{
					$pompe->setDocCommercial($filename_doc_commercial);
				}

				if(!is_null($form->getValue('doc_technique')) || $filename_doc_technique != "")
				{
					$pompe->setDocTechnique($filename_doc_technique);
				}

				if(!is_null($form->getValue('eclate_technique')) || $filename_eclate_technique != "")
				{
					$pompe->setEclateTechnique($filename_eclate_technique);
				}
				$pompe->setDocTechniqueEspacePro($form->getValue('doc_technique_espace_pro'));
				$pompe->setEclateTechniqueEspacePro($form->getValue('eclate_technique_espace_pro'));
				$pompe->setActif($form->getValue('actif'));
				$pompe->save();
			}
			catch (Doctrine_Validator_Exception $e)
			{

				$errorStack = $form->getObject()->getErrorStack();

				$message = get_class($form->getObject()) . ' has ' . count($errorStack) . " field" . (count($errorStack) > 1 ?  's' : null) . " with validation errors: ";
				foreach ($errorStack as $field => $errors)
				{
					$message .= "$field (" . implode(", ", $errors) . "), ";
				}
				$message = trim($message, ', ');

				$this->getUser()->setFlash('error', $message);
				return sfView::SUCCESS;
			}

			$this->dispatcher->notify(new sfEvent($this, 'admin.save_object', array('object' => $pompe)));

			if ($request->hasParameter('_save_and_add'))
			{
				$this->getUser()->setFlash('notice', $notice.' You can add another one below.');

				$this->redirect('@pompe_new');
			}
			else
			{
				$this->getUser()->setFlash('notice', $notice);

				$this->redirect(array('sf_route' => 'pompe_edit', 'sf_subject' => $pompe));
			}
		}
		else
		{
			$this->getUser()->setFlash('error', 'The item has not been saved due to some errors.', false);
		}
	}
}
