<?php

require_once dirname(__FILE__).'/../lib/tauxtvaGeneratorConfiguration.class.php';
require_once dirname(__FILE__).'/../lib/tauxtvaGeneratorHelper.class.php';

/**
 * tauxtva actions.
 *
 * @package    sf_sandbox
 * @subpackage tauxtva
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class tauxtvaActions extends autoTauxtvaActions
{

	public function executeEdit(sfWebRequest $request)
	{
		$this->taux_tva = $this->getRoute()->getObject();
		$this->taux_tva->setTaux(Utils::doubleEnToFr($this->taux_tva->getTaux()));
		$this->form = $this->configuration->getForm($this->taux_tva);
	}


	protected function processForm(sfWebRequest $request, sfForm $form)
	{
		$values = $request->getParameter($form->getName());
		$values['taux'] = Utils::doubleFrToEn($values['taux']);
			
		$form->bind($values, $request->getFiles($form->getName()));
		if ($form->isValid())
		{
			$notice = $form->getObject()->isNew() ? 'The item was created successfully.' : 'The item was updated successfully.';

			try
			{
				$taux_tva = $form->save();
			}
			catch (Doctrine_Validator_Exception $e)
			{

				$errorStack = $form->getObject()->getErrorStack();

				$message = get_class($form->getObject()) . ' has ' . count($errorStack) . " field" . (count($errorStack) > 1 ?  's' : null) . " with validation errors: ";
				foreach ($errorStack as $field => $errors)
				{
					$message .= "$field (" . implode(", ", $errors) . "), ";
				}
				$message = trim($message, ', ');

				$this->getUser()->setFlash('error', $message);
				return sfView::SUCCESS;
			}

			$this->dispatcher->notify(new sfEvent($this, 'admin.save_object', array('object' => $taux_tva)));

			if ($request->hasParameter('_save_and_add'))
			{
				$this->getUser()->setFlash('notice', $notice.' You can add another one below.');

				$this->redirect('@taux_tva_new');
			}
			else
			{
				$this->getUser()->setFlash('notice', $notice);

				$this->redirect(array('sf_route' => 'taux_tva_edit', 'sf_subject' => $taux_tva));
			}
		}
		else
		{
			$this->getUser()->setFlash('error', 'The item has not been saved due to some errors.', false);
		}
	}
}
