<?php

/**
 * article actions.
 *
 * @package    sf_sandbox
 * @subpackage article
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class articleActions extends sfActions
{
    public function executeCatalogue(sfWebRequest $request)
    {
	$this->tva = Doctrine_Core::getTable("TauxTVA")->find(sfConfig::get('app_tva_196'));
    }
    
	/**
	 * Executes index action
	 *
	 * @param sfRequest $request A request object
	 */
	public function executeIndex(sfWebRequest $request)
	{
		if($request->hasParameter("id_article"))
		{
			$this->article = Doctrine::getTable("Article")->find($request->getParameter("id_article"));
		}
		else if($request->hasParameter("famille") && $request->hasParameter("reference_ths"))
		{
			$this->article = ArticleTable::getArticleByFamilleReferenceTHSFromUrl($request->getParameter("famille"), $request->getParameter("reference_ths"));
		}
		
		$this->forward404If(!($this->article instanceof Article));
		
		$filAriane = ' > <a href="'.$this->article->getUrlArticle().'">'.$this->article->getBaliseTitle().'</a>';
		$this->getUser()->setFlash("filAriane", $filAriane);
		$this->getResponse()->addMeta('title', $this->article->getBaliseTitle());
		$this->getResponse()->addMeta('description', $this->article->getBaliseMeta());
		
		$this->nettoyeurs = NettoyeurHautePressionTable::getListByArticle($this->article->getReferenceThsSage());
		
		
		// Panier
		$nombre_articles = 0;
		if($this->getUser()->hasAttribute('commande_articles'))
		{
			$panier = $this->getUser()->getAttribute('commande_articles');
			$nombre_articles = sizeof($panier['article']) + sizeof($panier['nettoyeur']);
			
			$annule_minimum_commande = false;
			
			if(sizeof($panier['article']) > 0)
			{
				foreach ($panier['article'] as $article) 
				{
					$_article = Doctrine::getTable("Article")->find($article->getIdArticle());
					if($_article->getMinimumCommande())
					{
						$annule_minimum_commande = true;
						break;
					}
				}
			}
			
			$commande = $this->getUser()->getAttribute("commande");
			if($commande->getMailCommande() == 0 && !$annule_minimum_commande)
			{
				$this->minimumCommande = ConfigTable::getMinimumCommande();
			}
			else
			{
				$this->minimumCommande = 0;
			}
			
			$this->getUser()->setFlash("minimumCommande", $this->minimumCommande);
		}
		if($nombre_articles > 0)
		{
			$panier = $this->getUser()->getAttribute('commande_articles');

			// DonnÃ©es concernant frais de ports
			$francoDePort = 0;
			$horsGabarit = 0;
			$totalPoids = 0;

			$totalProduitsHTTemp = 0;
			$totalProduitsHT = 0;
			$totalProduitsTTC = 0;
			$totalHT = 0;
			$totalTVA = 0;
			$totalTTC = 0;
			$tva = Doctrine_Core::getTable("TauxTVA")->find(sfConfig::get('app_tva_196'));
				
			$nombre_total_articles = 0;

			foreach ($panier['article'] as $key => $commandeArticle)
			{
				$article = Doctrine::getTable("Article")->find($key);
				$totalProduitsHTTemp += $article->getPrixVenteThs() * $commandeArticle->getQuantite();
				$totalProduitsHT += $article->getPrixVenteThs() * $commandeArticle->getQuantite();
				$totalPoids += Utils::doubleFrToEn($article->getPoids()) * $commandeArticle->getQuantite();
				$totalTVA += $article->getPrixVenteThs() * $commandeArticle->getQuantite() * $tva->getTaux() / 100;
					
				if($article->getHorsGabarit())
				{
					$horsGabarit = 1;
				}
					
				$nombre_total_articles += $commandeArticle->getQuantite();
			}

			$totalProduitsTTC += $totalProduitsHTTemp * (1 + $tva->getTaux() / 100);
			$totalProduitsHTTemp = 0;
			$total_article = $totalProduitsTTC;

			foreach ($panier['nettoyeur'] as $key => $commandeArticle)
			{
				$nettoyeur = Doctrine::getTable("NettoyeurHautePression")->find($key);
				$totalProduitsHTTemp += $nettoyeur->getPrixVenteThs() * $commandeArticle->getQuantite();
				$totalProduitsHT += $nettoyeur->getPrixVenteThs() * $commandeArticle->getQuantite();
				$totalPoids += Utils::doubleFrToEn($nettoyeur->getPoids()) * $commandeArticle->getQuantite();
				$totalTVA += $nettoyeur->getPrixVenteThs() * $commandeArticle->getQuantite() * $tva->getTaux() / 100;
					
				if($nettoyeur->getFrancoDePort())
				{
					$francoDePort = 1;
				}
				$nombre_total_articles += $commandeArticle->getQuantite();
			}
			$totalProduitsTTC += $totalProduitsHTTemp * (1 + $tva->getTaux() / 100);

			// Arrondi
			$totalProduitsTTC = round($totalProduitsTTC, 2);
			$totalTVA = round($totalTVA, 2);

			$totalHT = $totalProduitsHT;
			$totalTTC = $totalProduitsTTC;
			
			$this->nombre_articles = $nombre_articles;
			$this->getUser()->setFlash("nombre_articles", $this->nombre_articles);
			$this->nombre_total_articles = $nombre_total_articles;
			$this->getUser()->setFlash("nombre_total_articles", $this->nombre_total_articles);
			$this->totalProduitsHT = $totalProduitsHT;
			$this->getUser()->setFlash("totalProduitsHT", $this->totalProduitsHT);
			$this->totalHT = $totalHT;
			$this->getUser()->setFlash("totalHT", $this->totalHT);
			$this->totalTVA = $totalTVA;
			$this->getUser()->setFlash("totalTVA", $this->totalTVA);
			$this->totalTTC = $totalTTC;
			$this->getUser()->setFlash("totalTTC", $this->totalTTC);
		}
	}
}