<?php 
    use_helper("Number");
    $panier = $sf_user->getAttribute('commande_articles');
?>
<div id="nettoyeur">
    <div id="vente-pieces-detachees">
	<p><strong>
		Merci de saisir la référence de votre article dans le champ de saisie « référence » pour consulter un prix ou passer commande.<br><br>
		Si vous désirez commander plusieurs articles, cliquez sur "<span class="text-red">+ Ajouter un article</span>", puis et saisissez la référence de l'article suivant dans le nouveau champ de saisie « référence ».<br><br>
		Une fois toutes vos références saisies, cliquez sur "<span class="text-green">Valider votre commande</span>" pour finaliser le processus de commande.<br><br>
		Merci de ne pas saisir les caractères spéciaux tels que « . », « , », « - », « / ».
	</strong></p>
	<form id="form-vente-pieces-detachees" action="<?php echo url_for("@ajouter_recuperer_article_nhp"); ?>" method="post">
	    <div id="panier">
		<table id="calculPanier">
			<tr class="entete">
				<td class="reference">Référence</td>
				<td class="effacer">Supprimer</td>
				<td class="designation">Désignation</td>
				<td class="prixUnitHT">Prix<br />Unit. HT</td>
				<td class="quantite">Quantité</td>
				<td class="prixTotalHT">Prix<br />Total HT</td>
				<td class="prixTotalTTC">Prix<br />Total TTC</td>
			</tr>
			<?php foreach ($panier['article'] as $key => $commandeArticle):?>
				<?php $article = Doctrine::getTable("Article")->find($key)?>
				<tr class="lignePanier">
					<td><?php echo $article->getReferenceThsAffichage()?></td>
					<td><?php echo link_to("Supprimer", "@panier_supprimer_article?id_article=".$article->getReferenceThs())?></td>
					<td><?php echo $article->getDesignationCourte()?></td>
					<td class="affichageChiffre"><?php echo format_currency($article->getPrixVenteHt())?>€</td>
					<td class="affichageQte">
						<select name="articleQte[<?php echo $key?>]" onchange="this.form.submit()">
							<?php for($i = 1; $i <= 20; $i++):?>
								<option value="<?php echo $i?>" <?php if($i == $commandeArticle->getQuantite()):?>selected="selected"<?php endif;?>><?php echo $i?></option>
							<?php endfor;?>
						</select>
					</td>
					<td class="affichageChiffre"><?php echo format_currency($article->getPrixVenteThs() * $commandeArticle->getQuantite())?>€</td>
					<td class="affichageChiffre"><?php echo format_currency(Utils::prixAvecTVA($article->getPrixVenteThs() * $commandeArticle->getQuantite(), $tva->getTaux()))?>€</td>
				</tr>
			<?php endforeach;?>
			<?php foreach ($panier['nettoyeur'] as $key => $commandeArticle):?>
				<?php $nettoyeur = Doctrine::getTable("NettoyeurHautePression")->find($key)?>
				<tr class="lignePanier">
					<td><?php echo $nettoyeur->getReferenceThs()?></td>
					<td><?php echo link_to("Effacer", "@panier_supprimer_nettoyeur?id_nettoyeur=".$nettoyeur->getIdNettoyeur())?></td>
					<td>Nettoyeur <?php echo $nettoyeur->getMarque()->getLibelle()?> <?php echo $nettoyeur->getModele()?></td>
					<td><?php echo link_to("Voir", "@url_nettoyeur?marque=".Utils::stringForUrl($nettoyeur->getMarque()->getLibelle())."&modele=".Utils::stringForUrl($nettoyeur->getModele()), array("target" => "_blank"))?></td>
					<td class="affichageChiffre"><?php echo format_currency($nettoyeur->getPrixVenteHt())?>€</td>
					<td class="affichageQte">
						<select name="nettoyeurQte[<?php echo $key?>]" onchange="this.form.submit()">
							<?php for($i = 1; $i <= 20; $i++):?>
								<option value="<?php echo $i?>" <?php if($i == $commandeArticle->getQuantite()):?>selected="selected"<?php endif;?>><?php echo $i?></option>
							<?php endfor;?>
						</select>
					</td>
					<td class="affichageChiffre"><?php echo format_currency($nettoyeur->getPrixVenteThs() * $commandeArticle->getQuantite())?>€</td>
					<td class="affichageChiffre"><?php echo format_currency(Utils::prixAvecTVA($nettoyeur->getPrixVenteThs() * $commandeArticle->getQuantite(), $tva->getTaux()))?>€</td>
				</tr>
			<?php endforeach;?>
		</table>
		<div class="calcul_panier_actions">
		    <p class="ajout_article">+ Ajouter un article</p>
		    <input id="form-vente-pieces-detachees-submit" type="submit" value="Valider votre commande" class="btn-panier-action">
		</div>
	    </div>
	</form>
    </div>
</div>
<script src="https://code.jquery.com/ui/1.11.4/jquery-ui.min.js" integrity="sha256-xNjb53/rY+WmG+4L6tTl9m6PpqknWZvRt0rO1SRnJzw="   crossorigin="anonymous"></script>
<script>
	function supprimerLigne(id) {
		$('#ligne_article_' + id).remove();
	}
	
	function modifierQuantite(id) {
		qte = document.getElementById('qte_'+id).value;
		pu_ht = document.getElementById('prix_unitaire_ht_'+id).value;
		pu_ttc = document.getElementById('prix_unitaire_ttc_'+id).value;
		document.getElementById('prix_total_ht_'+id).innerHTML = (Math.round(pu_ht*qte*100)/100).toString().replace('.', ',');
		document.getElementById('prix_total_ttc_'+id).innerHTML = (Math.round(pu_ttc*qte*100)/100).toString().replace('.', ',');
	}

	function recupererArticle(id, value){
		if (value == null) {
		    value = document.getElementById('ref_ths_'+id).value;
		}
		$.ajax({
			type: "POST",
			url: '<?php echo url_for("@recuperer_article_nhp") ?>',
			data: { reference_ths_sage: value},
			dataType: 'json',
			//Fonction executée quand la requete réussie
			success: function(result){console.log(result); 
				if (result['reference_ths'] != "") {
					document.getElementById('ref_ths_'+id).value = result['reference_ths'];
					document.getElementById('ref_ths_affichage_'+id).value = result['reference_ths_affichage'];
					document.getElementById('designation_'+id).innerHTML = result['designation'];
					var pu = result['prix'] + "";
					document.getElementById('prix_unitaire_'+id).innerHTML = pu.replace('.', ',');
					document.getElementById('prix_unitaire_ht_'+id).value = result['prix'];
					document.getElementById('prix_total_ht_'+id).innerHTML = pu.replace('.', ',');
					var pu = result['prix_ttc'] + "";
					document.getElementById('prix_unitaire_ttc_'+id).value = result['prix_ttc'];
					document.getElementById('prix_total_ttc_'+id).innerHTML = pu.replace('.', ',');
				}
			}
		});
	}

	$(document).ready(function() {
		var line = 0;

		$('.ajout_article').click(function (){
			var str = '<tr id="ligne_article_' + line + '">';
			str += '<input type="hidden" id="prix_unitaire_ht_' + line + '">';
			str += '<input type="hidden" id="prix_unitaire_ttc_' + line + '">';
			str += '<td><input class="search-article" id="ref_ths_affichage_' + line + '" onkeyup="recupererArticle(' + line + ')" type="text" value="" /><input id="ref_ths_' + line + '" type="hidden" value="" name="articles[' + line + '][reference]" /><input type="hidden" id="poids" value=""/></td>';
			str += '<td onclick="supprimerLigne(' + line + ')">Supprimer</td>';
			str += '<td id="designation_' + line + '"></td>';
			str += '<td id="prix_unitaire_' + line + '"></td>';
			str += '<td><select id="qte_' + line + '" name="articles[' + line + '][qte]" onchange="modifierQuantite(' + line + ')">';
			<?php for($i = 1; $i <= 20; $i++):?>
				str += '<option value="<?php echo $i?>"><?php echo $i?></option>';
			<?php endfor;?>
			str += '</select></td>';
			str += '<td id="prix_total_ht_' + line + '"></td>';
			str += '<td id="prix_total_ttc_' + line + '"></td>';
			str += '</tr>';
			
			$(str).appendTo($('#calculPanier'))
			
			$('#calculPanier td > input').last().focus();
			$('#calculPanier td > input.search-article').last().autocomplete({
			    source: function (request, response) {
				$.getJSON("<?php echo url_for("@rechercher_article_nhp") ?>?term=" + request.term, function (data) {
				    response($.map(data, function (value, key) {
					return {
					    label: value.affichage,
					    value: value.id
					};
				    }));
				});
			    },
			    minLength: 2,
			    delay: 100,
			    select: function (event, ui) {
				var id = event.target.id.split("_")
				recupererArticle(id[3], ui.item.value);
			    }
			});
			line++;
		});
		
		if ($('#calculPanier tr').length == 1) {
		    $('.ajout_article').click();
		}
	});
</script>