<?php

/**
 * client actions.
 *
 * @package    sf_sandbox
 * @subpackage client
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class clientActions extends sfActions
{
	/**
	 * Executes index action
	 *
	 * @param sfRequest $request A request object
	 */
	public function executeIndex(sfWebRequest $request)
	{
		$user_id = $this->getUser()->getAttribute("user_id", null, "sfGuardSecurityUser");
		$this->client = Doctrine_Core::getTable("Client")->findOneByIdUser($user_id);
		
		$this->forward404If(!($this->client instanceof Client));
		
		/*sfContext::getInstance()->getConfiguration()->loadhelpers("url");
		
		$filAriane = ' > <a href="'.url_for("@client").'">Espace client</a>';
		$this->getUser()->setFlash("filAriane", $filAriane);*/
		$this->getResponse()->addMeta('title', 'Espace client');
		$this->getResponse()->addMeta('description', 'Espace client');
	}
	
	public function executeMesCommandes(sfWebRequest $request)
	{
		$user_id = $this->getUser()->getAttribute("user_id", null, "sfGuardSecurityUser");
		$this->client = Doctrine_Core::getTable("Client")->findOneByIdUser($user_id);
		
		$this->listeCommande = Doctrine_Core::getTable("Commande")->findByIdClient($this->client->getIdClient());
	}

	public function executeCommande(sfWebRequest $request)
	{
		$id_commande = $request->getParameter("numero");
		$user_id = $this->getUser()->getAttribute("user_id", null, "sfGuardSecurityUser");
		
		$this->commande = Doctrine_Core::getTable("Commande")->find($id_commande);
		$this->forward404If(!($this->commande instanceof Commande));
		
		$this->client = Doctrine_Core::getTable("Client")->findOneByIdUser($user_id);
		$this->forward404If(!($this->client instanceof Client));
		
		$this->forward404If($this->commande->getIdClient() != $this->client->getPrimaryKey());
		
		// On vérifie que cette commande appartient bien à l'utilisateur connecté
		$this->forward404If($this->commande->getIdClient() != $this->client->getIdClient());
		
		$this->listeArticle = Doctrine_Core::getTable("CommandeArticle")->createQuery("ca")
			->where("ca.id_commande = ?", $id_commande)
			->andWhere("ca.id_article != ?", "")
			->execute();
		$this->listeNettoyeur = Doctrine_Core::getTable("CommandeArticle")->createQuery("ca")
			->where("ca.id_commande = ?", $id_commande)
			->andWhere("ca.id_nettoyeur != ?", "")
			->execute();

		/*sfContext::getInstance()->getConfiguration()->loadhelpers("url");
		$filAriane = ' > <a href="'.url_for("@client").'">Espace client</a>';
		$filAriane .= ' > Commande n°'.$id_commande;
		$this->getUser()->setFlash("filAriane", $filAriane);*/
		$this->getResponse()->addMeta('title', 'Commande n° '.$id_commande);
		$this->getResponse()->addMeta('description', 'Commande n° '.$id_commande);
	}
}
