<?php 
	use_helper("Number");
	
	// Données concernant frais de ports
	$francoDePort = 0;
	$totalPoids = 0;
        $tva = Doctrine_Core::getTable("TauxTVA")->find(sfConfig::get('app_tva_196'));
?>

<h3 id="client_titre">Commande numéro <?php echo $commande->getIdCommande()?> effectuée le <?php echo Utils::dateEnToFr($commande->getDateCreationSansHeure())?></h3>
<?php include_partial("client/menu")?>
<?php if($commande->getTypeCommande() == sfConfig::get("app_commande_type_commande")):?>
	<div id="panier">
		<table id="calculPanier">
			<tr class="entete">
				<td class="reference">Référence</td>
				<td class="designation">Désignation</td>
				<td class="voir">Voir</td>
				<td class="prixUnitHT">Prix<br />Unit. HT</td>
				<td class="quantite">Quantité</td>
				<td class="prixTotalHT">Prix<br />Total HT</td>
				<td class="prixTotalTTC">Prix<br />Total TTC</td>
			</tr>
			<?php foreach ($listeArticle as $commandeArticle):?>
				<?php $article = Doctrine::getTable("Article")->find($commandeArticle->getIdArticle())?>
				<tr class="lignePanier">
					<td><?php echo $article->getReferenceThsAffichage()?></td>
					<td><?php echo $article->getDesignationCourte()?></td>
					<td><?php echo link_to("Voir", "@url_article?famille=".Utils::stringForUrl($article->getFamille()->getLibelle())."&reference_ths=".Utils::stringForUrl($article->getReferenceThsUrl()), array("target" => "_blank"))?></td>
					<td class="affichageChiffre"><?php echo format_currency($commandeArticle->getPrixUnitaireHt())?> €</td>
					<td class="affichageQte"><?php echo $commandeArticle->getQuantite()?></td>
					<td class="affichageChiffre"><?php echo format_currency($commandeArticle->getPrixUnitaireHt() * $commandeArticle->getQuantite())?> €</td>
					<td class="affichageChiffre"><?php echo format_currency(Utils::prixAvecTVA($commandeArticle->getPrixUnitaireHt() * $commandeArticle->getQuantite(), $commande->getTauxTva()))?> €</td>
				</tr>
				<?php $totalPoids += Utils::doubleFrToEn($article->getPoids()) * $commandeArticle->getQuantite();?>
			<?php endforeach;?>
			
			<?php foreach ($listeNettoyeur as $commandeArticle):?>
				<?php $nettoyeur = Doctrine::getTable("NettoyeurHautePression")->find($commandeArticle->getIdNettoyeur())?>
				<tr class="lignePanier">
					<td><?php echo $nettoyeur->getReferenceThs()?></td>
					<td>Nettoyeur <?php echo $nettoyeur->getMarque()->getLibelle()?> <?php echo $nettoyeur->getModele()?></td>
					<td><?php echo link_to("Voir", "@url_nettoyeur?marque=".Utils::stringForUrl($nettoyeur->getMarque()->getLibelle())."&modele=".Utils::stringForUrl($nettoyeur->getModele()), array("target" => "_blank"))?></td>
					<td class="affichageChiffre"><?php echo format_currency($commandeArticle->getPrixUnitaireHt())?> €</td>
					<td class="affichageQte"><?php echo $commandeArticle->getQuantite()?></td>
					<td class="affichageChiffre"><?php echo format_currency($commandeArticle->getPrixUnitaireHt() * $commandeArticle->getQuantite())?> €</td>
					<td class="affichageChiffre"><?php echo format_currency(Utils::prixAvecTVA($commandeArticle->getPrixUnitaireHt() * $commandeArticle->getQuantite(), $commande->getTauxTva()))?> €</td>
				</tr>
				<?php 
					$totalPoids += Utils::doubleFrToEn($nettoyeur->getPoids()) * $commandeArticle->getQuantite();
					if($nettoyeur->getFrancoDePort())
					{
						$francoDePort = 1;
					}
				?>
			<?php endforeach;?>
		</table>
		<div id="recalculPanierPort">
			<?php if($francoDePort):?>
				<p>Franco de port</p>
			<?php else:?>
				<table class="general">
					<tr>
						<td class="recalculerPanier"></td>
						<td class="infoFraisDePort">
							<p class="titre">Frais de port:</p>
						</td>
						<td class="fraisDePort">
							<table>
								<tr class="entete">
									<td>Poids Total</td>
									<td>Prix HT</td>
									<td>Prix TTC</td>
								</tr>
								<tr>
									<td class="affichageChiffre"><?php echo Utils::doubleEnToFr($totalPoids)?> kg</td>
									<td class="affichageChiffre"><?php echo format_currency($commande->getFraisPortHt())?>€</td>
									<td class="affichageChiffre"><?php echo format_currency($commande->getFraisPortHt() * (1 + $commande->getTauxTva() / 100))?>€</td>
								</tr>
							</table>
						</td>
					</tr>
				</table>
			<?php endif?>
		</div>
		<div id="validerPanier">
			<table class="general">
				<tr>
					<td class="recapitulatif">
						<table>
							<tr>
								<td class="texte">Total des produits HT</td>
								<td class="affichageChiffre"><?php echo format_currency($commande->getTotalProduitHt())?>€</td>
							</tr>
							<tr>
								<td class="texte">Total port HT</td>
								<td class="affichageChiffre"><?php echo format_currency($commande->getFraisPortHt())?>€</td>
							</tr>
							<tr>
								<td colspan="2"></td>
							</tr>
							<tr>
								<td class="texte">Total HT</td>
								<td class="affichageChiffre"><?php echo format_currency($commande->getTotalHt())?>€</td>
							</tr>
							<tr>
								<td class="texte">TVA <?php echo format_currency($commande->getTauxTva())?>%</td>
								<td class="affichageChiffre"><?php echo format_currency($commande->getTotalTtc() - $commande->getTotalHt())?>€</td>
							</tr>
							<tr>
								<td colspan="2"></td>
							</tr>
							<tr>
								<td class="texte">Total TTC</td>
								<td class="texte affichageChiffre"><?php echo format_currency($commande->getTotalTtc())?>€</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</div>
	</div>
<?php elseif($commande->getTypeCommande() == sfConfig::get("app_commande_type_devis")):?>
	<div id="panier">
		<table class="imageDevis">
			<tr>
				<td class="imageDevisImage"><?php echo image_tag("pdf1.jpg")?></td>
				<td class="imageDevisTexte">
					<?php $file = explode(".", $commande->getDevisPdf())?>
					Visualiser votre devis <a href="<?php echo _compute_public_path("devis/".$commande->getDevisPdf(), $file[1], false)?>" target="_blank">Voir</a>
				</td>
				<td class="imageDevisTexte"></td>
			</tr>
			<tr>
				<td class="imageDevisImage"></td>
				<td class="imageDevisTexte">Total TTC</td>
				<td class="imageDevisTexte"><?php echo format_currency($commande->getTotalTtc())?>€</td>
			</tr>
		</table>
	</div>
<?php endif?>