<div id="panier">
	<?php use_helper("Number", "I18N")?>
	<p class="texte">
		Cher Client,<br /><br />
		Afin de valider votre commande, vous allez être mis en relation avec le terminal de paiement sécurisé du Crédit Mutuel.<br />
		Pour cela, veuillez remplir avec précision le formulaire d'identification ci-dessous.
	</p>
	<p class="texte">
		Notre devis N°<?php echo $commande->getIdCommande()?> du <?php echo Utils::dateEnToFr($commande->getDateCreationSansHeure())?><br />
		Montant : <?php echo format_currency($commande->getTotalTtc())?>€
	</p>
	<?php if($commande->getTypeCommande() == sfConfig::get("app_commande_type_devis")):?>
		<table class="imageDevis">
			<tr>
				<td class="imageDevisImage"><?php echo image_tag("pdf1.jpg")?></td>
				<td class="imageDevisTexte">
					<?php $file = explode(".", $commande->getDevisPdf())?>
					Visualiser votre devis <a href="<?php echo _compute_public_path("devis/".$commande->getDevisPdf(), $file[1], false)?>" target="_blank">Voir</a>
				</td>
			</tr>
		</table>
	<?php endif?>
	<?php echo get_partial('sfGuardAuth/coordonnees_signin_form_panier', array('userForm' => $userForm)) ?>
	<?php echo form_tag("@devis?id_commande=".$id_commande."&token=".$token) ?>
		<?php echo $form['_csrf_token']->render()?>
		<?php echo $form['id']->render()?>
		<table id="coordoneesPanier">
			<tr class="coordoneesPanierTr">
				<td class="coordoneesPanierTd"><span class="entete">Adresse de facturation</span></td>
				<td class="coordoneesPanierTd"><span class="entete">Adresse de livraison</span></td>
			</tr>
			<tr class="coordoneesPanierTr">
				<td class="coordoneesPanierTd">
					<table>
						<?php if($form->hasGlobalErrors()):?>
							<tr>
								<td></td>
								<td>
									<?php foreach ($form->getGlobalErrors() as $name => $error): ?>
         								<?php echo $error ?>
        							<?php endforeach; ?>
        						</td>
							</tr>
						<?php endif?>
						<tr>
							<td class="libelle">Type</td>
							<td><?php echo $form['type']->render()?></td>
						</tr>
						<tr>
							<td class="libelle">Raison sociale</td>
							<td><?php echo $form['raison_sociale']->render()?></td>
						</tr>
						<tr>
							<td></td>
							<td><?php echo $form['raison_sociale']->renderError()?></td>
						</tr>
						<tr>
							<td class="libelle">Civilité</td>
							<td><?php echo $form['civilite']->render()?></td>
						</tr>
						<tr>
							<td></td>
							<td><?php echo $form['civilite']->renderError()?></td>
						</tr>
						<tr>
							<td class="libelle">Nom</td>
							<td>
								<?php echo $form['nom']->render()?>
							</td>
						</tr>
						<tr>
							<td></td>
							<td><?php echo $form['nom']->renderError()?></td>
						</tr>
						<tr>
							<td class="libelle">Prénom</td>
							<td><?php echo $form['prenom']->render()?></td>
						</tr>
						<tr>
							<td></td>
							<td><?php echo $form['prenom']->renderError()?></td>
						</tr>
						<tr>
							<td class="libelle">Adresse</td>
							<td><?php echo $form['adresse']->render()?></td>
						</tr>
						<tr>
							<td></td>
							<td><?php echo $form['adresse']->renderError()?></td>
						</tr>
						<tr>
							<td class="libelle">Complément d'adresse</td>
							<td><?php echo $form['adresse_complement']->render()?></td>
						</tr>
						<tr>
							<td></td>
							<td><?php echo $form['adresse_complement']->renderError()?></td>
						</tr>
						<tr>
							<td class="libelle">Code postal</td>
							<td><?php echo $form['code_postal']->render()?></td>
						</tr>
						<tr>
							<td></td>
							<td><?php echo $form['code_postal']->renderError()?></td>
						</tr>
						<tr>
							<td class="libelle">Ville</td>
							<td><?php echo $form['ville']->render()?></td>
						</tr>
						<tr>
							<td></td>
							<td><?php echo $form['ville']->renderError()?></td>
						</tr>
						<tr>
							<td class="libelle">Pays</td>
							<td><?php echo $form['pays']->render()?></td>
						</tr>
						<tr>
							<td></td>
							<td><?php echo $form['pays']->renderError()?></td>
						</tr>
						<tr>
							<td class="libelle">Téléphone</td>
							<td><?php echo $form['telephone']->render()?></td>
						</tr>
						<tr>
							<td></td>
							<td><?php echo $form['telephone']->renderError()?></td>
						</tr>
						<tr>
							<td class="libelle">Fax</td>
							<td><?php echo $form['fax']->render()?></td>
						</tr>
						<tr>
							<td></td>
							<td><?php echo $form['fax']->renderError()?></td>
						</tr>
						<tr>
							<td class="libelle">E-mail</td>
							<td>
								<?php if($sf_user->isAuthenticated()):?>
									<?php echo $form['email_address']->render(array("readonly" => "readonly"))?>
								<?php else:?>
									<?php echo $form['email_address']->render()?>
								<?php endif?>
							</td>
						</tr>
						<tr>
							<td></td>
							<td><?php echo $form['email_address']->renderError()?></td>
						</tr>
						<tr>
							<td class="libelle">Confirmation E-mail</td>
							<td>
								<?php if($sf_user->isAuthenticated()):?>
									<?php echo $form['email_confirmation']->render(array("readonly" => "readonly"))?>
								<?php else:?>
									<?php echo $form['email_confirmation']->render()?>
								<?php endif?>
							</td>
						</tr>
						<tr>
							<td></td>
							<td><?php echo $form['email_confirmation']->renderError()?></td>
						</tr>
						
						<?php if(!$sf_user->isAuthenticated()):?>
							<tr>
								<td class="libelle">Mot de passe</td>
								<td>
									<?php echo $form['password']->render()?>
								</td>
							</tr>
							<tr>
								<td></td>
								<td><?php echo $form['password']->renderError()?></td>
							</tr>
							<tr>
								<td class="libelle">Confirmation du mot de passe</td>
								<td>
									<?php echo $form['password_confirmation']->render()?>
								</td>
							</tr>
							<tr>
								<td></td>
								<td><?php echo $form['password_confirmation']->renderError()?></td>
							</tr>
						<?php endif; ?>
					</table>
				</td>
				<td class="coordoneesPanierTd">
					<table>
						<tr>
							<td>&nbsp;</td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_raison_sociale']->render()?></td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_raison_sociale']->renderError()?></td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_civilite']->render()?></td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_civilite']->renderError()?></td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_nom']->render()?></td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_nom']->renderError()?></td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_prenom']->render()?></td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_prenom']->renderError()?></td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_adresse']->render()?></td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_adresse']->renderError()?></td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_adresse_complement']->render()?></td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_adresse_complement']->renderError()?></td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_code_postal']->render()?></td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_code_postal']->renderError()?></td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_ville']->render()?></td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_ville']->renderError()?></td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_pays']->render()?></td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_pays']->renderError()?></td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_telephone']->render()?></td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_telephone']->renderError()?></td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_fax']->render()?></td>
						</tr>
						<tr>
							<td><?php echo $form['livraison_fax']->renderError()?></td>
						</tr>
						<tr>
							<td>
								<p>Note sur la livraison :</p>
								<?php echo $form['livraison_note']->render()?>
							</td>
						</tr>
					</table>
				</td>
			</tr>
		</table>
		
                <p class="boutonValider"><input type="submit" value="Valider les coordonnées" style="    font-size: 16px;
            padding: 5px;
            background-color: #018549;
            color: #FFF;
            font-weight: bold;" /></p></form>
</div>
<script>
    $(document).ready(function() {
        $('#coordonnees_type').change(function() {
            if ($(this).val() == 'Société') {
                $('#coordonnees_raison_sociale').removeAttr('disabled');
                $('#coordonnees_livraison_raison_sociale').removeAttr('disabled');
            } else {
                $('#coordonnees_raison_sociale').attr('disabled', 'disabled');
                $('#coordonnees_livraison_raison_sociale').attr('disabled', 'disabled');
            }
        });
    });
</script>