﻿<?php

/**
 * page actions.
 *
 * @package    sf_sandbox
 * @subpackage page
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class pageActions extends sfActions
{
	/**
	 * Executes index action
	 *
	 * @param sfRequest $request A request object
	 */
	public function executeIndex(sfWebRequest $request)
	{
		$this->page = Doctrine::getTable("Page")->find($request->getParameter("id_page"));
		$this->forward404If(!($this->page instanceof Page));
		
		sfContext::getInstance()->getConfiguration()->loadHelpers("Url");
		
		if($this->page->getUrlPartie1() != "" && $this->page->getUrlPartie2() == "")
		{
			$filAriane = ' > <a href="'.url_for("@url_page1?partie1=".Utils::slugify($this->page->getUrlPartie1()), true).'">'.$this->page->getBaliseTitre().'</a>';
		}
		else if($this->page->getUrlPartie1() != "" && $this->page->getUrlPartie2() != "")
		{
			$filAriane = ' > <a href="'.url_for("@url_page2?partie1=".Utils::slugify($this->page->getUrlPartie1())."&partie2=".Utils::slugify($this->page->getUrlPartie2()), true).'">'.$this->page->getBaliseTitre().'</a>';
		}
		
		$this->getUser()->setFlash("filAriane", $filAriane);
		$this->getResponse()->setTitle($this->page->getBaliseTitre());
		$this->getResponse()->addMeta('description', $this->page->getBaliseMeta());
		
		$rechercheRapide = array(18, 21, 22, 34, 36, 37, 38, 39, 40, 41, 75, 76);
		$this->afficheRechercheRapide = false;
		if(in_array($request->getParameter("id_page"), $rechercheRapide))
		{
			$this->afficheRechercheRapide = true;
		}
		
		$this->affichePromotion = false;
		if($request->getParameter("id_page") == 59)
		{
			$this->affichePromotion = true;
			$this->listePromoEauFroide = NettoyeurHautePressionTable::getListPromoEauFroide();
			$this->listePromoEauChaude = NettoyeurHautePressionTable::getListPromoEauChaude();
			$this->listePromoMoteurThermique = NettoyeurHautePressionTable::getListPromoMoteurThermique();
		}
		
		// Espace pro
		//$espacePro = array(60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70);
		$this->afficheEspacePro = false;
		/*if(in_array($request->getParameter("id_page"), $espacePro))
		{*/
			if($this->getUser()->hasAttribute("espace_pro"))
			{
				$this->afficheEspacePro = true;
				
				$visite = new VisitePro();
				$visite->setIdMailingPro($this->getUser()->getAttribute("espace_pro"));
				$visite->setUrl($_SERVER["REQUEST_URI"]);
				$visite->setDateHeureDebut(date("Y-m-d H:i:s"));
				$visite->setDateHeureFin(date("Y-m-d H:i:s"));
				$visite->save();
				
				$this->idVisitePro = $visite->getPrimaryKey();
			}
		//}
	}
	
	public function executeRecupererMarque(sfWebRequest $request)
	{
		if ($request->isXmlHttpRequest())
		{
			return $this->renderComponent("page", "chargementMarque");
		}
		return sfView::NONE;
	}
	
	public function executeRecupererModele(sfWebRequest $request)
	{
		$id_marque = $request->getPostParameter('id_marque');
		if ($request->isXmlHttpRequest())
		{
			return $this->renderComponent("page", "chargementModele", array("id_marque" => $id_marque));
		}
		return sfView::NONE;
	}
	
	public function executeRecupererMarqueVentePiecesDetachees(sfWebRequest $request)
	{
	    if ($request->isXmlHttpRequest()) {
		    return $this->renderComponent("page", "chargementMarqueVentePiecesDetachees");
	    }
	    
	    return sfView::NONE;
	}
	
	public function executeRecupererModeleVentePiecesDetachees(sfWebRequest $request)
	{
	    $id_marque = $request->getPostParameter('id_marque');

	    if ($request->isXmlHttpRequest()) {
		    return $this->renderComponent("page", "chargementModeleVentePiecesDetachees", array("id_marque" => $id_marque));
	    }
	    return sfView::NONE;
	}
	
	public function executeRedirectionNettoyeur(sfWebRequest $request)
	{
	    if ($request->isMethod("POST")) {
		if ($request->hasParameter('recherche_modele')) {
		    $this->getUser()->setFlash("render", "vpd");
		    $nettoyeur = Doctrine_Core::getTable("NettoyeurHautePression")->find($request->getParameter('recherche_modele'));
		    $this->redirect('@url_nettoyeur?marque='.Utils::slugify($nettoyeur->getMarque()->getLibelle()).'&modele='.Utils::slugify($nettoyeur->getModele()));
		}
	    }

	    $this->forward404();
	}
	
	public function executeEspacePro(sfWebRequest $request)
	{
		$this->afficheEspacePro = false;
		if($this->getUser()->hasAttribute("espace_pro"))
		{
			$this->afficheEspacePro = true;
			$visite = new VisitePro();
			$visite->setIdMailingPro($this->getUser()->getAttribute("espace_pro"));
			$visite->setUrl($_SERVER["REQUEST_URI"]);
			$visite->setDateHeureDebut(date("Y-m-d H:i:s"));
			$visite->setDateHeureFin(date("Y-m-d H:i:s"));
			$visite->save();
			
			$this->idVisitePro = $visite->getPrimaryKey();
		}
		
		$this->form = new CodePromoForm();
		if($request->isMethod("POST"))
		{
			$this->form->bind($request->getParameter($this->form->getName()));

			if($this->form->isValid() && !$this->getUser()->hasAttribute("espace_pro"))
			{
				$values = $this->form->getValues();
				
				// Connexion
				$mailing_pro = Doctrine_Core::getTable("MailingPro")->findOneByCodeAcces($values['code_promo']);
				if($mailing_pro)
				{
					$mailing_pro->setAcces(true);
					$mailing_pro->save();
					
					$this->getUser()->setAttribute("espace_pro", $mailing_pro->getPrimaryKey());
					
					$visite = new VisitePro();
					$visite->setIdMailingPro($mailing_pro->getPrimaryKey());
					$visite->setUrl($_SERVER["REQUEST_URI"]);
					$visite->setDateHeureDebut(date("Y-m-d H:i:s"));
					$visite->setDateHeureFin(date("Y-m-d H:i:s"));
					$visite->save();
					
					$this->idVisitePro = $visite->getPrimaryKey();
					$this->afficheEspacePro = true;
				}
			}
		}
	}
	
	public function executeMailVisiteEspacePro(sfWebRequest $request)
	{
		// Cron
		$mailings_pro = Doctrine_Core::getTable("MailingPro")->findByAcces(true);
		
		foreach($mailings_pro as $mailing_pro)
		{
			$headers = "From: webmaster@haute-pression.com\n" .
					 "MIME-Version: 1.0\nContent-type: text/html; charset=UTF-8\n" .
					 "Reply-To: webmaster@haute-pression.com\n" ;
			$headers .= "Bcc: yenkong@lybliamay.fr\n" ;

			$visitesPro = VisiteProTable::getListByMailingPro($mailing_pro->getPrimaryKey());
			
			$emailCorps_client = "Civilité : ".$mailing_pro->getCivilite()."<br />";
			$emailCorps_client .= "Nom : ".$mailing_pro->getNom()."<br />";
			$emailCorps_client .= "Adresse : ".$mailing_pro->getAdresse()."<br />";
			$emailCorps_client .= "Code postal : ".$mailing_pro->getCodePostal()."<br />";
			$emailCorps_client .= "Ville : ".$mailing_pro->getVille()."<br />";
			$emailCorps_client .= "Téléphone : ".$mailing_pro->getTelephone()."<br />";
			$emailCorps_client .= "Fax : ".$mailing_pro->getFax()."<br />";
			$emailCorps_client .= "GSM : ".$mailing_pro->getGsm()."<br />";
			$emailCorps_client .= "Activité : ".$mailing_pro->getActivite()."<br />";
			$emailCorps_client .= "Date d'envoi : ".$mailing_pro->getDate()."<br />";
			$emailCorps_client .= "<br />";
			$emailCorps_client .= "Récapitulatif des pages visitées : <br />";
			$emailCorps_client .= "<table border='1'>";
			$emailCorps_client .= "<thead>";
			$emailCorps_client .= "<td>Url</td>";
			$emailCorps_client .= "<td>Date de début</td>";
			$emailCorps_client .= "<td>Date de fin</td>";
			$emailCorps_client .= "<td>Durée</td>";
			$emailCorps_client .= "</thead>";
			$emailCorps_client .= "<tbody>";
			foreach ($visitesPro as $visitePro)
			{
				$emailCorps_client .= "<tr>";
				$emailCorps_client .= "<td>".$visitePro->getUrl()."</td>";
				$emailCorps_client .= "<td>".Utils::dateEnToFr($visitePro->getDateHeureDebut())."</td>";
				$emailCorps_client .= "<td>".Utils::dateEnToFr($visitePro->getDateHeureFin())."</td>";
				$emailCorps_client .= "<td>".Utils::dureeDifference($visitePro->getDateHeureDebut(), $visitePro->getDateHeureFin())."</td>";
				$emailCorps_client .= "</tr>";
			}
			$emailCorps_client .= "</tbody>";
			$emailCorps_client .= "</table>";
			

			//yenkong@lybliamay.fr
			//laurent.ths@gmail.com
			
			$reponseMail = mail("contact@haute-pression.com", "Accès espace pro", $emailCorps_client, $headers);
		}
		
		Doctrine_Query::create()
			->update("MailingPro")
			->set("acces", 0)
			->execute();
			
		return sfView::NONE;
	}
	
	public function executeVisiteEspacePro(sfWebRequest $request)
	{
		$id_visite_pro = $request->getPostParameter('id');
		if ($request->isXmlHttpRequest())
		{
			$visite = Doctrine_Core::getTable("VisitePro")->find($id_visite_pro);
			if($visite)
			{
				$visite->setDateHeureFin(date("Y-m-d H:i:s"));
				$visite->save();
			}
		}
		return sfView::NONE;
	}
}