<?php

/**
 * panier actions.
 *
 * @package    sf_sandbox
 * @subpackage panier
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class panierActions extends sfActions
{
	/**
	 * Executes panier action
	 *
	 * @param sfRequest $request A request object
	 */
	public function executePanier(sfWebRequest $request)
	{
		sfContext::getInstance()->getConfiguration()->loadHelpers('Url');
		$filAriane = ' > <a href="'.url_for("@panier").'">Calcul du panier</a>';
		$this->getUser()->setFlash("filAriane", $filAriane);

		// S'il n'y a aucune commande on redirige sur la homepage
		if(!$this->getUser()->hasAttribute("commande"))
		{
			$this->redirect("@homepage");
		}

		// Vérifie que la commande minimum est atteint
		$commande = $this->getUser()->getAttribute("commande");
		$commande_articles = $this->getUser()->getAttribute("commande_articles");
		$this->depasseMinimumCommande = true;
		
		$annule_minimum_commande = false;
		
		if(sizeof($commande_articles['article']) > 0)
		{
			foreach ($commande_articles['article'] as $article) 
			{
				$_article = Doctrine::getTable("Article")->find($article->getIdArticle());
				if($_article->getMinimumCommande())
				{
					$annule_minimum_commande = true;
					break;
				}
			}
		}
		
		if($commande->getMailCommande() == 0 && !$annule_minimum_commande)
		{
			$resultat = $this->calculerCommande();
			if($resultat['totalTTC'] >= $resultat['minimumCommande'])
			{
				$this->depasseMinimumCommande = true;
			}
			else
			{
				$this->depasseMinimumCommande = false;
				$this->minimumCommande = $resultat['minimumCommande'];
			}
		}
                
	    $this->optionVacances = ConfigTable::getOptionVacances();
	    $this->configMinimumFraisDePort = ConfigTable::getMinimumFraisDePort();
	    $this->configMinimumFraisDeGestion = ConfigTable::getMinimumFraisDeGestion();
	    $this->configFraisDeGestionHT = ConfigTable::getFraisDeGestion();
	}

	/**
	 * Executes panier action
	 *
	 * @param sfRequest $request A request object
	 */
	public function executeCoordonnees(sfWebRequest $request)
	{
		sfContext::getInstance()->getConfiguration()->loadHelpers("Url");
		$this->getUser()->setAttribute("signin_referer", url_for("@panier_coordonnees"));
		
		// S'il n'y a aucune commande on redirige sur la page du panier
		if(!$this->getUser()->hasAttribute("commande"))
		{
			$this->redirect("@panier");
		}
		
		// Vérifie que la commande minimum est atteint
		$commande = $this->getUser()->getAttribute("commande");
		$commande_articles = $this->getUser()->getAttribute("commande_articles");
		
		$annule_minimum_commande = false;
			
		if(sizeof($commande_articles['article']) > 0)
		{
			foreach ($commande_articles['article'] as $article) 
			{
				$_article = Doctrine::getTable("Article")->find($article->getIdArticle());
				if($_article->getMinimumCommande())
				{
					$annule_minimum_commande = true;
					break;
				}
			}
		}
		
		if($commande->getMailCommande() == 0 && !$annule_minimum_commande)
		{
			$resultat = $this->calculerCommande();
			if($resultat['totalTTC'] < $resultat['minimumCommande'])
			{
				$this->redirect("@panier");
			}
		}
		
		$class = sfConfig::get('app_sf_guard_plugin_signin_form', 'sfGuardFormSignin');
		$this->userForm = new $class();

		$this->form = new PanierCoordonneesForm();

		$filAriane = ' > <a href="'.url_for("@panier_coordonnees").'">Vos coordonnées</a>';
		$this->getUser()->setFlash("filAriane", $filAriane);
		$this->getResponse()->addMeta('title', "Vos coordonnées");
		$this->getResponse()->addMeta('description', "Vos coordonnées");
		
		$this->livraisonIdentique = true;
		$client = null;
		
		if($this->getUser()->isAuthenticated())
		{
		    
		
		    $this->livraisonIdentique = false;
			// On récupère le client et on le préremplit
			$client = Doctrine_Core::getTable('Client')
			->createQuery('c')
			->where('c.id_user = ?', $this->getUser()->getAttribute('user_id', null, 'sfGuardSecurityUser'))
			->execute();
			
			if(sizeof($client) > 0)
			{
				$user = Doctrine_Core::getTable('SfGuardUser')->find($this->getUser()->getAttribute('user_id', null, 'sfGuardSecurityUser'));
			
				$client = $client[0];
				$this->form->setDefaults(array(
					'type' 				=> $client->getType(),
					'civilite' 				=> $client->getCivilite(),
					'raison_sociale' 				=> $client->getRaisonSociale(),
					'nom' 					=> $client->getNom(),
					'prenom' 				=> $client->getPrenom(),
					'adresse' 				=> $client->getAdresse(),
					'adresse_complement' 				=> $client->getAdresseComplement(),
					'code_postal' 			=> $client->getCodePostal(),
					'ville' 				=> $client->getVille(),
					'pays' 					=> $client->getPays(),
					'telephone' 			=> $client->getTelephone(),
					'fax' 					=> $client->getFax(),
					'id' 					=> $this->getUser()->getAttribute('user_id', null, 'sfGuardSecurityUser'),
					'email_address'			=> $user->getUsername(),
					'email_confirmation'	=> $user->getUsername(),
					'livraison_type' 	=> $commande->getType(),
					'livraison_civilite' 	=> $commande->getCivilite(),
					'livraison_raison_sociale' 	=> $commande->getRaisonSociale(),
					'livraison_nom' 		=> $commande->getNom(),
					'livraison_prenom' 		=> $commande->getPrenom(),
					'livraison_adresse' 	=> $commande->getAdresse(),
					'livraison_adresse_complement' 	=> $commande->getAdresseComplement(),
					'livraison_code_postal' => $commande->getCodePostal(),
					'livraison_ville' 		=> $commande->getVille(),
					'livraison_pays' 		=> $commande->getPays(),
					'livraison_telephone' 	=> $commande->getTelephone(),
					'livraison_fax' 		=> $commande->getFax(),
					'livraison_note'		=> $commande->getNoteLivraison(),
				));
			}
			else
			{
				// On récupère le sfGuard pour l'adresse email
				$sfUser = Doctrine_Core::getTable('sfGuardUser')->find($this->getUser()->getAttribute('user_id', null, 'sfGuardSecurityUser'));

				$this->form->setDefaults(array(
					'id' 					=> $this->getUser()->getAttribute('user_id', null, 'sfGuardSecurityUser'),
					'nom' 					=> $sfUser->getLastName(),
					'prenom' 				=> $sfUser->getFirstName(),
					'email_address'			=> $sfUser->getUsername(),
					'email_confirmation'	=> $sfUser->getUsername(),
					'livraison_type' 	=> $commande->getType(),
					'livraison_civilite' 	=> $commande->getCivilite(),
					'livraison_raison_sociale' 	=> $commande->getRaisonSociale(),
					'livraison_nom' 		=> $commande->getNom(),
					'livraison_prenom' 		=> $commande->getPrenom(),
					'livraison_adresse' 	=> $commande->getAdresse(),
					'livraison_adresse_complement' 	=> $commande->getAdresseComplement(),
					'livraison_code_postal' => $commande->getCodePostal(),
					'livraison_ville' 		=> $commande->getVille(),
					'livraison_pays' 		=> $commande->getPays(),
					'livraison_telephone' 	=> $commande->getTelephone(),
					'livraison_fax' 		=> $commande->getFax(),
					'livraison_note'		=> $commande->getNoteLivraison(),
				));
			}
		}
			
		if($request->isMethod("POST"))
		{
			if($this->getUser()->isAuthenticated()) {
				$fake_password = uniqid();
				$this->form->bind(array_merge($request->getParameter($this->form->getName()), array(
					'password' => $fake_password,
					'password_confirmation' => $fake_password,
				)), $request->getFiles($this->form->getName()));
			} else {
				$this->form->bind($request->getParameter($this->form->getName()), $request->getFiles($this->form->getName()));
			}
			
			if($this->form->isValid())
			{
				$values = $this->form->getValues();
				
				if(sizeof($client) == 0)
				{
					if(!$this->getUser()->isAuthenticated())
					{
						// On créé un sfuser
						$sfUser = new sfGuardUser();
						$sfUser->setLastName($values['nom']);
						$sfUser->setFirstName($values['prenom']);
						$sfUser->setUsername($values['email_address']);
						$sfUser->setEmailAddress($values['email_address']);
						$sfUser->setPassword($values['password']);
						$sfUser->save();
						$this->getUser()->setAttribute('user_id', $sfUser->getId(), 'sfGuardSecurityUser');
						$this->getUser()->setAuthenticated(true);
					}

					$client = new Client();
				}
				
				$client->id_user = $this->getUser()->getAttribute('user_id', null, 'sfGuardSecurityUser');
				$client->type = $values['type'];
				$client->raison_sociale = $values['raison_sociale'];
				$client->civilite = $values['civilite'];
				$client->nom = $values['nom'];
				$client->prenom = $values['prenom'];
				$client->adresse = $values['adresse'];
				$client->adresse_complement = $values['adresse_complement'];
				$client->code_postal = $values['code_postal'];
				$client->ville = $values['ville'];
				$client->pays = $values['pays'];
				$client->telephone = $values['telephone'];
				$client->fax = $values['fax'];
				$client->email = $values['email_address'];
				
				$commande->type = $values['type'];

				$commande->civilite = ($values['livraison_civilite'] == ''? $values['civilite']: $values['livraison_civilite']);
				$commande->raison_sociale = ($values['livraison_raison_sociale'] == ''? $values['raison_sociale']: $values['livraison_raison_sociale']);
				$commande->nom = ($values['livraison_nom'] == ''? $values['nom']: $values['livraison_nom']);
				$commande->prenom = ($values['livraison_prenom'] == ''? $values['prenom']: $values['livraison_prenom']);
				$commande->adresse = ($values['livraison_adresse'] == ''? $values['adresse']: $values['livraison_adresse']);
				$commande->adresse_complement = ($values['livraison_adresse_complement'] == ''? $values['adresse_complement']: $values['livraison_adresse_complement']);
				$commande->code_postal = ($values['livraison_code_postal'] == ''? $values['code_postal']: $values['livraison_code_postal']);
				$commande->ville = ($values['livraison_ville'] == ''? $values['ville']: $values['livraison_ville']);
				$commande->pays = ($values['livraison_pays'] == ''? $values['pays']: $values['livraison_pays']);
				$commande->telephone = ($values['livraison_telephone'] == ''? $values['telephone']: $values['livraison_telephone']);
				$commande->fax = ($values['livraison_fax'] == ''? $values['fax']: $values['livraison_fax']);
				
				$commande->email = $values['email_address'];
				$commande->note_livraison = $values['livraison_note'];
				$commande->setClient($client);
				$commande->setTypeCommande(sfConfig::get("app_commande_type_commande"));
				$commande->save();
				$this->getUser()->setAttribute("commande", $commande);

				$this->redirect("@panier_recapitulatif");
			}
		} 
		
		if (is_null($client)) {
		    $client = new Client();
		}
		
		$this->client = $client;
	}

	/**
	 * Executes panier action
	 *
	 * @param sfRequest $request A request object
	 */
	public function executeRecapitulatif(sfWebRequest $request)
	{
		if(!$this->getUser()->hasAttribute("commande"))
		{
			$this->redirect("@panier");
		}
		
		// Vérifie que la commande minimum est atteint
		$commande = $this->getUser()->getAttribute("commande");
		$commande_articles = $this->getUser()->getAttribute("commande_articles");
		
		$annule_minimum_commande = false;
			
		if(sizeof($commande_articles['article']) > 0)
		{
			foreach ($commande_articles['article'] as $article) 
			{
				$_article = Doctrine::getTable("Article")->find($article->getIdArticle());
				if($_article->getMinimumCommande())
				{
					$annule_minimum_commande = true;
					break;
				}
			}
		}
		
		if($commande->getMailCommande() == 0 && !$annule_minimum_commande)
		{
			$resultat = $this->calculerCommande();
			if($resultat['totalTTC'] < $resultat['minimumCommande'])
			{
				$this->redirect("@panier");
			}
		}
		
		sfContext::getInstance()->getConfiguration()->loadHelpers("Url");
		$filAriane = ' > <a href="'.url_for("@panier_recapitulatif").'">Récapitulatif de la commande</a>';
		$this->getUser()->setFlash("filAriane", $filAriane);
		$this->getResponse()->addMeta('title', "Récapitulatif de la commande");
		$this->getResponse()->addMeta('description', "Récapitulatif de la commande");

		$this->recalculerCommande();
		
		$this->configMinimumFraisDePort = ConfigTable::getMinimumFraisDePort();
		$this->configMinimumFraisDeGestion = ConfigTable::getMinimumFraisDeGestion();
		$this->configFraisDeGestionHT = ConfigTable::getFraisDeGestion();
	}

	/**
	 * Executes recalculer action
	 *
	 * @param sfRequest $request A request object
	 */
	public function executeRecalculer(sfWebRequest $request)
	{
		if(!$this->getUser()->hasAttribute("commande"))
		{
			$this->redirect("@panier");
		}

		if($request->isMethod("POST"))
		{
			$panier = $this->getUser()->getAttribute("commande_articles");

			if($request->hasParameter("articleQte"))
			{
				foreach($request->getParameter("articleQte") as $_id => $_qte)
				{
					$article = Doctrine::getTable("Article")->find($_id);
					// On vérifie que l'article n'existe pas déjà
					$panierArticle = $panier['article'];

					$existe = false;
					foreach ($panierArticle as $id => $commandeArticle)
					{
						if($id == $_id)
						{
							$commandeArticle->setQuantite($_qte);
							$panierArticle[$id] = $commandeArticle;
							$existe = true;
						}
					}

					$panier['article'] = $panierArticle;
					$this->getUser()->setAttribute("commande_articles", $panier);
				}
			}

			if($request->hasParameter("nettoyeurQte"))
			{
				foreach($request->getParameter("nettoyeurQte") as $_id => $_qte)
				{
					$nettoyeur = Doctrine::getTable("NettoyeurHautePression")->find($_id);
					// On vérifie que l'article n'existe pas déjà
					$panierNettoyeur = $panier['nettoyeur'];

					$existe = false;
					foreach ($panierNettoyeur as $id => $commandeArticle)
					{
						if($id == $_id)
						{
							$commandeArticle->setQuantite($_qte);
							$panierNettoyeur[$_id] = $commandeArticle;
							$existe = true;
						}
					}

					$panier['nettoyeur'] = $panierNettoyeur;
					$this->getUser()->setAttribute("commande_articles", $panier);
				}
			}

			$this->redirect("@panier");
		}
	}

	/**
	 * Executes ajouter action
	 *
	 * @param sfRequest $request A request object
	 */
	public function executeAjouter(sfWebRequest $request)
	{
		// Si le panier n'existe pas on le créé
		if (!$this->getUser()->hasAttribute("commande"))
		{
			$commande = new Commande();
			$commande->setIdStatut(sfConfig::get("app_commande_statut_cree"));
			$this->getUser()->setAttribute("commande", $commande);
			$this->getUser()->setAttribute("commande_articles", array("article" => array(), "nettoyeur" => array()));
		}
		$panier = $this->getUser()->getAttribute("commande_articles");

		if($request->hasParameter("id_article"))
		{
			$article = Doctrine::getTable("Article")->find($request->getParameter("id_article"));
			// On vérifie que l'article n'existe pas déjà
			$panierArticle = $panier['article'];

			$existe = false;
			foreach ($panierArticle as $id => $commandeArticle)
			{
				if($id == $request->getParameter("id_article"))
				{
					$commandeArticle->setQuantite($commandeArticle->getQuantite() + 1);
					$panierArticle[$request->getParameter("id_article")] = $commandeArticle;
					$existe = true;
				}
			}

			if(!$existe)
			{
				$commandeArticle = new CommandeArticle();
				$commandeArticle->setIdArticle($request->getParameter("id_article"));
				$commandeArticle->setQuantite(1);
				$commandeArticle->setPrixUnitaireHt($article->getPrixVenteThs());
				$panierArticle[$request->getParameter("id_article")] = $commandeArticle;
			}

			$panier['article'] = $panierArticle;
			$this->getUser()->setAttribute("commande_articles", $panier);

			$this->getUser()->setFlash("panier_ajout", true);

			// Redirection vers la page d'article
			$this->redirect("@url_article?famille=".Utils::slugify($article->getFamille()->getLibelle())."&reference_ths=".Utils::slugify($article->getReferenceThsUrl()));
		}
		else if($request->hasParameter("id_nettoyeur"))
		{
			$nettoyeur = Doctrine::getTable("NettoyeurHautePression")->find($request->getParameter("id_nettoyeur"));
			// On vérifie que l'article n'existe pas déjà
			$panierNettoyeur = $panier['nettoyeur'];

			$existe = false;
			foreach ($panierNettoyeur as $id => $commandeArticle)
			{
				if($id == $request->getParameter("id_nettoyeur"))
				{
					$commandeArticle->setQuantite($commandeArticle->getQuantite() + 1);
					$panierNettoyeur[$request->getParameter("id_nettoyeur")] = $commandeArticle;
					$existe = true;
				}
			}

			if(!$existe)
			{
				$commandeArticle = new CommandeArticle();
				$commandeArticle->setIdNettoyeur($request->getParameter("id_nettoyeur"));
				$commandeArticle->setQuantite(1);
				$commandeArticle->setPrixUnitaireHt($nettoyeur->getPrixVenteThs());
				$panierNettoyeur[$request->getParameter("id_nettoyeur")] = $commandeArticle;
			}

			$panier['nettoyeur'] = $panierNettoyeur;
			$this->getUser()->setAttribute("commande_articles", $panier);

			$this->getUser()->setFlash("panier_ajout", true);

			// Redirection vers la page d'article
			$this->redirect("@url_nettoyeur?marque=".Utils::slugify($nettoyeur->getMarque()->getLibelle())."&modele=".Utils::slugify($nettoyeur->getModele()));
		}
		else
		{
			$this->forward404();
		}
	}

	/**
	 * Executes supprimer action
	 *
	 * @param sfRequest $request A request object
	 */
	public function executeSupprimer(sfWebRequest $request)
	{
		if(!$this->getUser()->hasAttribute("commande"))
		{
			$this->redirect("@panier");
		}

		$panier = $this->getUser()->getAttribute("commande_articles");

		if($request->hasParameter("id_article"))
		{
			// On vérifie que l'article n'existe pas déjà
			$panierArticle = $panier['article'];

			if(isset($panierArticle[$request->getParameter("id_article")]))
			{
				$article = $panierArticle[$request->getParameter("id_article")];
				if($article->getIdCommandeArticle() != "")
				{
					$article->delete();
				}
				unset($panierArticle[$request->getParameter("id_article")]);
			}
			$panier['article'] = $panierArticle;

		}
		else if($request->hasParameter("id_nettoyeur"))
		{
			// On vérifie que l'article n'existe pas déjà
			$panierNettoyeur = $panier['nettoyeur'];

			if(isset($panierNettoyeur[$request->getParameter("id_nettoyeur")]))
			{
				$article = $panierNettoyeur[$request->getParameter("id_nettoyeur")];
				if($article->getIdCommandeArticle() != "")
				{
					$article->delete();
				}
				unset($panierNettoyeur[$request->getParameter("id_nettoyeur")]);
			}
			$panier['nettoyeur'] = $panierNettoyeur;
		}
		else
		{
			$this->forward404();
		}

		$this->getUser()->setAttribute("commande_articles", $panier);

		// Redirection vers la page d'article
		$this->redirect("@panier");
	}

	public function executeModePaiement(sfWebRequest $request)
	{
		if(!$this->getUser()->hasAttribute("commande"))
		{
			$this->redirect("@panier");
		}
		$commande = $this->getUser()->getAttribute("commande");
		$commande_articles = $this->getUser()->getAttribute("commande_articles");
		
		// Vérifie que le code postal est OK
		if(sizeof($panier['nettoyeur']) > 0 && (substr($commande->getCodePostal(), 0, 2 ) == "20" || substr($commande->getCodePostal(), 0, 2 ) == "97"))
		{
			$this->redirect("@panier_recapitulatif");
		}
		
		$annule_minimum_commande = false;
			
		if(sizeof($commande_articles['article']) > 0)
		{
			foreach ($commande_articles['article'] as $article) 
			{
				$_article = Doctrine::getTable("Article")->find($article->getIdArticle());
				if($_article->getMinimumCommande())
				{
					$annule_minimum_commande = true;
					break;
				}
			}
		}
		// Vérifie que la commande minimum est atteint
		if($commande->getMailCommande() == 0 && !$annule_minimum_commande)
		{
			$resultat = $this->calculerCommande();
			if($resultat['totalTTC'] < $resultat['minimumCommande'])
			{
				$this->redirect("@panier");
			}
		}
		
		sfContext::getInstance()->getConfiguration()->loadHelpers("Url");
		$filAriane = ' > <a href="'.url_for("@panier_paiement").'">Paiement de la commande</a>';
		$this->getUser()->setFlash("filAriane", $filAriane);
		$this->getResponse()->addMeta('title', "Paiement de la commande");
		$this->getResponse()->addMeta('description', "Paiement de la commande");

		$this->recalculerCommande();
	}

	private function envoieMailCommande($client, $commande, $articles)
	{
		$modePaiement = sfConfig::get('app_commande_moyen_paiement_libelle');
		sfContext::getInstance()->getConfiguration()->loadHelpers("Number");
		
		$body = "<table style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:600px;'>
					<tr>
						<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;'><strong>Id client:</strong> ".strtoupper($client->getNom().$client->getPrenom())."<br /><strong>email:</strong> ".$client->getEmail()."</td>
						<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;'><strong>Date de création:</strong> ".$commande->getDateCreationFr()."<br /><strong>N° de commande:</strong> ".$commande->getIdCommande()."</td>
					</tr>
					<tr>
						<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;text-align:center'>FACTURATION</td>
						<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;text-align:center'>LIVRAISON</td>
					</tr>
					<tr>
						<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;'>
							<strong>Type:</strong> ".strtoupper($client->getType())."<br />
							<strong>Civilité:</strong> ".strtoupper($client->getCivilite())."<br />
							<strong>Nom/Raison Sociale:</strong> ".($client->getType() == "Société"? strtoupper($commande->getRaisonSociale()): strtoupper($commande->getNom()))."<br />
							<strong>Prénom:</strong> ".strtoupper($client->getPrenom())."<br />
							<strong>Adresse:</strong> ".strtoupper($client->getAdresse())."<br />
							<strong>Complément d'adresse:</strong> ".strtoupper($client->getAdresseComplement())."<br />
							<strong>Code postal:</strong> ".strtoupper($client->getCodePostal())."<br />
							<strong>Ville:</strong> ".strtoupper($client->getVille())."<br />
							<strong>Tel:</strong> ".$client->getTelephone()."<br />
							<strong>Fax:</strong> ".$client->getFax()."
						</td>
						<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;'>
							<strong>Civilité:</strong> ".strtoupper($commande->getCivilite())."<br />
							<strong>Nom/Raison Sociale:</strong> ".($client->getType() == "Société"? strtoupper($commande->getRaisonSociale()): strtoupper($commande->getNom()))."<br />
							<strong>Prénom:</strong> ".strtoupper($commande->getPrenom())."<br />
							<strong>Adresse:</strong> ".strtoupper($commande->getAdresse())."<br />
							<strong>Complément d'adresse:</strong> ".strtoupper($commande->getAdresseComplement())."<br />
							<strong>Code postal:</strong> ".strtoupper($commande->getCodePostal())."<br />
							<strong>Ville:</strong> ".strtoupper($commande->getVille())."<br />
							<strong>Tel:</strong> ".$commande->getTelephone()."<br />
							<strong>Fax:</strong> ".$commande->getFax()."
						</td>
					</tr>
					<tr>
						<td colspan='2' style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;'><strong>Note sur livraison:</strong> ".$commande->getNoteLivraison()."</td>
					</tr>
					<tr>
						<td colspan='2' style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;'><strong>Montant HT:</strong> ".format_currency($commande->getTotalHt())."€ - <strong>Montant TTC:</strong> ".format_currency($commande->getTotalTtc())."€</td>
					</tr>
					<tr>
						<td colspan='2' style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;'>
							<table style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:100%;'>
								<tr>
									<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;'>Ref Site</td>
									<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;'>Ref Interne</td>
									<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;'>Quantité</td>
									<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;'>Prix Unit. HT</td>
									<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;'>Prix Total HT</td>
								</tr>";
		foreach ($articles['article'] as $key => $commandeArticle)
		{
			$article = Doctrine_Core::getTable('Article')->find($commandeArticle->getIdArticle());
			$body .= "<tr>
					<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;'>".$article->getReferenceThsAffichage()."</td>
					<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;'><strong>".$article->getReferenceThsSage()."</strong></td>
					<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;'>".$commandeArticle->getQuantite()."</td>
					<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;'>".format_currency($commandeArticle->getPrixUnitaireHt())."</td>
					<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;'>".format_currency($commandeArticle->getPrixTotalHt())."</td>
				</tr>";
		}

		foreach ($articles['nettoyeur'] as $key => $commandeArticle)
		{
			$nettoyeur = Doctrine_Core::getTable('NettoyeurHautePression')->find($commandeArticle->getIdNettoyeur());
			$body .= "<tr>
					<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;'>".$nettoyeur->getReferenceThs()."</td>
					<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;'><strong>".$nettoyeur->getReferenceConstructeur()."</strong></td>
					<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;'>".$commandeArticle->getQuantite()."</td>
					<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;'>".format_currency($commandeArticle->getPrixUnitaireHt())."</td>
					<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;'>".format_currency($commandeArticle->getPrixTotalHt())."</td>
				</tr>";
		}

		$statutCommande = sfConfig::get('app_commande_statut_libelle');
		$body .= "			</table>
						</td>
					</tr>
					<tr>
						<td colspan='2' style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;'><strong>Port HT:</strong> ".format_currency($commande->getFraisPortHt())."€</td>
					</tr>
					<tr>
						<td colspan='2' style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;'><strong>Frais de gestion HT:</strong> ".format_currency($commande->getFraisGestionHT())."€</td>
					</tr>
					<tr>
						<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;'><strong>Mode de paiement:</strong> ".$modePaiement[$commande->getMoyenPaiement()]."</td>
						<td style='border-collapse:collapse;border-color:#000;border-style:solid;border-width:1px;width:300px;'><strong>Statut de la commande:</strong> ".$statutCommande[$commande->getIdStatut()]."</td>
					</tr>
				</table>";
		$body .= "<br /><br /><br /><br /><br /><br />".$body;

		
		$header = "Un paiement a été effectué sur le site <a href='http://www.haute-pression.com' target='_blank'>http://www.haute-pression.com</a><br /><br/>";
		$header .= "Mode de paiement : ".$modePaiement[$commande->getMoyenPaiement()]."<br />";
		$header .= "Prix Total TTC : ".format_currency($commande->getTotalTtc())."€<br />";
		$header .= "Numéro de la commande : ".$commande->getIdCommande()."<br />";
		
		if($commande->getMoyenPaiement() == 1)
		{
			$header .= "Date de la transaction : ".Utils::dateEnToFr($commande->getDateTransaction())."<br />";
			$header .= "Référence de la transaction : ".$commande->getNumeroTransaction()."<br />";
			$header .= "Numéro de la carte : ".$commande->getNumeroCarte()."<br />";
			$header .= "Certificat de la transaction : ".$commande->getCertificatTransaction()."<br />";
		}
		
		$id_suiveur = $commande->getIdUserSuiveur();
		if(!empty($id_suiveur))
		{
			// on récupère le commercial 
			$commercial = Doctrine_Core::getTable("sfGuardUser")->find($id_suiveur);
			$header .= "<b>Commercial : ".$commercial->getUsername()."</b><br />";
		}
		
		$body = $header."<br /><br />".$body;
		
		$message = Swift_Message::newInstance()
		->setSubject('Nouvelle commande')
		->setFrom(array(sfConfig::get("app_paiement_email") => 'Commande Haute pression'));
		if(!empty($id_suiveur))
		{
			$message->setTo(array(sfConfig::get("app_paiement_email")=>'Commande Haute pression', sfConfig::get("app_paiement_email_1")=>'Commande Haute pression', sfConfig::get("app_paiement_email_2")=>'Commande Haute pression', sfConfig::get("app_paiement_email_3")=>'Commande Haute pression', $commercial->getUsername()=>$commercial->getLastName()." ".$commercial->getFirstName()));
		}
		else
		{
			$message->setTo(array(sfConfig::get("app_paiement_email")=>'Commande Haute pression', sfConfig::get("app_paiement_email_1")=>'Commande Haute pression', sfConfig::get("app_paiement_email_2")=>'Commande Haute pression', sfConfig::get("app_paiement_email_3")=>'Commande Haute pression'));
		}
		$message->setBcc(array('yenkong@lybliamay.fr'=>'Commande Haute pression'))
		->setBody($body, 'text/html');
			
		$this->getMailer()->send($message);

		$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "PANIER PAIEMENT AUTOMATIC - ENVOI MAIL COMMANDE")));
	}

	public function executeFinPaiement(sfWebRequest $request)
	{
		if(!$this->getUser()->hasAttribute("commande"))
		{
			$this->redirect("@panier");
		}
		
		// Vérifie que la commande minimum est atteint
		$commande = $this->getUser()->getAttribute("commande");
		$commande_articles = $this->getUser()->getAttribute("commande_articles");
		
		$annule_minimum_commande = false;
			
		if(sizeof($commande_articles['article']) > 0)
		{
			foreach ($commande_articles['article'] as $article) 
			{
				$_article = Doctrine::getTable("Article")->find($article->getIdArticle());
				if($_article->getMinimumCommande())
				{
					$annule_minimum_commande = true;
					break;
				}
			}
		}
		
		if($commande->getMailCommande() == 0 && !$annule_minimum_commande)
		{
			$resultat = $this->calculerCommande();
			if($resultat['totalTTC'] < $resultat['minimumCommande'])
			{
				$this->redirect("@panier");
			}
		}
		
		$this->commande = $this->getUser()->getAttribute("commande");
		$this->commande_articles = $this->getUser()->getAttribute("commande_articles");
		$this->client = Doctrine_Core::getTable('Client')->find($this->commande->getIdClient());

		if($request->isMethod("POST"))
		{
			sfContext::getInstance()->getConfiguration()->loadHelpers("Url");
			$filAriane = ' > <a href="'.url_for("@panier_fin").'">Finalisation de la commande</a>';
			$this->getUser()->setFlash("filAriane", $filAriane);
			$this->getResponse()->addMeta('title', "Finalisation de la commande");
			$this->getResponse()->addMeta('description', "Finalisation de la commande");

			if($request->hasParameter('modePaiement'))
			{
				$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "PANIER PAIEMENT CHEQUE - DEBUT")));

				$this->commande->setIdStatut(sfConfig::get("app_commande_statut_attente_paiement"));
				$this->commande->setMoyenPaiement(sfConfig::get("app_commande_moyen_paiement_cheque"));
				$this->commande->save();

				$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "PANIER PAIEMENT CHEQUE - ORDER ID ".$this->commande->getIdCommande())));

				// Mise à jour de la commande
				$this->modePaiement = 0;

				$this->getUser()->getAttributeHolder()->remove('commande');
				$this->getUser()->getAttributeHolder()->remove('commande_articles');

				// envoi email client
				$email_client = $this->commande->getEmail();

				if ($email_client != '')
				{
					$headers = "From: webmaster@haute-pression.com\n" .
					 "MIME-Version: 1.0\nContent-type: text/html; charset=UTF-8\n" .
					 "Reply-To: webmaster@haute-pression.com\n" ;
					$headers .= "Bcc: yenkong@lybliamay.fr\n" ;

					$emailSujet_client = "Votre commande www.haute-pression.com - Ref ".$this->commande->getIdCommande();
					$emailCorps_client = "Technique Haute pression & Sablage<br>\r\nLe Grand Colombier<br>\r\n24150 - BAYAC<br>\r\nFRANCE<br><br>\r\n\r\nTel: (+33 0)5 53 61 11 86<br>\r\n(+33 0)9 77 07 64 85<br>\r\nFax:(+33 0)5 53 58 39 98<br><br>\r\n\r\nEmail: contact@haute-pression.com<br><br>\r\n\r\n";
					$emailCorps_client .= "Cher Client,<br><br>\r\n\r\nVotre commande a bien été pris en compte. Nous vous prions de bien vouloir nous retourner le détail de la commande ainsi qu'un chèque d'un montant de ".Utils::doubleEnToFr($this->commande->getTotalTtc())." € à l'ordre de \"Technique Haute pression & Sablage\".<br>\r\nVotre référence de commande est : ".$this->commande->getIdCommande()."<br><br>\r\n\r\n" ;
					$emailCorps_client .= "<br><br>\r\n\r\nVous pouvez accéder à tout instant à votre suivi commande et à votre compte <b><a href='http://www.haute-pression.com/espace-client/mes-commandes.html'>sous ce lien</a></b>.<br><br>\r\n\r\n";
					$emailCorps_client .= "Nous procéderons au traitement de celle-ci dès la réception du chèque.<br><br>\r\n\r\nCordialement,<br><br>\r\n\r\nL'équipe THS<br>\r\n\r\n";
					$reponseMail = mail($email_client, $emailSujet_client, $emailCorps_client, $headers);
					if($reponseMail)
					{
						$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "DEVIS PAIEMENT CHEQUE - ENVOI MAIL CLIENT OK ".$email_client)));
					}
					else
					{
						$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "DEVIS PAIEMENT CHEQUE - ENVOI MAIL CLIENT KO ".$email_client)));
					}
				}

				$this->envoieMailCommande($this->client, $this->commande, $this->commande_articles);
				$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "PANIER PAIEMENT CHEQUE - FIN")));
			}
			elseif($request->hasParameter('PAIEMENT'))
			{
				$message="message=".$request->getParameter('DATA');
				$pathfile="pathfile=".sfConfig::get("app_paiement_chemin")."cgi-bin/citelis/param/pathfile";
				$path_bin = sfConfig::get("app_paiement_chemin")."cgi-bin/citelis/bin/response";
				$result=exec("$path_bin $pathfile $message");

				$tableau = explode ("!", $result);

				$code = $tableau[1];
				$error = $tableau[2];
				$merchant_id = $tableau[3];
				$merchant_country = $tableau[4];
				$amount = $tableau[5];
				$transaction_id = $tableau[6];
				$payment_means = $tableau[7];
				$transmission_date= $tableau[8];
				$payment_time = $tableau[9];
				$payment_date = $tableau[10];
				$response_code = $tableau[11];
				$payment_certificate = $tableau[12];
				$authorisation_id = $tableau[13];
				$currency_code = $tableau[14];
				$card_number = $tableau[15];
				$cvv_flag = $tableau[16];
				$cvv_response_code = $tableau[17];
				$bank_response_code = $tableau[18];
				$complementary_code = $tableau[19];
				$complementary_info = $tableau[20];
				$return_context = $tableau[21];
				$caddie = $tableau[22];
				$receipt_complement = $tableau[23];
				$merchant_language = $tableau[24];
				$language = $tableau[25];
				$customer_id = $tableau[26];
				$order_id = $tableau[27];
				$customer_email = $tableau[28];
				$customer_ip_address = $tableau[29];
				$capture_day = $tableau[30];
				$capture_mode = $tableau[31];
				$data = $tableau[32];
				
				if (($code == "") && ($error == ""))
				{
					$this->modePaiement = 1;
				}
				elseif ($code != 0)
				{
					$this->modePaiement = 1;
				}
				else
				{
					switch ($response_code)
					{
						case '0' :
						case '00' :
							$msg = "Autorisation acceptée";
							break;

						case '02' :
							$msg = "Demande d'autorisation par téléphone à la banque à cause d'un dépassement de plafond d'autorisation sur la carte";
							break;

						case  '03' :
							$msg = "Champ 'merchant_id' invalide";
							break;

						case  '05' :
							$msg = "Autorisation refusée";
							break;

						case  '12' :
							$msg = "Transaction invalide, vérifier les paramètres transférés dans la requête.";
							break;

						case  '17' :
							$msg = "Annulation de l'internaute";
							break;

						case  '30' :
							$msg = "Erreur de format";
							break;

						case  '34' :
							$msg = "Suspicion de fraude";
							break;

						case  '75' :
							$msg = "Nombre de tentatives de saisie du numéro de carte dépassé. ";
							break;

						case  '90' :
							$msg = "Service temporairement indisponible";
							break;

						default :
							$msg = "Valeur du champ 'response_code' inconnue : " . $response_code ;
							break;
					}

					$emailCorps = "";

					if (($response_code != '00') && ($response_code != '0'))
					{
						$this->modePaiement = 2;
					}
					else
					{
						$this->modePaiement = 3;
					}
				}

				$this->getUser()->getAttributeHolder()->remove('commande');
				$this->getUser()->getAttributeHolder()->remove('commande_articles');
			}
			else
			{
				$this->redirect("@panier_paiement");
			}
		}
		
	    $this->configMinimumFraisDePort = ConfigTable::getMinimumFraisDePort();
	    $this->configMinimumFraisDeGestion = ConfigTable::getMinimumFraisDeGestion();
	    $this->configFraisDeGestionHT = ConfigTable::getFraisDeGestion();
	}

	public function executeFinPaiementAutomatic(sfWebRequest $request)
	{
		$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "PANIER PAIEMENT AUTOMATIC - DEBUT")));
		if($request->isMethod("POST"))
		{
			$message="message=".$request->getParameter('DATA');
			$pathfile="pathfile=".sfConfig::get("app_paiement_chemin")."cgi-bin/citelis/param/pathfile";
			$path_bin = sfConfig::get("app_paiement_chemin")."cgi-bin/citelis/bin/response";
			$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "PANIER PAIEMENT AUTOMATIC - REQUEST $path_bin $pathfile $message")));
			$result=exec("$path_bin $pathfile $message");
			$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "PANIER PAIEMENT AUTOMATIC - RESULT ".$result)));
			$tableau = explode ("!", $result);

			$code = $tableau[1];
			$error = $tableau[2];
			$merchant_id = $tableau[3];
			$merchant_country = $tableau[4];
			$amount = $tableau[5];
			$transaction_id = $tableau[6];
			$payment_means = $tableau[7];
			$transmission_date= $tableau[8];
			$payment_time = $tableau[9];
			$payment_date = $tableau[10];
			$response_code = $tableau[11];
			$payment_certificate = $tableau[12];
			$authorisation_id = $tableau[13];
			$currency_code = $tableau[14];
			$card_number = $tableau[15];
			$cvv_flag = $tableau[16];
			$cvv_response_code = $tableau[17];
			$bank_response_code = $tableau[18];
			$complementary_code = $tableau[19];
			$complementary_info = $tableau[20];
			$return_context = $tableau[21];
			$caddie = $tableau[22];
			$receipt_complement = $tableau[23];
			$merchant_language = $tableau[24];
			$language = $tableau[25];
			$customer_id = $tableau[26];
			$order_id = $tableau[27];
			$customer_email = $tableau[28];
			$customer_ip_address = $tableau[29];
			$capture_day = $tableau[30];
			$capture_mode = $tableau[31];
			$data = $tableau[32];

			$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "PANIER PAIEMENT AUTOMATIC - ORDER ID ".$order_id)));
				
			$commande = Doctrine_Core::getTable("Commande")->find($order_id);

			if (($code == "") && ($error == ""))
			{
				$msg = "Erreur lors de l'initialisation du paiement";
				$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "PANIER PAIEMENT AUTOMATIC - ERROR ".$msg)));

				// Mise à jour de la commande
				$commande->setIdStatut(sfConfig::get("app_commande_statut_echec_paiement"));
				$commande->save();
			}
			elseif ($code != 0)
			{
				$msg = "API call error";
				$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "PANIER PAIEMENT AUTOMATIC - ERROR ".$msg)));

				// Mise à jour de la commande
				$commande->setIdStatut(sfConfig::get("app_commande_statut_echec_paiement"));
				$commande->save();
			}
			else
			{
				switch ($response_code)
				{
					case '0' :
					case '00' :
						$msg = "Autorisation acceptée";
						break;

					case '02' :
						$msg = "Demande d'autorisation par téléphone à la banque à cause d'un dépassement de plafond d'autorisation sur la carte";
						break;

					case  '03' :
						$msg = "Champ 'merchant_id' invalide";
						break;

					case  '05' :
						$msg = "Autorisation refusée";
						break;

					case  '12' :
						$msg = "Transaction invalide, vérifier les paramètres transférés dans la requête.";
						break;

					case  '17' :
						$msg = "Annulation de l'internaute";
						break;

					case  '30' :
						$msg = "Erreur de format";
						break;

					case  '34' :
						$msg = "Suspicion de fraude";
						break;

					case  '75' :
						$msg = "Nombre de tentatives de saisie du numéro de carte dépassé. ";
						break;

					case  '90' :
						$msg = "Service temporairement indisponible";
						break;

					default :
						$msg = "Valeur du champ 'response_code' inconnue : " . $response_code ;
						break;
				}
				$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "PANIER PAIEMENT AUTOMATIC - MESSAGE ".$msg)));

				$emailCorps = "";
				
				// Mise à jour de la commande
				$commande->setIdStatut(sfConfig::get("app_commande_statut_paye"));
				$commande->setMoyenPaiement(sfConfig::get("app_commande_moyen_paiement_ligne"));
				$commande->setNumeroTransaction($transaction_id);
				$commande->setNumeroCarte($card_number);
				$commande->setCertificatTransaction($payment_certificate);
				$commande->setDateTransaction(substr($payment_date, 0, 4)."-".substr($payment_date, 4, 2)."-".substr($payment_date, 6, 2)." ".substr($payment_time, 0, 2).":".substr($payment_time, 2, 2).":".substr($payment_time, 4, 2));
				$commande->save();

				if (($response_code != '00') && ($response_code != '0'))
				{
					$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "PANIER PAIEMENT AUTOMATIC - PAIEMENT REFUSE")));
						
					$emailSujet = "Un paiement a été refusé sur le site www.haute-pression.com";
					$emailCorps .= "Bonjour,\n<br>\n<br>Un paiement a été refusé sur le site http://www.haute-pression.com\n<br>";
					$emailCorps .= "Numéro de Commande : " . $order_id . "\nMontant : " . ($amount / 100) . " EUR\n<br>\n<br>";
					$emailCorps .= "Code de retour : " . $response_code . "\n<br>Message : " . $msg . "\n<br>";
					$OrderStatus = "paiement refusé" ;
						
					// Mise à jour de la commande
					$commande->setIdStatut(sfConfig::get("app_commande_statut_echec_paiement"));
					$commande->save();
				}
				else
				{
					// On récupère les règles
					$rules = Doctrine_Core::getTable("CritereEnvoi")->findAll();
					$type = $commande->getType();
					$nbCommandes = Doctrine_Core::getTable("Commande")->countByCustomer($commande->getIdClient());
					$nbCommandes = $nbCommandes[0]['count'];
					$nbQuantite = 0;

					foreach ($commande->getCommandeArticles() as $article) {
					    $nbQuantite += $article->getQuantite();
					}

					$totalCommande = $commande->getTotalTtc();
					
					foreach ($rules as $rule) {
						if ($commande->getType() == $rule->getType() || $rule->getType() == '') {
							// Est ce que le client a déjà reçu l'article spécial
							$nb_special_article = Doctrine_Core::getTable("Commande")->alreadyBuyArticle($commande->getIdClient(), $rule->getReferenceThs());
							
							if (count($nb_special_article) > 0) {
							    continue;
							}
							
							$rncs = $rule->getNumeroCommandeSigne();
							$rnc = $rule->getNumeroCommande();
							$rnas = $rule->getNombreArticleSigne();
							$rna = $rule->getNombreArticle();
							$rtcs = $rule->getTotalCommandeSigne();
							$rtc = $rule->getTotalCommande();
							
							$isOK = eval("return ($nbCommandes $rncs $rnc && $nbQuantite $rnas $rna && $totalCommande $rtcs $rtc);");

							if ($isOK) {
								$commandeArticle = new CommandeArticle();
								$commandeArticle->setIdArticle($rule->getReferenceThs());
								$commandeArticle->setQuantite(1);
								$commandeArticle->setPrixUnitaireHt(0);
								$commandeArticle->setIdCommande($commande->getIdCommande());
								$commandeArticle->setPrixTotalHt(0);
								$commandeArticle->setPrixTotalTtc(0);
								$commandeArticle->save();
							}
						}
					}
					
					$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "PANIER PAIEMENT AUTOMATIC - PAIEMENT EFFECTUE")));
						
					$emailSujet = "Un paiement a été effectué sur le site www.haute-pression.com";
					$emailCorps .= "Bonjour,\n<br>\n<br>Un paiement a été effectué sur le site http://www.haute-pression.com\n<br>";
					$emailCorps .= "Numéro de Commande : " . $commande->getIdCommande() . "\n<br>Montant : " . ($amount / 100) . " EUR\n<br>\n<br>";
					$OrderStatus = "payée" ;

					// envoi email client
					$email_client = utf8_decode(str_replace('"' , '&quot;' , $commande->email)) ;

					if ($email_client != '')
					{
						$headers = "From: webmaster@haute-pression.com\n" .
						"MIME-Version: 1.0\nContent-type: text/html; charset=UTF-8\n" .
						"Reply-To: webmaster@haute-pression.com\n" ;
						$headers .= "Bcc: yenkong@lybliamay.fr\n" ;

						$emailSujet_client = "Votre commande www.haute-pression.com - Ref ".$commande->getIdCommande() ;
						$emailCorps_client = "Technique Haute pression & Sablage<br>\r\nLe Grand Colombier<br>\r\n24150 - BAYAC<br>\r\nFRANCE<br><br>\r\n\r\nTel: (+33 0)5 53 61 11 86<br>\r\n(+33 0)9 77 07 64 85<br>\r\nFax:(+33 0)5 53 58 39 98<br><br>\r\n\r\nEmail: contact@haute-pression.com<br><br>\r\n\r\n";
						$emailCorps_client .= "Cher Client,<br><br>\r\n\r\nVotre commande et votre règlement ont bien été pris en compte.<br>\r\nVotre référence de commande est : ".$commande->getIdCommande()."<br><br>\r\n\r\n" ;
						$emailCorps_client .= "<br><br>\r\n\r\nVous pouvez accéder à tout instant à votre suivi commande et à votre compte <b><a href='http://www.haute-pression.com/espace-client/mes-commandes.html'>sous ce lien</a></b>.<br><br>\r\n\r\n";
						$emailCorps_client .= "Nous procédons au traitement de celle-ci dans les plus brefs délais.<br><br>\r\n\r\nCordialement,<br><br>\r\n\r\nL'équipe THS<br>\r\n\r\n";
						mail($email_client, $emailSujet_client, $emailCorps_client, $headers);

						$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "PANIER PAIEMENT AUTOMATIC - ENVOI MAIL CLIENT")));
					}
				}

				$emailTo = sfConfig::get("app_paiemeil");
				$headers = "From: webmaster@haute-pression.com\n" .
					"MIME-Version: 1.0\nContent-type: text/html; charset=UTF-8\n" .
					"Reply-To: webmaster@haute-pression.com\nnt_ema" ;
				$headers .= "Bcc: yenkong@lybliamay.fr\n" ;
				mail($emailTo , $emailSujet , $emailCorps , $headers) ;

				$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "PANIER PAIEMENT AUTOMATIC - ENVOI MAIL ADMIN")));
			}

			$client = Doctrine_Core::getTable("Client")->find($commande->getIdClient());
			$commandeArticles = Doctrine_Core::getTable("CommandeArticle")->findByIdCommande($order_id);
			$commande_articles["nettoyeur"] = array();
			$commande_articles["article"] = array();
			foreach ($commandeArticles as $commandeArticle)
			{
				if($commandeArticle->getIdNettoyeur() != "")
				{
					$commande_articles["nettoyeur"][] = $commandeArticle;
				}
				else
				{
					$commande_articles["article"][] = $commandeArticle;
				}
			}
			$this->envoieMailCommande($client, $commande, $commande_articles);
		}
		$this->dispatcher->notify(new sfEvent($this, 'application.log', array("message" => "PANIER PAIEMENT AUTOMATIC - FIN")));
		return sfView::NONE;
	}

	private function recalculerCommande()
	{
		$tva = Doctrine_Core::getTable("TauxTVA")->find(sfConfig::get('app_tva_196'));
		$panier = $this->getUser()->getAttribute("commande_articles");
		$commande = $this->getUser()->getAttribute("commande");
		$commande->save();

		// Informations pour la commande
		$francoDePort = 0;
		$horsGabarit = 0;
		$totalPoids = 0;

		$totalProduitsHTTemp = 0;
		$totalProduitsHT = 0;
		$totalProduitsTTC = 0;
		$totalPortHT = 0;
		$fraisDeGestionHT = 0;
		$totalHT = 0;
		$totalTVA = 0;
		$totalTTC = 0;

		// Traitement des articles
		$articles = $panier['article'];
		foreach($articles as $key => $commandeArticle)
		{
			$_article = Doctrine_Core::getTable("Article")->find($key);

			$totalProduitsHTTemp += $_article->getPrixVenteThs() * $commandeArticle->getQuantite();
			$totalProduitsHT += $_article->getPrixVenteThs() * $commandeArticle->getQuantite();
			$totalPoids += Utils::doubleFrToEn($_article->getPoids()) * $commandeArticle->getQuantite();
			$totalTVA += $_article->getPrixVenteThs() * $commandeArticle->getQuantite() * $tva->getTaux() / 100;

			if($_article->getHorsGabarit())
			{
				$horsGabarit = 1;
			}

			$commandeArticle->setIdCommande($commande->getIdCommande());
			$commandeArticle->prix_unitaire_ht = $_article->getPrixVenteThs();
			$commandeArticle->prix_total_ht = $_article->getPrixVenteThs() * $commandeArticle->getQuantite();
			$commandeArticle->prix_total_ttc = round($commandeArticle->prix_total_ht * (1 + $tva->getTaux() / 100), 2);
			$commandeArticle->save();
			$articles[$key] = $commandeArticle;
		}

		$totalProduitsTTC += $totalProduitsHTTemp * (1 + $tva->getTaux() / 100);
		$totalProduitsHTTemp = 0;
		$total_article = $totalProduitsTTC;
		
		/**
		 * Frais de port gratuit à partir d'un certain seuil
		 */
		$minimumFraisDePort = ConfigTable::getMinimumFraisDePort();

		if ($minimumFraisDePort > 0 && $totalProduitsTTC >= $minimumFraisDePort && $commande->getPays() == 'France') {
		    $francoDePort = true;
		}

		/**
		 * Frais de gestion en dessous d'un certain seuil
		 */
		$minimumFraisDeGestion = ConfigTable::getMinimumFraisDeGestion();

		if ($total_article <= $minimumFraisDeGestion) {
		    $fraisDeGestionHT = ConfigTable::getFraisDeGestion();
		}

		// Traitement des NHP
		$nhp = $panier['nettoyeur'];
		foreach($nhp as $key => $commandeArticle)
		{
			$_nettoyeur = Doctrine_Core::getTable("NettoyeurHautePression")->find($key);

			$totalProduitsHTTemp += $_nettoyeur->getPrixVenteThs() * $commandeArticle->getQuantite();
			$totalProduitsHT += $_nettoyeur->getPrixVenteThs() * $commandeArticle->getQuantite();
			$totalPoids += Utils::doubleFrToEn($_nettoyeur->getPoids()) * $commandeArticle->getQuantite();
			$totalTVA += $_nettoyeur->getPrixVenteThs() * $commandeArticle->getQuantite() * $tva->getTaux() / 100;

			if($_nettoyeur->getFrancoDePort())
			{
				$francoDePort = 1;
			}

			$commandeArticle->setIdCommande($commande->getIdCommande());
			$commandeArticle->prix_unitaire_ht = $_nettoyeur->getPrixVenteThs();
			$commandeArticle->prix_total_ht = $_nettoyeur->getPrixVenteThs() * $commandeArticle->getQuantite();
			$commandeArticle->prix_total_ttc = round($commandeArticle->prix_total_ht * (1 + $tva->getTaux() / 100), 2);
			$commandeArticle->save();
			$nhp[$key] = $commandeArticle;
		}

		$totalProduitsTTC += $totalProduitsHTTemp * (1 + $tva->getTaux() / 100);

		$panier['article'] = $articles;
		$panier['nettoyeur'] = $nhp;

		// Calcul frais de port
		if(!$francoDePort)
		{
			$tarif = ZoneTarifTable::calculFraisDePort($totalPoids * 1000, $horsGabarit, $commande->getCodePostal());
			if(sizeof($tarif) > 0)
			{
				$tarif = $tarif[0];
				$totalPortHT = $tarif->getZone()->getTransporteur()->getForfaitEmballage() + $tarif->getTarif();
				$totalTVA += $totalPortHT * $tva->getTaux() / 100;
			}
		}

		$totalPortTTC = Utils::prixAvecTVA($totalPortHT, $tva->getTaux());
		$fraisDeGestionTTC = Utils::prixAvecTVA($fraisDeGestionHT, $tva->getTaux());

		// Arrondi
		$totalProduitsTTC = round($totalProduitsTTC, 2);
		$totalPortTTC = round($totalPortTTC, 2);
		$totalTVA = round($totalTVA, 2);

		$totalHT = $totalProduitsHT + $totalPortHT + $fraisDeGestionHT;
		$totalTTC = $totalProduitsTTC + $totalPortTTC + $fraisDeGestionTTC;

		$commande->setPoidsTotal($totalPoids);
		$commande->frais_port_ht = $totalPortHT;
		$commande->frais_gestion_ht = $fraisDeGestionHT;
		$commande->total_produit_ht = $totalProduitsHT;
		$commande->total_ht = $totalHT;
		$commande->taux_tva = $tva->getTaux();
		$commande->total_ttc = round($totalTTC, 2);
		$commande->save();

		$this->getUser()->setAttribute("commande_articles", $panier);
		$this->getUser()->setAttribute("commande", $commande);
	}
	
	public function calculerCommande()
	{
		// Panier
		$nombre_articles = 0;
		if($this->getUser()->hasAttribute('commande_articles'))
		{
			$panier = $this->getUser()->getAttribute('commande_articles');
			$nombre_articles = sizeof($panier['article']) + sizeof($panier['nettoyeur']);
		}
		if($nombre_articles > 0)
		{
			$minimumCommande = ConfigTable::getMinimumCommande();
			$panier = $this->getUser()->getAttribute('commande_articles');

			// DonnÃ©es concernant frais de ports
			$francoDePort = 0;
			$horsGabarit = 0;
			$totalPoids = 0;

			$totalProduitsHTTemp = 0;
			$totalProduitsHT = 0;
			$totalProduitsTTC = 0;
			$totalPortHT = 0;
			$fraisDeGestionHT = 0;
			$totalHT = 0;
			$totalTVA = 0;
			$totalTTC = 0;
			$tva = Doctrine_Core::getTable("TauxTVA")->find(sfConfig::get('app_tva_196'));
				
			$nombre_total_articles = 0;
			$total_article = 0;

			foreach ($panier['article'] as $key => $commandeArticle)
			{
				$article = Doctrine::getTable("Article")->find($key);
				$totalProduitsHTTemp += $article->getPrixVenteThs() * $commandeArticle->getQuantite();
				$totalProduitsHT += $article->getPrixVenteThs() * $commandeArticle->getQuantite();
				$totalPoids += Utils::doubleFrToEn($article->getPoids()) * $commandeArticle->getQuantite();
				$totalTVA += $article->getPrixVenteThs() * $commandeArticle->getQuantite() * $tva->getTaux() / 100;
					
				if($article->getHorsGabarit())
				{
					$horsGabarit = 1;
				}
					
				$nombre_total_articles += $commandeArticle->getQuantite();
			}

			$totalProduitsTTC += $totalProduitsHTTemp * (1 + $tva->getTaux() / 100);
			$total_article = $totalProduitsTTC;
			$totalProduitsHTTemp = 0;
			
			/**
			 * Frais de port gratuit à partir d'un certain seuil
			 */
			$minimumFraisDePort = ConfigTable::getMinimumFraisDePort();
			
			if ($minimumFraisDePort > 0 && $total_article >= $minimumFraisDePort) {
			    $francoDePort = true;
			}
			
			/**
			 * Frais de gestion en dessous d'un certain seuil
			 */
			$minimumFraisDeGestion = ConfigTable::getMinimumFraisDeGestion();
			
			if ($total_article <= $minimumFraisDeGestion) {
			    $fraisDeGestionHT = ConfigTable::getFraisDeGestion();
			}

			foreach ($panier['nettoyeur'] as $key => $commandeArticle)
			{
				$nettoyeur = Doctrine::getTable("NettoyeurHautePression")->find($key);
				$totalProduitsHTTemp += $nettoyeur->getPrixVenteThs() * $commandeArticle->getQuantite();
				$totalProduitsHT += $nettoyeur->getPrixVenteThs() * $commandeArticle->getQuantite();
				$totalPoids += Utils::doubleFrToEn($nettoyeur->getPoids()) * $commandeArticle->getQuantite();
				$totalTVA += $nettoyeur->getPrixVenteThs() * $commandeArticle->getQuantite() * $tva->getTaux() / 100;
					
				if($nettoyeur->getFrancoDePort())
				{
					$francoDePort = 1;
				}
				$nombre_total_articles += $commandeArticle->getQuantite();
			}
			$totalProduitsTTC += $totalProduitsHTTemp * (1 + $tva->getTaux() / 100);

			if(!$francoDePort &&!$horsGabarit && $totalPoids <= 10)
			{
				$tarif = ZoneTarifTable::calculFraisDePort($totalPoids * 1000, 0, '69');
					
				if(sizeof($tarif) > 0)
				{
					$tarif = $tarif[0];
				}
				$totalPortHT = $tarif->getZone()->getTransporteur()->getForfaitEmballage() + $tarif->getTarif();
				$totalTVA += $totalPortHT * $tva->getTaux() / 100;
			}

			$totalPortTTC = Utils::prixAvecTVA($totalPortHT, $tva->getTaux());
			$fraisDeGestionTTC = Utils::prixAvecTVA($fraisDeGestionHT, $tva->getTaux());

			// Arrondi
			$totalProduitsTTC = round($totalProduitsTTC, 2);
			$totalPortTTC = round($totalPortTTC, 2);
			$totalTVA = round($totalTVA, 2);

			$totalHT = $totalProduitsHT + $totalPortHT + $fraisDeGestionHT;
			$totalTTC = $totalProduitsTTC + $totalPortTTC + $fraisDeGestionTTC;
			
			$resultat['minimumCommande'] = $minimumCommande;
			$resultat['nombre_articles'] = $nombre_articles;
			$resultat['nombre_total_articles'] = $nombre_total_articles;
			$resultat['totalProduitsHT'] = $totalProduitsHT;
			$resultat['fraisDeGestionHT'] = $fraisDeGestionHT;
			$resultat['francoDePort'] = $francoDePort;
			$resultat['horsGabarit'] = $horsGabarit;
			$resultat['totalPoids'] = $totalPoids;
			$resultat['totalPortHT'] = $totalPortHT;
			$resultat['totalHT'] = $totalHT;
			$resultat['totalTVA'] = $totalTVA;
			$resultat['totalTTC'] = $totalTTC;
			
			return $resultat;
		}
		else
		{
			return false;
		}
	}
	
	public function executeCommande(sfWebRequest $request)
	{
		// on récupère la commande
		$id_commande = $request->getParameter('id_commande');
		$token = $request->getParameter('token');
		$commande = Doctrine_Core::getTable("Commande")->findOneByIdCommandeAndCommandeToken($id_commande, $token);
		$this->forward404If(!($commande instanceof Commande));
		
		if($commande->getIdStatut() == sfConfig::get("app_commande_statut_cree"))
		{
			$this->getUser()->setAttribute("commande", $commande);
			
			// Récupérer les articles
			$panier = array();
			$panier['article'] = array();
			$panier['nettoyeur'] = array();
			
			$articles_commande = Doctrine_Core::getTable("CommandeArticle")->findByIdCommande($id_commande);
			
			foreach($articles_commande as $article)
			{
				if(!is_null($article->getIdArticle()))
				{
					$panier['article'][$article->getIdArticle()] = $article;
				}
				else if(!is_null($article->getIdNettoyeur()))
				{
					$panier['nettoyeur'][$article->getIdNettoyeur()] = $article;
				}
			}
			
			$this->getUser()->setAttribute("commande_articles", $panier);
			
			$this->forward("panier", "panier");
		}
	}
	
	public function executeRecupererArticleNHP(sfWebRequest $request)
	{
		if ($request->isXmlHttpRequest()) {
			$reference_ths_sage = $request->getPostParameter('reference_ths_sage');
			
			$donnees = array();
			$donnees['id_article'] = "";
			$donnees['reference_ths_sage'] = "";
			$donnees['reference_ths'] = "";
			$donnees['designation'] = "";
			$donnees['prix'] = "";
			$donnees['prix_ttc'] = "";
			$donnees['poids'] = "";
			
			$article = Doctrine::getTable("Article")->findOneByReferenceThsSage($reference_ths_sage);
			
			if ($article instanceof Article) {
				$donnees = array();
				$donnees['reference_ths_sage'] = $article->getReferenceThsSage();
				$donnees['reference_ths'] = $article->getReferenceThs();
				$donnees['reference_ths_affichage'] = $article->getReferenceThsAffichage();
				$donnees['designation'] = $article->getDesignationCourte();
				$donnees['prix'] = $article->getPrixVenteThs();
				$donnees['prix_ttc'] = $article->getPrixTtc();
				$donnees['poids'] = $article->getPoids();
			} else {
				$article = Doctrine::getTable("Article")->findOneByReferenceThs($reference_ths_sage);
				
				if ($article instanceof Article) {
					$donnees = array();
					$donnees['reference_ths_sage'] = $article->getReferenceThsSage();
					$donnees['reference_ths'] = $article->getReferenceThs();
					$donnees['reference_ths_affichage'] = $article->getReferenceThsAffichage();
					$donnees['designation'] = $article->getDesignationCourte();
					$donnees['prix'] = $article->getPrixVenteThs();
					$donnees['prix_ttc'] = $article->getPrixTtc();
					$donnees['poids'] = $article->getPoids();
				}
			}
			
			return $this->renderText(json_encode($donnees));
		}
		
		return sfView::NONE;
	}
	
	public function executeRechercherArticleNHP(sfWebRequest $request)
	{
		if ($request->isXmlHttpRequest()) {
			$reference_ths_sage = $request->getGetParameter('term');
			
			$donnees = array();
			$donnees['id_article'] = "";
			$donnees['reference_ths_sage'] = "";
			$donnees['reference_ths'] = "";
			$donnees['designation'] = "";
			$donnees['prix'] = "";
			$donnees['prix_ttc'] = "";
			$donnees['poids'] = "";
			
			$articles = Doctrine::getTable("Article")->searchArticleReferenceTHS($reference_ths_sage);
			$result = array();
			//var_dump(count($articles));
			foreach ($articles as $article) {
				$donnees = array();
				$donnees['id'] = $article->getReferenceThs();
				$donnees['affichage'] = $article->getReferenceThsAffichage();
				/*$donnees['value'] = $article->getReferenceThs();
				$donnees['designation'] = $article->getDesignationCourte();
				$donnees['prix'] = $article->getPrixVenteThs();
				$donnees['prix_ttc'] = $article->getPrixTtc();
				$donnees['poids'] = $article->getPoids();*/
				$result[] = $donnees;
			}
			
			return $this->renderText(json_encode($result));
		}
		
		return sfView::NONE;
	}
	
	public function executeAjouterArticlesNHP(sfWebRequest $request)
	{
		// Si le panier n'existe pas on le créé
		if (!$this->getUser()->hasAttribute("commande")) {
			$commande = new Commande();
			$commande->setIdStatut(sfConfig::get("app_commande_statut_cree"));
			$this->getUser()->setAttribute("commande", $commande);
			$this->getUser()->setAttribute("commande_articles", array("article" => array(), "nettoyeur" => array()));
		}
		
		$panier = $this->getUser()->getAttribute("commande_articles");

		if ($request->hasParameter("articles")) {
			$articles = $request->getParameter("articles");
			
			foreach ($articles as $line => $article) {
				$id_article = $article['reference'];
				
				if ($id_article == "") {
				    continue;
				}
				
				$qte = $article['qte'];
				
				$_article = Doctrine::getTable("Article")->find($id_article);
				
				if (!$_article) {
				    continue;
				}
				
				// On vérifie que l'article n'existe pas déjà
				$panierArticle = $panier['article'];

				$existe = false;
				
				foreach ($panierArticle as $id => $commandeArticle) {
					if ($id == $id_article) {
						$commandeArticle->setQuantite($commandeArticle->getQuantite() + $qte);
						$panierArticle[$id_article] = $commandeArticle;
						$existe = true;
					}
				}

				if (!$existe) {
					$commandeArticle = new CommandeArticle();
					$commandeArticle->setIdArticle($id_article);
					$commandeArticle->setQuantite($qte);
					$commandeArticle->setPrixUnitaireHt($_article->getPrixVenteThs());
					$panierArticle[$id_article] = $commandeArticle;
				}

				$panier['article'] = $panierArticle;
			}
			
			$this->getUser()->setAttribute("commande_articles", $panier);
			$this->getUser()->setFlash("panier_ajout", true);

		}
		
		
		if ($request->hasParameter("id")) {
		    $nhp = Doctrine::getTable("NettoyeurHautePression")->find($request->getParameter("id"));
		    $this->redirect($nhp->getUrlArticle());
		} else {
		    $this->redirect('@panier');
		}
	}
}
