<?php

/**
 * support actions.
 *
 * @package    sf_sandbox
 * @subpackage support
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class supportActions extends sfActions
{
	/**
	 * Executes index action
	 *
	 * @param sfRequest $request A request object
	 */
	public function executeIndex(sfWebRequest $request)
	{
		$email = $request->getParameter('email');
		$code = $request->getParameter('code');
		
		$this->forward404If(is_null($email) || is_null($code));
		
		$this->form = new MailReponseForm();
		
		if ($request->isMethod('post')) {
			// Enregistrement de la réponse
			$this->form->bind($request->getParameter($this->form->getName()), $request->getFiles($this->form->getName()));
			$parameter = $request->getParameter($this->form->getName());

			if ($this->form->isValid()) {
				$dbc = sfContext::getInstance()->getDatabaseManager()->getDatabase('doctrine')->getDoctrineConnection();
				$dbc->beginTransaction();
				
				try {
					$mail_sujet = Doctrine_Core::getTable('MailSujet')->find($parameter['id_mail_sujet']);
					$mail_sujet->setStatut(MailSujet::STATUT_REPONSE_CLIENT);
					$mail_sujet->save();

					$mail_reponse = new MailReponse();
					$mail_reponse->setMessage($parameter['message']);
					$mail_reponse->setIdMailSujet($parameter['id_mail_sujet']);
					$mail_reponse->setDateReponse(date("Y-m-d H:i:s"));
					$mail_reponse->save();
						
					for ($i = 1; $i <= 5; $i++) {
						$file = $this->form->getValue('image_'.$i);

						if (!is_null($file)) {
							$filename = uniqid().'_'.Utils::slugify($file->getOriginalName());
							$extension = $file->getExtension($file->getOriginalExtension());

							$imageInfo = getimagesize($file->getTempName());

							if ($imageInfo[0] > 1024) {
								$thumbnail = new sfThumbnail(1024);
								$thumbnail->loadFile($file->getTempName());
								$thumbnail->save(sfConfig::get('sf_upload_dir').'/mails/'.$filename.$extension, 'image/png');
							} else {
								$file->save(sfConfig::get('sf_upload_dir').'/mails/'.$filename.$extension);
							}

							if (file_exists(sfConfig::get('sf_upload_dir').'/mails/'.$filename.$extension)) {
								$thumbnail = new sfThumbnail(100, 100);
								$thumbnail->loadFile(sfConfig::get('sf_upload_dir').'/mails/'.$filename.$extension);
								$thumbnail->save(sfConfig::get('sf_upload_dir').'/mails/thumbnail/'.$filename.$extension, 'image/png');

								$mail_file = new MailFile();
								$mail_file->setName($filename.$extension);
								$mail_file->setType('image');
								$mail_file->setIdMailReponse($mail_reponse->getPrimaryKey());
								$mail_file->save();
							} else {
								throw new Exception("Erreur lors de l'enregistrement de l'image");
							}
						}

						$file = $this->form->getValue('pdf_'.$i);

						if (!is_null($file)) {
							$filename = uniqid().'_'.Utils::slugify($file->getOriginalName());
							$extension = $file->getExtension($file->getOriginalExtension());

							if ($file->save(sfConfig::get('sf_upload_dir').'/mails/'.$filename.$extension)) {
								$mail_file = new MailFile();
								$mail_file->setName($filename.$extension);
								$mail_file->setType('pdf');
								$mail_file->setIdMailReponse($mail_reponse->getPrimaryKey());
								$mail_file->save();
							} else {
								throw new Exception("Erreur lors de l'enregistrement du PDF");
							}
						}
					}
					
					$dbc->commit();
					 
					$receiver = $mail_sujet->getSfGuardUser()->getEmailAddress();
					$objet = 'THS : un client vient de vous répondre';
					$body = "<strong>Technique Haute-Pression et Sablage</strong><br>
Le Grand Colombier<br>
24150 - BAYAC<br>
France<br>
Tél: 05 53 61 11 86<br>
Fax: 05 53 58 39 98<br>
<br>
<strong>Email :</strong> contact@haute-pression.com<br>
Sarl au capital de 30 200 €. Siret 351617048 00019 - Ape 4669B<br>
<br>
Bonjour ".$mail_sujet->getUserAssignation().",<br><br>

Un client vient d'effectuer une réponse.<br><br>
Cliquer sur le lien suivant pour voir la réponse : <a href='http://www.haute-pression.com/backend.php/mail_sujet/repondre/".$mail_sujet->getId()."'>http://www.haute-pression.com/backend.php/mail_sujet/repondre/".$mail_sujet->getId()."</a>.<br><br>
Cordialement,<br>
http://www.haute-pression.com";

					$sender = array(sfConfig::get("app_contact_email") => 'Haute-pression.com');
					$mailing = $this->getMailer()->compose($sender, $receiver, $objet, '')->setBody($body, 'text/html');
					$this->mailEnvoye = $this->getMailer()->send($mailing);

					// Envoi mail au correspondant
					$this->form = new MailReponseForm();

					$this->getUser()->setFlash('notice', "Votre message a bien été enregistré et transmis à votre conseiller qui vous répondra dans les plus brefs délais. Nous vous remercions de votre confiance.");
				} catch (Exception $e) {
					$this->form->getErrorSchema()->addError(new sfValidatorError(new sfValidatorString(), $e->getMessage()), 'error_name');
					$dbc->rollback();
					$this->getUser()->setFlash('error', "Une erreure est survenu, veuillez vérifier votre message.");
				}
			}
		}
		
		$this->sujet = Doctrine_Core::getTable('MailSujet')->findOneByEmailAndCode($email, $code);
		$this->form->setDefault('id_mail_sujet', $this->sujet->getId());
	}
	/**
	 * Executes index action
	 *
	 * @param sfRequest $request A request object
	 */
	public function executeIndexNew(sfWebRequest $request)
	{
		$email = $request->getParameter('email');
		$code = $request->getParameter('code');
		
		$this->forward404If(is_null($email) || is_null($code));
		
		$this->form = new MailReponseForm();
		
		if ($request->isMethod('post')) {
			// Enregistrement de la réponse
			$this->form->bind($request->getParameter($this->form->getName()), $request->getFiles($this->form->getName()));
			$parameter = $request->getParameter($this->form->getName());
			
			if ($this->form->isValid()) {
				$dbc = sfContext::getInstance()->getDatabaseManager()->getDatabase('doctrine')->getDoctrineConnection();
				$dbc->beginTransaction();
				
				try {
					$mail_sujet = Doctrine_Core::getTable('MailSujet')->find($parameter['id_mail_sujet']);
					$mail_sujet->setStatut(MailSujet::STATUT_REPONSE_CLIENT);
					$mail_sujet->save();

					$mail_reponse = new MailReponse();
					$mail_reponse->setMessage($parameter['message']);
					$mail_reponse->setIdMailSujet($parameter['id_mail_sujet']);
					$mail_reponse->setDateReponse(date("Y-m-d H:i:s"));
					$mail_reponse->save();
						
					for ($i = 1; $i <= 5; $i++) {
						$file = $this->form->getValue('image_'.$i);

						if (!is_null($file)) {
							$filename = uniqid().'_'.Utils::slugify($file->getOriginalName());
							$extension = $file->getExtension($file->getOriginalExtension());

							$imageInfo = getimagesize($file->getTempName());

							if ($imageInfo[0] > 1024) {
								$thumbnail = new sfThumbnail(1024);
								$thumbnail->loadFile($file->getTempName());
								$thumbnail->save(sfConfig::get('sf_upload_dir').'/mails/'.$filename.$extension, 'image/png');
							} else {
								$file->save(sfConfig::get('sf_upload_dir').'/mails/'.$filename.$extension);
							}

							if (file_exists(sfConfig::get('sf_upload_dir').'/mails/'.$filename.$extension)) {
								$mail_file = new MailFile();
								$mail_file->setName($filename.$extension);
								$mail_file->setType('image');
								$mail_file->setIdMailReponse($mail_reponse->getPrimaryKey());
								$mail_file->save();
							} else {
								throw new Exception("Erreur lors de l'enregistrement de l'image");
							}
						}

						$file = $this->form->getValue('pdf_'.$i);

						if (!is_null($file)) {
							$filename = uniqid().'_'.Utils::slugify($file->getOriginalName());
							$extension = $file->getExtension($file->getOriginalExtension());

							if ($file->save(sfConfig::get('sf_upload_dir').'/mails/'.$filename.$extension)) {
								$mail_file = new MailFile();
								$mail_file->setName($filename.$extension);
								$mail_file->setType('pdf');
								$mail_file->setIdMailReponse($mail_reponse->getPrimaryKey());
								$mail_file->save();
							} else {
								throw new Exception("Erreur lors de l'enregistrement du PDF");
							}
						}
					}
					
					$dbc->commit();

					// Envoi mail au correspondant
					$this->form = new MailReponseForm();

					$this->getUser()->setFlash('notice', "Votre message a bien été enregistré et transmis à votre conseiller qui vous répondra dans les plus brefs délais. Nous vous remercions de votre confiance.");
				} catch (Exception $e) {
					$this->form->getErrorSchema()->addError(new sfValidatorError(new sfValidatorString(), $e->getMessage()), 'error_name');
					$dbc->rollback();
					$this->getUser()->setFlash('error', "Une erreure est survenu, veuillez vérifier votre message.");
				}
			}

		}
		
		$this->sujet = Doctrine_Core::getTable('MailSujet')->findOneByEmailAndCode($email, $code);
		$this->form->setDefault('id_mail_sujet', $this->sujet->getId());
	}
}
