<?php

/**
 * mail_sujet module configuration.
 *
 * @package    ##PROJECT_NAME##
 * @subpackage mail_sujet
 * @author     ##AUTHOR_NAME##
 * @version    SVN: $Id: configuration.php 24171 2009-11-19 16:37:50Z Kris.Wallsmith $
 */
abstract class BaseMail_sujetGeneratorConfiguration extends sfModelGeneratorConfiguration
{
  public function getActionsDefault()
  {
    return array();
  }

  public function getFormActions()
  {
    return array(  '_delete' => NULL,  '_list' => NULL,  '_save' => NULL,  '_save_and_add' => NULL,);
  }

  public function getNewActions()
  {
    return array();
  }

  public function getEditActions()
  {
    return array();
  }

  public function getListObjectActions()
  {
    return array(  '_edit' => NULL,  '_delete' => NULL,);
  }

  public function getListActions()
  {
    return array(  '_new' => NULL,);
  }

  public function getListBatchActions()
  {
    return array(  '_delete' => NULL,);
  }

  public function getListParams()
  {
    return '%%=id%% - %%statut%% - %%date_reception%% - %%type%% - %%nom%% - %%telephone%% - %%email%% - %%date_assignation%% - %%user_assignation%%';
  }

  public function getListLayout()
  {
    return 'tabular';
  }

  public function getListTitle()
  {
    return 'Liste des mails';
  }

  public function getEditTitle()
  {
    return 'Assigner le mail';
  }

  public function getNewTitle()
  {
    return 'New Mail sujet';
  }

  public function getFilterDisplay()
  {
    return array(  0 => 'statut',  1 => 'code',  2 => 'date_reception',  3 => 'date_assignation',  4 => 'type',  5 => 'nom',  6 => 'email',  7 => 'code_postal',);
  }

  public function getFormDisplay()
  {
    return array(  'Information' =>   array(    0 => 'date_reception',    1 => 'statut',    2 => 'code',    3 => 'type',  ),  'Contenu' =>   array(    0 => 'type',    1 => 'nom',    2 => 'telephone',    3 => 'email',    4 => 'code_postal',    5 => 'message',  ),  'Assigner' =>   array(    0 => 'date_assignation',    1 => 'id_user',  ),);
  }

  public function getEditDisplay()
  {
    return array();
  }

  public function getNewDisplay()
  {
    return array();
  }

  public function getListDisplay()
  {
    return array(  0 => '=id',  1 => 'statut',  2 => 'date_reception',  3 => 'type',  4 => 'nom',  5 => 'telephone',  6 => 'email',  7 => 'date_assignation',  8 => 'user_assignation',);
  }

  public function getFieldsDefault()
  {
    return array(
      'id' => array(  'is_link' => true,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'statut' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'code' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'date_reception' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',  'label' => 'Reçu le',),
      'date_assignation' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',  'label' => 'Assigné le',),
      'id_user' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'ForeignKey',),
      'type' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'nom' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'telephone' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',  'label' => 'Téléphone',),
      'email' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'code_postal' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'message' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'user_assignation' => array(  'is_link' => false,  'is_real' => false,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',  'label' => 'Commercial assigné',),
    );
  }

  public function getFieldsList()
  {
    return array(
      'id' => array(),
      'statut' => array(),
      'code' => array(),
      'date_reception' => array(),
      'date_assignation' => array(),
      'id_user' => array(),
      'type' => array(),
      'nom' => array(),
      'telephone' => array(),
      'email' => array(),
      'code_postal' => array(),
      'message' => array(),
    );
  }

  public function getFieldsFilter()
  {
    return array(
      'id' => array(),
      'statut' => array(),
      'code' => array(),
      'date_reception' => array(),
      'date_assignation' => array(),
      'id_user' => array(),
      'type' => array(),
      'nom' => array(),
      'telephone' => array(),
      'email' => array(),
      'code_postal' => array(),
      'message' => array(),
    );
  }

  public function getFieldsForm()
  {
    return array(
      'id' => array(),
      'statut' => array(),
      'code' => array(),
      'date_reception' => array(),
      'date_assignation' => array(),
      'id_user' => array(),
      'type' => array(),
      'nom' => array(),
      'telephone' => array(),
      'email' => array(),
      'code_postal' => array(),
      'message' => array(),
    );
  }

  public function getFieldsEdit()
  {
    return array(
      'id' => array(),
      'statut' => array(),
      'code' => array(),
      'date_reception' => array(),
      'date_assignation' => array(),
      'id_user' => array(),
      'type' => array(),
      'nom' => array(),
      'telephone' => array(),
      'email' => array(),
      'code_postal' => array(),
      'message' => array(),
    );
  }

  public function getFieldsNew()
  {
    return array(
      'id' => array(),
      'statut' => array(),
      'code' => array(),
      'date_reception' => array(),
      'date_assignation' => array(),
      'id_user' => array(),
      'type' => array(),
      'nom' => array(),
      'telephone' => array(),
      'email' => array(),
      'code_postal' => array(),
      'message' => array(),
    );
  }


  /**
   * Gets the form class name.
   *
   * @return string The form class name
   */
  public function getFormClass()
  {
    return 'MailSujetForm';
  }

  public function hasFilterForm()
  {
    return true;
  }

  /**
   * Gets the filter form class name
   *
   * @return string The filter form class name associated with this generator
   */
  public function getFilterFormClass()
  {
    return 'MailSujetFormFilter';
  }

  public function getPagerClass()
  {
    return 'sfDoctrinePager';
  }

  public function getPagerMaxPerPage()
  {
    return 20;
  }

  public function getDefaultSort()
  {
    return array('date_reception', 'desc');
  }

  public function getTableMethod()
  {
    return '';
  }

  public function getTableCountMethod()
  {
    return '';
  }
}
