<?php

/**
 * page module configuration.
 *
 * @package    ##PROJECT_NAME##
 * @subpackage page
 * @author     ##AUTHOR_NAME##
 * @version    SVN: $Id: configuration.php 24171 2009-11-19 16:37:50Z Kris.Wallsmith $
 */
abstract class BasePageGeneratorConfiguration extends sfModelGeneratorConfiguration
{
  public function getActionsDefault()
  {
    return array();
  }

  public function getFormActions()
  {
    return array(  '_delete' => NULL,  '_list' => NULL,  '_save' => NULL,  '_save_and_add' => NULL,);
  }

  public function getNewActions()
  {
    return array();
  }

  public function getEditActions()
  {
    return array();
  }

  public function getListObjectActions()
  {
    return array(  '_edit' => NULL,  '_delete' => NULL,);
  }

  public function getListActions()
  {
    return array(  '_new' => NULL,);
  }

  public function getListBatchActions()
  {
    return array(  '_delete' => NULL,);
  }

  public function getListParams()
  {
    return '%%=id_page%% - %%titre%% - %%actif%%';
  }

  public function getListLayout()
  {
    return 'tabular';
  }

  public function getListTitle()
  {
    return 'Liste des pages';
  }

  public function getEditTitle()
  {
    return 'Edition de la page';
  }

  public function getNewTitle()
  {
    return 'Nouvelle page';
  }

  public function getFilterDisplay()
  {
    return array();
  }

  public function getFormDisplay()
  {
    return array();
  }

  public function getEditDisplay()
  {
    return array();
  }

  public function getNewDisplay()
  {
    return array();
  }

  public function getListDisplay()
  {
    return array(  0 => '=id_page',  1 => 'titre',  2 => 'actif',);
  }

  public function getFieldsDefault()
  {
    return array(
      'id_page' => array(  'is_link' => true,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'titre' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'description' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'balise_titre' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'balise_h1' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'url_partie1' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'url_partie2' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'url' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'balise_meta' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'actif' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Boolean',),
      'no_index' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Boolean',),
    );
  }

  public function getFieldsList()
  {
    return array(
      'id_page' => array(),
      'titre' => array(),
      'description' => array(),
      'balise_titre' => array(),
      'balise_h1' => array(),
      'url_partie1' => array(),
      'url_partie2' => array(),
      'url' => array(),
      'balise_meta' => array(),
      'actif' => array(),
      'no_index' => array(),
    );
  }

  public function getFieldsFilter()
  {
    return array(
      'id_page' => array(),
      'titre' => array(),
      'description' => array(),
      'balise_titre' => array(),
      'balise_h1' => array(),
      'url_partie1' => array(),
      'url_partie2' => array(),
      'url' => array(),
      'balise_meta' => array(),
      'actif' => array(),
      'no_index' => array(),
    );
  }

  public function getFieldsForm()
  {
    return array(
      'id_page' => array(),
      'titre' => array(),
      'description' => array(),
      'balise_titre' => array(),
      'balise_h1' => array(),
      'url_partie1' => array(),
      'url_partie2' => array(),
      'url' => array(),
      'balise_meta' => array(),
      'actif' => array(),
      'no_index' => array(),
    );
  }

  public function getFieldsEdit()
  {
    return array(
      'id_page' => array(),
      'titre' => array(),
      'description' => array(),
      'balise_titre' => array(),
      'balise_h1' => array(),
      'url_partie1' => array(),
      'url_partie2' => array(),
      'url' => array(),
      'balise_meta' => array(),
      'actif' => array(),
      'no_index' => array(),
    );
  }

  public function getFieldsNew()
  {
    return array(
      'id_page' => array(),
      'titre' => array(),
      'description' => array(),
      'balise_titre' => array(),
      'balise_h1' => array(),
      'url_partie1' => array(),
      'url_partie2' => array(),
      'url' => array(),
      'balise_meta' => array(),
      'actif' => array(),
      'no_index' => array(),
    );
  }


  /**
   * Gets the form class name.
   *
   * @return string The form class name
   */
  public function getFormClass()
  {
    return 'PageForm';
  }

  public function hasFilterForm()
  {
    return true;
  }

  /**
   * Gets the filter form class name
   *
   * @return string The filter form class name associated with this generator
   */
  public function getFilterFormClass()
  {
    return 'PageFormFilter';
  }

  public function getPagerClass()
  {
    return 'sfDoctrinePager';
  }

  public function getPagerMaxPerPage()
  {
    return 500;
  }

  public function getDefaultSort()
  {
    return array(null, null);
  }

  public function getTableMethod()
  {
    return '';
  }

  public function getTableCountMethod()
  {
    return '';
  }
}
