<?php

/**
 * pompe module configuration.
 *
 * @package    ##PROJECT_NAME##
 * @subpackage pompe
 * @author     ##AUTHOR_NAME##
 * @version    SVN: $Id: configuration.php 24171 2009-11-19 16:37:50Z Kris.Wallsmith $
 */
abstract class BasePompeGeneratorConfiguration extends sfModelGeneratorConfiguration
{
  public function getActionsDefault()
  {
    return array();
  }

  public function getFormActions()
  {
    return array(  '_delete' => NULL,  '_list' => NULL,  '_save' => NULL,  '_save_and_add' => NULL,);
  }

  public function getNewActions()
  {
    return array();
  }

  public function getEditActions()
  {
    return array();
  }

  public function getListObjectActions()
  {
    return array(  '_edit' => NULL,  '_delete' => NULL,);
  }

  public function getListActions()
  {
    return array(  '_new' => NULL,);
  }

  public function getListBatchActions()
  {
    return array(  '_delete' => NULL,);
  }

  public function getListParams()
  {
    return '%%id_pompe%% - %%id_marque%% - %%=modele%% - %%serie%%';
  }

  public function getListLayout()
  {
    return 'tabular';
  }

  public function getListTitle()
  {
    return 'Liste des pompes';
  }

  public function getEditTitle()
  {
    return 'Edition de la pompe';
  }

  public function getNewTitle()
  {
    return 'Nouvelle pompe';
  }

  public function getFilterDisplay()
  {
    return array();
  }

  public function getFormDisplay()
  {
    return array();
  }

  public function getEditDisplay()
  {
    return array();
  }

  public function getNewDisplay()
  {
    return array();
  }

  public function getListDisplay()
  {
    return array(  0 => 'id_pompe',  1 => 'id_marque',  2 => '=modele',  3 => 'serie',);
  }

  public function getFieldsDefault()
  {
    return array(
      'id_pompe' => array(  'is_link' => true,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'id_marque' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'ForeignKey',),
      'modele' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'serie' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'pression' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'debit_litre_min' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'debit_litre_heure' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'vitesse_rotation' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'puissance' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'poids' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'description' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'url_article' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'balise_title' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'balise_meta' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'photo_1' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'doc_commercial' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'doc_technique' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'doc_technique_espace_pro' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Boolean',),
      'eclate_technique' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Text',),
      'eclate_technique_espace_pro' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Boolean',),
      'actif' => array(  'is_link' => false,  'is_real' => true,  'is_partial' => false,  'is_component' => false,  'type' => 'Boolean',),
    );
  }

  public function getFieldsList()
  {
    return array(
      'id_pompe' => array(),
      'id_marque' => array(),
      'modele' => array(),
      'serie' => array(),
      'pression' => array(),
      'debit_litre_min' => array(),
      'debit_litre_heure' => array(),
      'vitesse_rotation' => array(),
      'puissance' => array(),
      'poids' => array(),
      'description' => array(),
      'url_article' => array(),
      'balise_title' => array(),
      'balise_meta' => array(),
      'photo_1' => array(),
      'doc_commercial' => array(),
      'doc_technique' => array(),
      'doc_technique_espace_pro' => array(),
      'eclate_technique' => array(),
      'eclate_technique_espace_pro' => array(),
      'actif' => array(),
    );
  }

  public function getFieldsFilter()
  {
    return array(
      'id_pompe' => array(),
      'id_marque' => array(),
      'modele' => array(),
      'serie' => array(),
      'pression' => array(),
      'debit_litre_min' => array(),
      'debit_litre_heure' => array(),
      'vitesse_rotation' => array(),
      'puissance' => array(),
      'poids' => array(),
      'description' => array(),
      'url_article' => array(),
      'balise_title' => array(),
      'balise_meta' => array(),
      'photo_1' => array(),
      'doc_commercial' => array(),
      'doc_technique' => array(),
      'doc_technique_espace_pro' => array(),
      'eclate_technique' => array(),
      'eclate_technique_espace_pro' => array(),
      'actif' => array(),
    );
  }

  public function getFieldsForm()
  {
    return array(
      'id_pompe' => array(),
      'id_marque' => array(),
      'modele' => array(),
      'serie' => array(),
      'pression' => array(),
      'debit_litre_min' => array(),
      'debit_litre_heure' => array(),
      'vitesse_rotation' => array(),
      'puissance' => array(),
      'poids' => array(),
      'description' => array(),
      'url_article' => array(),
      'balise_title' => array(),
      'balise_meta' => array(),
      'photo_1' => array(),
      'doc_commercial' => array(),
      'doc_technique' => array(),
      'doc_technique_espace_pro' => array(),
      'eclate_technique' => array(),
      'eclate_technique_espace_pro' => array(),
      'actif' => array(),
    );
  }

  public function getFieldsEdit()
  {
    return array(
      'id_pompe' => array(),
      'id_marque' => array(),
      'modele' => array(),
      'serie' => array(),
      'pression' => array(),
      'debit_litre_min' => array(),
      'debit_litre_heure' => array(),
      'vitesse_rotation' => array(),
      'puissance' => array(),
      'poids' => array(),
      'description' => array(),
      'url_article' => array(),
      'balise_title' => array(),
      'balise_meta' => array(),
      'photo_1' => array(),
      'doc_commercial' => array(),
      'doc_technique' => array(),
      'doc_technique_espace_pro' => array(),
      'eclate_technique' => array(),
      'eclate_technique_espace_pro' => array(),
      'actif' => array(),
    );
  }

  public function getFieldsNew()
  {
    return array(
      'id_pompe' => array(),
      'id_marque' => array(),
      'modele' => array(),
      'serie' => array(),
      'pression' => array(),
      'debit_litre_min' => array(),
      'debit_litre_heure' => array(),
      'vitesse_rotation' => array(),
      'puissance' => array(),
      'poids' => array(),
      'description' => array(),
      'url_article' => array(),
      'balise_title' => array(),
      'balise_meta' => array(),
      'photo_1' => array(),
      'doc_commercial' => array(),
      'doc_technique' => array(),
      'doc_technique_espace_pro' => array(),
      'eclate_technique' => array(),
      'eclate_technique_espace_pro' => array(),
      'actif' => array(),
    );
  }


  /**
   * Gets the form class name.
   *
   * @return string The form class name
   */
  public function getFormClass()
  {
    return 'PompeForm';
  }

  public function hasFilterForm()
  {
    return true;
  }

  /**
   * Gets the filter form class name
   *
   * @return string The filter form class name associated with this generator
   */
  public function getFilterFormClass()
  {
    return 'PompeFormFilter';
  }

  public function getPagerClass()
  {
    return 'sfDoctrinePager';
  }

  public function getPagerMaxPerPage()
  {
    return 500;
  }

  public function getDefaultSort()
  {
    return array('id_marque', 'asc');
  }

  public function getTableMethod()
  {
    return 'retrieveBackendPompeList';
  }

  public function getTableCountMethod()
  {
    return '';
  }
}
