CREATE TABLE article (reference_ths VARCHAR(100), reference_ths_sage VARCHAR(100) UNIQUE, id_famille SMALLINT, designation_courte VARCHAR(100), designation_detaillee VARCHAR(255), specificite VARCHAR(100), dimensions_a VARCHAR(100), dimensions_b VARCHAR(100), matiere VARCHAR(100), pression_maximum VARCHAR(100), temperature_maximum VARCHAR(100), diametre_nominal VARCHAR(100), reference_metrique_entree VARCHAR(100), sexe_entree VARCHAR(100), precision_supplementaire_entree VARCHAR(100), reference_metrique_sortie VARCHAR(100), sexe_sortie VARCHAR(100), precision_supplementaire_sortie VARCHAR(100), calibre_piece VARCHAR(100), debit_max VARCHAR(100), hors_gabarit TINYINT(1) DEFAULT '1' NOT NULL, piece_origine TINYINT(1) DEFAULT '1' NOT NULL, piece_visible TINYINT(1) DEFAULT '1' NOT NULL, poids VARCHAR(100), prix_vente_ht FLOAT(18, 2), taux_remise_fournisseur FLOAT(18, 2), prix_vente_ths FLOAT(18, 2), marge_pourcentage FLOAT(18, 2), marge_euro FLOAT(18, 2), prix_ttc FLOAT(18, 2), stock BIGINT, url_article VARCHAR(255), balise_title VARCHAR(255), balise_meta VARCHAR(255), minimum_commande TINYINT(1) DEFAULT '1' NOT NULL, id_fournisseur BIGINT NOT NULL, INDEX id_fournisseur_idx (id_fournisseur), INDEX id_famille_idx (id_famille), INDEX reference_ths_sage_idx (reference_ths_sage), PRIMARY KEY(reference_ths)) ENGINE = INNODB;
CREATE TABLE association (id_association BIGINT AUTO_INCREMENT, ordre SMALLINT, texte VARCHAR(100), note VARCHAR(100), id_famille SMALLINT NOT NULL, id_nettoyeur BIGINT NOT NULL, INDEX id_famille_idx (id_famille), INDEX id_nettoyeur_idx (id_nettoyeur), PRIMARY KEY(id_association)) ENGINE = INNODB;
CREATE TABLE association_article (id_association BIGINT, reference_ths_sage VARCHAR(100), ordre SMALLINT, PRIMARY KEY(id_association, reference_ths_sage)) ENGINE = INNODB;
CREATE TABLE backup_config (type VARCHAR(255), day BIGINT, PRIMARY KEY(type, day)) ENGINE = INNODB;
CREATE TABLE backup_data (id_backup BIGINT AUTO_INCREMENT, date_time datetime, duration INT, statut TINYINT(1), type VARCHAR(255), PRIMARY KEY(id_backup)) ENGINE = INNODB;
CREATE TABLE client (id_client BIGINT AUTO_INCREMENT, type VARCHAR(15), civilite VARCHAR(15), raison_sociale VARCHAR(255), nom VARCHAR(100), prenom VARCHAR(100), adresse VARCHAR(255), adresse_complement VARCHAR(255), code_postal VARCHAR(5), ville VARCHAR(100), pays VARCHAR(100), telephone VARCHAR(15), fax VARCHAR(15), email VARCHAR(155), id_statut SMALLINT, id_user BIGINT, export_sage TINYINT(1) DEFAULT '0' NOT NULL, INDEX id_user_idx (id_user), PRIMARY KEY(id_client)) ENGINE = INNODB;
CREATE TABLE commande (id_commande BIGINT AUTO_INCREMENT, poids_total FLOAT(18, 2), frais_port_ht FLOAT(18, 2), total_produit_ht FLOAT(18, 2), total_ht FLOAT(18, 2), taux_tva FLOAT(18, 2), total_ttc FLOAT(18, 2), id_statut VARCHAR(15), type stirng(15), raison_sociale VARCHAR(255), civilite SMALLINT, nom VARCHAR(100), prenom VARCHAR(100), adresse VARCHAR(255), adresse_complement VARCHAR(255), code_postal VARCHAR(5), ville VARCHAR(100), pays VARCHAR(100), telephone VARCHAR(15), fax VARCHAR(15), email VARCHAR(155), note_livraison text, type_commande SMALLINT, commande_token VARCHAR(13), devis_token VARCHAR(13), devis_pdf VARCHAR(255), moyen_paiement SMALLINT, numero_transaction VARCHAR(255), numero_carte VARCHAR(255), certificat_transaction VARCHAR(255), date_transaction datetime, id_client BIGINT, id_user_suiveur BIGINT, numero_colissimo VARCHAR(13), mail_commande TINYINT(1) DEFAULT '0', mail_colissimo TINYINT(1) DEFAULT '0', date_creation DATETIME NOT NULL, date_edition DATETIME NOT NULL, INDEX id_client_idx (id_client), INDEX id_user_suiveur_idx (id_user_suiveur), PRIMARY KEY(id_commande)) ENGINE = INNODB;
CREATE TABLE commande_article (id_commande_article BIGINT AUTO_INCREMENT, id_commande BIGINT, id_article VARCHAR(100), id_nettoyeur BIGINT, quantite BIGINT, prix_unitaire_ht FLOAT(18, 2), prix_total_ht FLOAT(18, 2), prix_total_ttc FLOAT(18, 2), INDEX id_commande_idx (id_commande), PRIMARY KEY(id_commande_article)) ENGINE = INNODB;
CREATE TABLE config (id_config BIGINT AUTO_INCREMENT, libelle VARCHAR(255), valeur VARCHAR(255), actif TINYINT(1) DEFAULT '1' NOT NULL, PRIMARY KEY(id_config)) ENGINE = INNODB;
CREATE TABLE departement (id_departement VARCHAR(3), libelle VARCHAR(255), statut TINYINT(1) DEFAULT '1' NOT NULL, PRIMARY KEY(id_departement)) ENGINE = INNODB;
CREATE TABLE famille (id_famille SMALLINT AUTO_INCREMENT, libelle VARCHAR(255), ordre SMALLINT DEFAULT 0 NOT NULL, statut TINYINT(1) DEFAULT '1' NOT NULL, PRIMARY KEY(id_famille)) ENGINE = INNODB;
CREATE TABLE fournisseur (id BIGINT AUTO_INCREMENT, code VARCHAR(255) NOT NULL UNIQUE, nom VARCHAR(255), description text, PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE fournisseur_coefficient (id BIGINT AUTO_INCREMENT, coefficient FLOAT(18, 2), prix_min FLOAT(18, 2), prix_max FLOAT(18, 2), id_fournisseur BIGINT NOT NULL, INDEX id_fournisseur_idx (id_fournisseur), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE mail (id_mail BIGINT AUTO_INCREMENT, libelle VARCHAR(255), objet VARCHAR(255), mail text, PRIMARY KEY(id_mail)) ENGINE = INNODB;
CREATE TABLE mail_file (id BIGINT AUTO_INCREMENT, id_mail_reponse BIGINT NOT NULL, name VARCHAR(255), type VARCHAR(10), INDEX id_mail_reponse_idx (id_mail_reponse), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE mail_reponse (id BIGINT AUTO_INCREMENT, id_mail_sujet BIGINT NOT NULL, date_reponse datetime, id_user BIGINT, message text, INDEX id_mail_sujet_idx (id_mail_sujet), INDEX id_user_idx (id_user), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE mail_sujet (id BIGINT AUTO_INCREMENT, statut VARCHAR(20), code VARCHAR(50), date_reception datetime, date_assignation datetime, id_user BIGINT, type VARCHAR(20), nom VARCHAR(255), telephone VARCHAR(50), email VARCHAR(255), code_postal VARCHAR(10), message text, UNIQUE INDEX code_index_idx (code), INDEX id_user_idx (id_user), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE mailing_pro (id_mailing_pro BIGINT AUTO_INCREMENT, civilite VARCHAR(10), nom VARCHAR(50), adresse VARCHAR(100), code_postal VARCHAR(10), ville VARCHAR(100), telephone VARCHAR(15), fax VARCHAR(15), gsm VARCHAR(15), activite VARCHAR(100), code_acces VARCHAR(100), date DATE, acces TINYINT(1), PRIMARY KEY(id_mailing_pro)) ENGINE = INNODB;
CREATE TABLE marque (id_marque SMALLINT AUTO_INCREMENT, libelle VARCHAR(255), statut TINYINT(1) DEFAULT '1' NOT NULL, famille VARCHAR(255), PRIMARY KEY(id_marque)) ENGINE = INNODB;
CREATE TABLE menu (id_menu BIGINT AUTO_INCREMENT, libelle VARCHAR(100), largeur BIGINT, ordre SMALLINT, actif TINYINT(1) DEFAULT '1' NOT NULL, PRIMARY KEY(id_menu)) ENGINE = INNODB;
CREATE TABLE nettoyeur_haute_pression (id_nettoyeur BIGINT AUTO_INCREMENT, id_marque SMALLINT, modele VARCHAR(50), poste_fixe TINYINT(1) DEFAULT '0' NOT NULL, groupe_moteur_pompe TINYINT(1) DEFAULT '0' NOT NULL, eau_froide TINYINT(1) DEFAULT '0' NOT NULL, eau_chaude TINYINT(1) DEFAULT '0' NOT NULL, vapeur TINYINT(1) DEFAULT '0' NOT NULL, temperature FLOAT(18, 2), pression_service SMALLINT, debit_litre_min FLOAT(18, 2), debit_litre_heure FLOAT(18, 2), calibre VARCHAR(50), electrique_220 TINYINT(1) DEFAULT '0' NOT NULL, electrique_220_a FLOAT(18, 2), electrique_220_kw FLOAT(18, 2), electrique_220_hz FLOAT(18, 2), electrique_380 TINYINT(1) DEFAULT '0' NOT NULL, electrique_380_a FLOAT(18, 2), electrique_380_kw FLOAT(18, 2), electrique_380_hz FLOAT(18, 2), moteur_thermique TINYINT(1) DEFAULT '0' NOT NULL, moteur_thermique_info VARCHAR(255), poids FLOAT(18, 2), description text, reference_ths VARCHAR(100), reference_constructeur VARCHAR(100), prix_vente_ht FLOAT(18, 2), taux_remise_fournisseur FLOAT(18, 2), prix_vente_ths FLOAT(18, 2), marge_pourcentage FLOAT(18, 2), marge_euro FLOAT(18, 2), prix_ttc FLOAT(18, 2), stock BIGINT, franco_de_port TINYINT(1) DEFAULT '0' NOT NULL, promo TINYINT(1) DEFAULT '0' NOT NULL, url_article VARCHAR(255), balise_title VARCHAR(255), balise_meta VARCHAR(255), photo_1 VARCHAR(255), photo_2 VARCHAR(255), photo_3 VARCHAR(255), photo_4 VARCHAR(255), photo_5 VARCHAR(255), video_flv VARCHAR(255), doc_commercial VARCHAR(255), doc_technique VARCHAR(255), doc_technique_espace_pro TINYINT(1) DEFAULT '1' NOT NULL, eclate_technique VARCHAR(255), eclate_technique_espace_pro TINYINT(1) DEFAULT '1' NOT NULL, actif TINYINT(1) DEFAULT '1' NOT NULL, disponible_vente TINYINT(1) DEFAULT '1' NOT NULL, visible_moteur_recherche TINYINT(1) DEFAULT '1' NOT NULL, afficher_prix TINYINT(1) DEFAULT '0' NOT NULL, plus_fabriquer TINYINT(1) DEFAULT '0' NOT NULL, no_index TINYINT(1) DEFAULT '0' NOT NULL, vente_pieces_detachees TINYINT(1) DEFAULT '0' NOT NULL, INDEX id_marque_idx (id_marque), PRIMARY KEY(id_nettoyeur)) ENGINE = INNODB;
CREATE TABLE nettoyeur_haute_pression_nomenclature (id BIGINT AUTO_INCREMENT, id_nettoyeur BIGINT, id_nomenclature BIGINT, position BIGINT, gras TINYINT(1), INDEX id_nomenclature_idx (id_nomenclature), INDEX id_nettoyeur_idx (id_nettoyeur), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE nomenclature (id BIGINT AUTO_INCREMENT, reference BIGINT, designation VARCHAR(255), traduction TINYINT(1), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE page (id_page BIGINT AUTO_INCREMENT, titre VARCHAR(255), description LONGTEXT, balise_titre VARCHAR(255), balise_h1 VARCHAR(255), url_partie1 VARCHAR(255), url_partie2 VARCHAR(255), url VARCHAR(255), balise_meta VARCHAR(255), actif TINYINT(1) DEFAULT '1' NOT NULL, no_index TINYINT(1) DEFAULT '1' NOT NULL, PRIMARY KEY(id_page)) ENGINE = INNODB;
CREATE TABLE poids (id_poids SMALLINT AUTO_INCREMENT, poids BIGINT NOT NULL, statut TINYINT(1) DEFAULT '1' NOT NULL, PRIMARY KEY(id_poids)) ENGINE = INNODB;
CREATE TABLE pompe (id_pompe BIGINT AUTO_INCREMENT, id_marque SMALLINT, modele VARCHAR(50), serie VARCHAR(50), pression VARCHAR(50), debit_litre_min VARCHAR(50), debit_litre_heure VARCHAR(50), vitesse_rotation VARCHAR(50), puissance VARCHAR(50), poids FLOAT(18, 2), description text, url_article VARCHAR(255), balise_title VARCHAR(255), balise_meta VARCHAR(255), photo_1 VARCHAR(255), doc_commercial VARCHAR(255), doc_technique VARCHAR(255), doc_technique_espace_pro TINYINT(1) DEFAULT '1' NOT NULL, eclate_technique VARCHAR(255), eclate_technique_espace_pro TINYINT(1) DEFAULT '1' NOT NULL, actif TINYINT(1) DEFAULT '1' NOT NULL, INDEX id_marque_idx (id_marque), PRIMARY KEY(id_pompe)) ENGINE = INNODB;
CREATE TABLE pressure_washer_price_history (id BIGINT AUTO_INCREMENT, date_time datetime, source text, price FLOAT(18, 2), id_pwww BIGINT, INDEX id_pwww_idx (id_pwww), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE pressure_washer_watch (id_nettoyeur BIGINT, price FLOAT(18, 2), PRIMARY KEY(id_nettoyeur)) ENGINE = INNODB;
CREATE TABLE pressure_washer_watch_website (id BIGINT AUTO_INCREMENT, name VARCHAR(255), url VARCHAR(255), before_price VARCHAR(255), after_price VARCHAR(255), id_nettoyeur BIGINT, INDEX id_nettoyeur_idx (id_nettoyeur), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE sous_menu (id_sous_menu BIGINT AUTO_INCREMENT, libelle VARCHAR(100), url VARCHAR(255), ordre SMALLINT, actif TINYINT(1) DEFAULT '1' NOT NULL, id_menu BIGINT, INDEX id_menu_idx (id_menu), PRIMARY KEY(id_sous_menu)) ENGINE = INNODB;
CREATE TABLE taux_tva (id_taux_tva SMALLINT AUTO_INCREMENT, taux FLOAT(18, 2) NOT NULL, statut TINYINT(1) DEFAULT '1' NOT NULL, PRIMARY KEY(id_taux_tva)) ENGINE = INNODB;
CREATE TABLE transporteur (id_transporteur SMALLINT AUTO_INCREMENT, libelle VARCHAR(255), forfait_emballage FLOAT(18, 2) NOT NULL, hors_gabarit TINYINT(1) DEFAULT '1' NOT NULL, statut TINYINT(1) DEFAULT '1' NOT NULL, PRIMARY KEY(id_transporteur)) ENGINE = INNODB;
CREATE TABLE visite_pro (id_visite BIGINT AUTO_INCREMENT, id_mailing_pro BIGINT, url VARCHAR(255), date_heure_debut datetime, date_heure_fin datetime, INDEX id_mailing_pro_idx (id_mailing_pro), PRIMARY KEY(id_visite)) ENGINE = INNODB;
CREATE TABLE zone (id_zone BIGINT AUTO_INCREMENT, libelle VARCHAR(255), statut TINYINT(1) DEFAULT '1' NOT NULL, id_transporteur SMALLINT NOT NULL, INDEX id_transporteur_idx (id_transporteur), PRIMARY KEY(id_zone)) ENGINE = INNODB;
CREATE TABLE zone_departement (id_zone BIGINT, id_departement VARCHAR(3), PRIMARY KEY(id_zone, id_departement)) ENGINE = INNODB;
CREATE TABLE zone_tarif (id_zone BIGINT, id_poids SMALLINT, tarif FLOAT(18, 2) NOT NULL, PRIMARY KEY(id_zone, id_poids)) ENGINE = INNODB;
CREATE TABLE sf_guard_forgot_password (id BIGINT AUTO_INCREMENT, user_id BIGINT NOT NULL, unique_key VARCHAR(255), expires_at DATETIME NOT NULL, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, INDEX user_id_idx (user_id), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE sf_guard_group (id BIGINT AUTO_INCREMENT, name VARCHAR(255) UNIQUE, description TEXT, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE sf_guard_group_permission (group_id BIGINT, permission_id BIGINT, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, PRIMARY KEY(group_id, permission_id)) ENGINE = INNODB;
CREATE TABLE sf_guard_permission (id BIGINT AUTO_INCREMENT, name VARCHAR(255) UNIQUE, description TEXT, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE sf_guard_remember_key (id BIGINT AUTO_INCREMENT, user_id BIGINT, remember_key VARCHAR(32), ip_address VARCHAR(50), created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, INDEX user_id_idx (user_id), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE sf_guard_user (id BIGINT AUTO_INCREMENT, first_name VARCHAR(255), last_name VARCHAR(255), email_address VARCHAR(255) NOT NULL UNIQUE, username VARCHAR(128) NOT NULL UNIQUE, algorithm VARCHAR(128) DEFAULT 'sha1' NOT NULL, salt VARCHAR(128), password VARCHAR(128), is_active TINYINT(1) DEFAULT '1', is_super_admin TINYINT(1) DEFAULT '0', last_login DATETIME, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, INDEX is_active_idx_idx (is_active), PRIMARY KEY(id)) ENGINE = INNODB;
CREATE TABLE sf_guard_user_group (user_id BIGINT, group_id BIGINT, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, PRIMARY KEY(user_id, group_id)) ENGINE = INNODB;
CREATE TABLE sf_guard_user_permission (user_id BIGINT, permission_id BIGINT, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, PRIMARY KEY(user_id, permission_id)) ENGINE = INNODB;
ALTER TABLE article ADD CONSTRAINT article_id_fournisseur_fournisseur_id FOREIGN KEY (id_fournisseur) REFERENCES fournisseur(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE article ADD CONSTRAINT article_id_famille_famille_id_famille FOREIGN KEY (id_famille) REFERENCES famille(id_famille);
ALTER TABLE article ADD CONSTRAINT arar FOREIGN KEY (reference_ths_sage) REFERENCES association_article(reference_ths_sage);
ALTER TABLE association ADD CONSTRAINT association_id_nettoyeur_nettoyeur_haute_pression_id_nettoyeur FOREIGN KEY (id_nettoyeur) REFERENCES nettoyeur_haute_pression(id_nettoyeur);
ALTER TABLE association ADD CONSTRAINT association_id_famille_famille_id_famille FOREIGN KEY (id_famille) REFERENCES famille(id_famille);
ALTER TABLE association_article ADD CONSTRAINT association_article_id_association_association_id_association FOREIGN KEY (id_association) REFERENCES association(id_association) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE association_article ADD CONSTRAINT arar_1 FOREIGN KEY (reference_ths_sage) REFERENCES article(reference_ths_sage) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE client ADD CONSTRAINT client_id_user_sf_guard_user_id FOREIGN KEY (id_user) REFERENCES sf_guard_user(id);
ALTER TABLE commande ADD CONSTRAINT commande_id_user_suiveur_sf_guard_user_id FOREIGN KEY (id_user_suiveur) REFERENCES sf_guard_user(id);
ALTER TABLE commande ADD CONSTRAINT commande_id_client_client_id_client FOREIGN KEY (id_client) REFERENCES client(id_client);
ALTER TABLE commande_article ADD CONSTRAINT commande_article_id_commande_commande_id_commande FOREIGN KEY (id_commande) REFERENCES commande(id_commande) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE fournisseur_coefficient ADD CONSTRAINT fournisseur_coefficient_id_fournisseur_fournisseur_id FOREIGN KEY (id_fournisseur) REFERENCES fournisseur(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE mail_file ADD CONSTRAINT mail_file_id_mail_reponse_mail_reponse_id FOREIGN KEY (id_mail_reponse) REFERENCES mail_reponse(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE mail_reponse ADD CONSTRAINT mail_reponse_id_user_sf_guard_user_id FOREIGN KEY (id_user) REFERENCES sf_guard_user(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE mail_reponse ADD CONSTRAINT mail_reponse_id_mail_sujet_mail_sujet_id FOREIGN KEY (id_mail_sujet) REFERENCES mail_sujet(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE mail_sujet ADD CONSTRAINT mail_sujet_id_user_sf_guard_user_id FOREIGN KEY (id_user) REFERENCES sf_guard_user(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE nettoyeur_haute_pression ADD CONSTRAINT nettoyeur_haute_pression_id_marque_marque_id_marque FOREIGN KEY (id_marque) REFERENCES marque(id_marque);
ALTER TABLE nettoyeur_haute_pression_nomenclature ADD CONSTRAINT nini_2 FOREIGN KEY (id_nettoyeur) REFERENCES nettoyeur_haute_pression(id_nettoyeur);
ALTER TABLE nettoyeur_haute_pression_nomenclature ADD CONSTRAINT nini_1 FOREIGN KEY (id_nomenclature) REFERENCES nomenclature(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE pompe ADD CONSTRAINT pompe_id_marque_marque_id_marque FOREIGN KEY (id_marque) REFERENCES marque(id_marque);
ALTER TABLE pressure_washer_price_history ADD CONSTRAINT pipi FOREIGN KEY (id_pwww) REFERENCES pressure_washer_watch_website(id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE pressure_washer_watch_website ADD CONSTRAINT pini_1 FOREIGN KEY (id_nettoyeur) REFERENCES nettoyeur_haute_pression(id_nettoyeur) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE sous_menu ADD CONSTRAINT sous_menu_id_menu_menu_id_menu FOREIGN KEY (id_menu) REFERENCES menu(id_menu) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE visite_pro ADD CONSTRAINT visite_pro_id_mailing_pro_mailing_pro_id_mailing_pro FOREIGN KEY (id_mailing_pro) REFERENCES mailing_pro(id_mailing_pro) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE zone ADD CONSTRAINT zone_id_transporteur_transporteur_id_transporteur FOREIGN KEY (id_transporteur) REFERENCES transporteur(id_transporteur) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE zone_departement ADD CONSTRAINT zone_departement_id_zone_zone_id_zone FOREIGN KEY (id_zone) REFERENCES zone(id_zone) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE zone_departement ADD CONSTRAINT zone_departement_id_departement_departement_id_departement FOREIGN KEY (id_departement) REFERENCES departement(id_departement) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE zone_tarif ADD CONSTRAINT zone_tarif_id_zone_zone_id_zone FOREIGN KEY (id_zone) REFERENCES zone(id_zone) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE zone_tarif ADD CONSTRAINT zone_tarif_id_poids_poids_id_poids FOREIGN KEY (id_poids) REFERENCES poids(id_poids) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE sf_guard_forgot_password ADD CONSTRAINT sf_guard_forgot_password_user_id_sf_guard_user_id FOREIGN KEY (user_id) REFERENCES sf_guard_user(id) ON DELETE CASCADE;
ALTER TABLE sf_guard_group_permission ADD CONSTRAINT sf_guard_group_permission_permission_id_sf_guard_permission_id FOREIGN KEY (permission_id) REFERENCES sf_guard_permission(id) ON DELETE CASCADE;
ALTER TABLE sf_guard_group_permission ADD CONSTRAINT sf_guard_group_permission_group_id_sf_guard_group_id FOREIGN KEY (group_id) REFERENCES sf_guard_group(id) ON DELETE CASCADE;
ALTER TABLE sf_guard_remember_key ADD CONSTRAINT sf_guard_remember_key_user_id_sf_guard_user_id FOREIGN KEY (user_id) REFERENCES sf_guard_user(id) ON DELETE CASCADE;
ALTER TABLE sf_guard_user_group ADD CONSTRAINT sf_guard_user_group_user_id_sf_guard_user_id FOREIGN KEY (user_id) REFERENCES sf_guard_user(id) ON DELETE CASCADE;
ALTER TABLE sf_guard_user_group ADD CONSTRAINT sf_guard_user_group_group_id_sf_guard_group_id FOREIGN KEY (group_id) REFERENCES sf_guard_group(id) ON DELETE CASCADE;
ALTER TABLE sf_guard_user_permission ADD CONSTRAINT sf_guard_user_permission_user_id_sf_guard_user_id FOREIGN KEY (user_id) REFERENCES sf_guard_user(id) ON DELETE CASCADE;
ALTER TABLE sf_guard_user_permission ADD CONSTRAINT sf_guard_user_permission_permission_id_sf_guard_permission_id FOREIGN KEY (permission_id) REFERENCES sf_guard_permission(id) ON DELETE CASCADE;
