<?php

/**
 * NettoyeurHautePression form.
 *
 * @package    sf_sandbox
 * @subpackage form
 * @author     Your name here
 * @version    SVN: $Id: sfDoctrineFormTemplate.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class NettoyeurHautePressionForm extends BaseNettoyeurHautePressionForm
{
	public function configure()
	{
		$this->widgetSchema['id_marque'] = new sfWidgetFormDoctrineChoice(
												array(	'model' => $this->getRelatedModelName('Marque'), 
														'add_empty' => true,
														'query' => MarqueTable::queryNettoyeurHautePressionForEditForm()));
												
		$this->widgetSchema['description'] = new sfWidgetFormTextareaTinyMCE(array(
		  'width'  => 760,
		  'height' => 350,
		  'config' => 'theme_advanced_disable: "anchor,image,cleanup,help", theme_advanced_buttons1: "bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,formatselect,fontselect,fontsizeselect", theme_advanced_buttons2: "bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,|,code,forecolor", theme_advanced_font_sizes: "10px,12px,13px,14px,16px,18px,20px"',
		));
		
		$this->widgetSchema["balise_meta"] = new sfWidgetFormTextarea(array(), array("cols"=>70));
		
		$this->widgetSchema["photo_1"] = new sfWidgetFormInputFile();
		$this->widgetSchema["photo_1_supprimer"] = new sfWidgetFormInputCheckbox();
		$this->widgetSchema["photo_2"] = new sfWidgetFormInputFile();
		$this->widgetSchema["photo_2_supprimer"] = new sfWidgetFormInputCheckbox();
		$this->widgetSchema["photo_3"] = new sfWidgetFormInputFile();
		$this->widgetSchema["photo_3_supprimer"] = new sfWidgetFormInputCheckbox();
		$this->widgetSchema["photo_4"] = new sfWidgetFormInputFile();
		$this->widgetSchema["photo_4_supprimer"] = new sfWidgetFormInputCheckbox();
		$this->widgetSchema["photo_5"] = new sfWidgetFormInputFile();
		$this->widgetSchema["photo_5_supprimer"] = new sfWidgetFormInputCheckbox();
		$this->widgetSchema["video_flv"] = new sfWidgetFormInputFile();
		$this->widgetSchema["video_flv_supprimer"] = new sfWidgetFormInputCheckbox();
		$this->widgetSchema["doc_commercial"] = new sfWidgetFormInputFile();
		$this->widgetSchema["doc_commercial_supprimer"] = new sfWidgetFormInputCheckbox();
		$this->widgetSchema["doc_technique"] = new sfWidgetFormInputFile();
		$this->widgetSchema["doc_technique_supprimer"] = new sfWidgetFormInputCheckbox();
		$this->widgetSchema["eclate_technique"] = new sfWidgetFormInputFile();
		$this->widgetSchema["eclate_technique_existant"] = new sfWidgetFormInputHidden();
		$this->widgetSchema["eclate_technique_supprimer"] = new sfWidgetFormInputCheckbox();
		$this->widgetSchema["doc_technique_masque"] = new sfWidgetFormInputCheckbox();
		$this->widgetSchema["eclate_technique_masque"] = new sfWidgetFormInputCheckbox();
		
		$this->validatorSchema["id_marque"] = new sfValidatorDoctrineChoice(array('model' => $this->getRelatedModelName('Marque'), 'required' => true), array('required'=>'Veuillez renseigner une marque'));
		$this->validatorSchema["modele"] = new sfValidatorString(array('max_length' => 50, 'required' => true), array('required'=>'Veuillez renseigner un modèle'));
		$this->validatorSchema["pression_service"] = new sfValidatorInteger(array('required' => false), array('invalid'=>'Veuillez renseigner un entier pour la pression'));
		$this->validatorSchema["stock"] =  new sfValidatorInteger(array('required' => false), array('invalid'=>'Veuillez renseigner un entier pour le stock'));
		$this->validatorSchema["photo_1"] = new sfValidatorFile(array('required' => false));
		$this->validatorSchema["photo_1_supprimer"] = new sfValidatorBoolean(array('required' => false));
		$this->validatorSchema["photo_2"] = new sfValidatorFile(array('required' => false));
		$this->validatorSchema["photo_2_supprimer"] = new sfValidatorBoolean(array('required' => false));
		$this->validatorSchema["photo_3"] = new sfValidatorFile(array('required' => false));
		$this->validatorSchema["photo_3_supprimer"] = new sfValidatorBoolean(array('required' => false));
		$this->validatorSchema["photo_4"] = new sfValidatorFile(array('required' => false));
		$this->validatorSchema["photo_4_supprimer"] = new sfValidatorBoolean(array('required' => false));
		$this->validatorSchema["photo_5"] = new sfValidatorFile(array('required' => false));
		$this->validatorSchema["photo_5_supprimer"] = new sfValidatorBoolean(array('required' => false));
		$this->validatorSchema["video_flv"] = new sfValidatorFile(array('required' => false));
		$this->validatorSchema["video_flv_supprimer"] = new sfValidatorBoolean(array('required' => false));
		$this->validatorSchema["doc_commercial"] = new sfValidatorFile(array('required' => false));
		$this->validatorSchema["doc_commercial_supprimer"] = new sfValidatorBoolean(array('required' => false));
		$this->validatorSchema["doc_technique"] = new sfValidatorFile(array('required' => false));
		$this->validatorSchema["doc_technique_supprimer"] = new sfValidatorBoolean(array('required' => false));
		$this->validatorSchema["eclate_technique"] = new sfValidatorFile(array('required' => false));
		$this->validatorSchema["eclate_technique_existant"] = new sfValidatorBoolean(array('required' => false));
		$this->validatorSchema["eclate_technique_supprimer"] = new sfValidatorBoolean(array('required' => false));
		$this->validatorSchema["doc_technique_masque"] = new sfValidatorBoolean(array('required' => false));
		$this->validatorSchema["eclate_technique_masque"] = new sfValidatorBoolean(array('required' => false));
		
		// add a post validator
		$this->validatorSchema->setPostValidator(
		    new sfValidatorCallback(array('callback' => array($this, 'checkVentePiecesDetachees')))
		);
	}
	
	public function checkVentePiecesDetachees($validator, $values)
	{
	    if ($values['vente_pieces_detachees'] && !$values['eclate_technique']) {
		if ($values['vente_pieces_detachees'] && (!$values['eclate_technique_existant'] || $values['eclate_technique_supprimer'])) {
		    throw new sfValidatorError($validator, 'Vous devez avoir un éclaté technique pour activer la vente de pièces détachées');
		}
	    }

	    return $values;
	}
}
