<?php

/**
 * Departement form base class.
 *
 * @method Departement getObject() Returns the current form's model object
 *
 * @package    sf_sandbox
 * @subpackage form
 * @author     Your name here
 * @version    SVN: $Id: sfDoctrineFormGeneratedTemplate.php 29553 2010-05-20 14:33:00Z Kris.Wallsmith $
 */
abstract class BaseDepartementForm extends BaseFormDoctrine
{
  public function setup()
  {
    $this->setWidgets(array(
      'id_departement' => new sfWidgetFormInputHidden(),
      'libelle'        => new sfWidgetFormInputText(),
      'statut'         => new sfWidgetFormInputCheckbox(),
      'zone_list'      => new sfWidgetFormDoctrineChoice(array('multiple' => true, 'model' => 'Zone')),
    ));

    $this->setValidators(array(
      'id_departement' => new sfValidatorChoice(array('choices' => array($this->getObject()->get('id_departement')), 'empty_value' => $this->getObject()->get('id_departement'), 'required' => false)),
      'libelle'        => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'statut'         => new sfValidatorBoolean(array('required' => false)),
      'zone_list'      => new sfValidatorDoctrineChoice(array('multiple' => true, 'model' => 'Zone', 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('departement[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    $this->setupInheritance();

    parent::setup();
  }

  public function getModelName()
  {
    return 'Departement';
  }

  public function updateDefaultsFromObject()
  {
    parent::updateDefaultsFromObject();

    if (isset($this->widgetSchema['zone_list']))
    {
      $this->setDefault('zone_list', $this->object->Zone->getPrimaryKeys());
    }

  }

  protected function doSave($con = null)
  {
    $this->saveZoneList($con);

    parent::doSave($con);
  }

  public function saveZoneList($con = null)
  {
    if (!$this->isValid())
    {
      throw $this->getErrorSchema();
    }

    if (!isset($this->widgetSchema['zone_list']))
    {
      // somebody has unset this widget
      return;
    }

    if (null === $con)
    {
      $con = $this->getConnection();
    }

    $existing = $this->object->Zone->getPrimaryKeys();
    $values = $this->getValue('zone_list');
    if (!is_array($values))
    {
      $values = array();
    }

    $unlink = array_diff($existing, $values);
    if (count($unlink))
    {
      $this->object->unlink('Zone', array_values($unlink));
    }

    $link = array_diff($values, $existing);
    if (count($link))
    {
      $this->object->link('Zone', array_values($link));
    }
  }

}
