<?php
class PanierCoordonneesForm extends sfForm
{
	public function configure()
	{
		$this->setWidgets(array(
				'type'			=> new sfWidgetFormSelect(array("choices" =>array("Particulier" => "Particulier", "Société" => "Société"))),
				'raison_sociale'		=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 255)),
				'civilite'			=> new sfWidgetFormSelect(array("choices" =>array("Mr" => "Mr", "Mme" => "Mme"))),
				'nom'				=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 100)),
				'prenom'			=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 100)),
				'adresse'			=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 255)),
                                'adresse_complement'		=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 255)),
				'code_postal'                   => new sfWidgetFormInputText(array(), array('size'=> 5, 'maxlength' => 5)),
				'ville'				=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 100)),
				'pays'				=> new sfWidgetFormSelect(array("choices" =>array("France" => "France", "DOM" => "DOM", "Autre" => "Autre"))),
				'telephone'			=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 15)),
				'fax'				=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 15)),
				'id'				=> new sfWidgetFormInputHidden(),
				'email_address'                 => new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 155)),
				'email_confirmation'            => new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 155)),
				'password'			=> new sfWidgetFormInputPassword(array(), array('size'=> 30, 'maxlength' => 20)),
				'password_confirmation'		=> new sfWidgetFormInputPassword(array(), array('size'=> 30, 'maxlength' => 20)),
		    
				'livraison_raison_sociale'		=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 255)),
				'livraison_civilite'            => new sfWidgetFormSelect(array("choices" =>array("Mr" => "Mr", "Mme" => "Mme", "Société" => "Société"))),
				'livraison_nom'			=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 100)),
				'livraison_prenom'		=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 100)),
				'livraison_adresse'		=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 255)),
				'livraison_adresse_complement'	=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 255)),
				'livraison_code_postal'         => new sfWidgetFormInputText(array(), array('size'=> 5, 'maxlength' => 5)),
				'livraison_ville'		=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 100)),
				'livraison_pays'		=> new sfWidgetFormSelect(array("choices" =>array("France" => "France", "DOM" => "DOM", "Autre" => "Autre"))),
				'livraison_telephone'           => new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 15)),
				'livraison_fax'			=> new sfWidgetFormInputText(array(), array('size'=> 30, 'maxlength' => 15)),

				'livraison_note'		=> new sfWidgetFormTextarea()
		));
			
		$this->setValidators(array(
				'type'			=> new sfValidatorString(array('required' => true), array('required'=>'Veuillez renseigner si vous êtes un particulier ou une société')),
				'raison_sociale'	=> new sfValidatorString(array('required' => false)),
				'civilite'			=> new sfValidatorString(array('required' => true), array('required'=>'Veuillez renseigner votre civilité')),
				'nom'				=> new sfValidatorString(array('required' => false), array('required'=>'Veuillez renseigner votre nom')),
				'prenom'			=> new sfValidatorString(array('required' => false)),
				'adresse'			=> new sfValidatorString(array('required' => true), array('required'=>'Veuillez renseigner votre adresse')),
				'adresse_complement'		=> new sfValidatorString(array('required' => false)),
				'code_postal'                   => new sfValidatorString(array('required' => true, 'min_length' => 5, 'max_length' => 5), array('required'=>'Veuillez renseigner le code postal')),
				'ville'				=> new sfValidatorString(array('required' => true), array('required'=>'Veuillez renseigner votre ville')),
				'pays'				=> new sfValidatorString(array('required' => true), array('required'=>'Veuillez renseigner votre pays')),
				'telephone'			=> new sfValidatorString(array('required' => true), array('required'=>'Veuillez renseigner votre téléphone')),
				'fax'				=> new sfValidatorString(array('required' => false)),
				'id'				=> new sfValidatorString(array('required' => false)),
				'email_address'                 => new sfValidatorEmail(array('required' => true), array('required'=>'Veuillez renseigner votre email')),
				'email_confirmation'            => new sfValidatorEmail(array('required' => true), array('required'=>'Veuillez renseigner la confirmation de votre email')),
				'password'			=> new sfValidatorString(array('required' => true), array('required'=>'Veuillez renseigner votre mot de passe')),
				'password_confirmation'		=> new sfValidatorString(array('required' => true), array('required'=>'Veuillez renseigner la confirmation de votre mot de passe')),
		    
				'livraison_raison_sociale'	=> new sfValidatorString(array('required' => false)),
				'livraison_civilite'            => new sfValidatorString(array('required' => false)),
				'livraison_nom'			=> new sfValidatorString(array('required' => false)),
				'livraison_prenom'		=> new sfValidatorString(array('required' => false)),
				'livraison_adresse'		=> new sfValidatorString(array('required' => false)),
				'livraison_adresse_complement'	=> new sfValidatorString(array('required' => false)),
				'livraison_code_postal'         => new sfValidatorString(array('required' => false, 'min_length' => 5, 'max_length' => 5), array('required'=>'Veuillez renseigner le code postal')),
				'livraison_ville'		=> new sfValidatorString(array('required' => false)),
				'livraison_pays'		=> new sfValidatorString(array('required' => false)),
				'livraison_telephone'           => new sfValidatorString(array('required' => false)),
				'livraison_fax'			=> new sfValidatorString(array('required' => false)),

				'livraison_note'		=> new sfValidatorString(array('required' => false))
		));
			
		$this->validatorSchema->setPostValidator(
		new sfValidatorAnd(array(
		new sfValidatorDoctrineUnique(array('model' => 'sfGuardUser', 'column' => 'email_address', 'primary_key' => 'id'), array('invalid'=>'Une adresse similaire est déjà enregistrée. Vous devez impérativement vous connecter en haut de ce formulaire.')),
		new sfValidatorSchemaCompare('email_address', sfValidatorSchemaCompare::EQUAL, 'email_confirmation', array(), array('invalid' => 'Les deux emails doivent être identiques')),
		new sfValidatorSchemaCompare('password', sfValidatorSchemaCompare::IDENTICAL, 'password_confirmation', array(), array('invalid' => 'Les deux mots de passe doivent être identiques')),
		    new sfValidatorCallback(array('callback' => array($this, 'champsObligatoires')))
		))
		);

		$this->widgetSchema->setNameFormat('coordonnees[%s]');
	}

	public function champsObligatoires($validator, $values)
	{
		if($values["type"] != "Société" && $values["prenom"] == "")
		{
			$error = new sfValidatorError($validator, 'Veuillez renseigner votre prénom');
			// throw an error bound to the val field
			throw new sfValidatorErrorSchema($validator, array('prenom' => $error));
		}
		
		if($values["type"] == "Société" && $values["raison_sociale"] == "")
		{
			$error = new sfValidatorError($validator, 'Veuillez renseigner votre raison sociale');
			// throw an error bound to the val field
			throw new sfValidatorErrorSchema($validator, array('raison_sociale' => $error));
		}

		return $values;
	}
}