<?php

/**
 * Commande form.
 *
 * @package    sf_sandbox
 * @subpackage form
 * @author     Your name here
 * @version    SVN: $Id: sfDoctrineFormTemplate.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class CommandeForm extends BaseCommandeForm
{
	public function configure()
	{
		unset($this['id_client'], $this['date_creation'], $this['date_edition']);
		
		$this->widgetSchema['type'] = new sfWidgetFormSelect(array("choices" =>array(""=>"", "Société" => "Société", "Particulier" => "Particulier")));
		$this->validatorSchema['type'] = new sfValidatorString(array('required' => false));

		$this->widgetSchema['civilite'] = new sfWidgetFormSelect(array("choices" =>array(""=>"", "Mr" => "Mr", "Mme" => "Mme")));
		$this->validatorSchema['civilite'] = new sfValidatorString(array('required' => false));

		$this->widgetSchema['type_commande'] = new sfWidgetFormSelect(array("choices" =>array(""=>"", 1 => "Devis", 2 => "Panier", 3 => "Ticket")));
		$this->validatorSchema['type_commande'] = new sfValidatorString(array('required' => true), array('required'=>'Veuillez choisir un type de commande'));

		$this->widgetSchema['note_livraison'] = new sfWidgetFormTextarea();
		$this->validatorSchema['note_livraison'] = new sfValidatorString(array('required' => false));

		$this->widgetSchema['id_statut'] = new sfWidgetFormSelect(array("choices" => sfConfig::get("app_commande_statut_libelle")));
		$this->validatorSchema['id_statut'] = new sfValidatorNumber();

		$this->widgetSchema['devis_pdf'] = new sfWidgetFormInputHidden();
		$this->widgetSchema["devis_pdf_supprimer"] = new sfWidgetFormInputCheckbox();
		$this->validatorSchema["devis_pdf_supprimer"] = new sfValidatorBoolean(array('required' => false));

		$this->widgetSchema['moyen_paiement'] = new sfWidgetFormSelect(array("choices" => sfConfig::get("app_commande_moyen_paiement_libelle")));
		$this->validatorSchema['moyen_paiement'] = new sfValidatorNumber(array("required"=>false));

		$this->widgetSchema['id_user_suiveur'] = new sfWidgetFormInputHidden();
		$this->validatorSchema['id_user_suiveur'] = new sfValidatorDoctrineChoice(array('model' => $this->getRelatedModelName('sfGuardUser'), 'required' => false));

		$this->validatorSchema['email'] = new sfValidatorEmail(array('required'=>true), array('required'=>'Vous devez saisir une adresse email'));
		
		$this->validatorSchema['total_ttc'] = new sfValidatorNumber(array('required' => true),array('required'=>'Vous devez saisir le total ttc'));
		
		$this->widgetSchema['numero_colissimo'] = new sfWidgetFormInputText(array(), array('maxlength'=>13));
		$this->validatorSchema['numero_colissimo'] = new sfValidatorString(array('required'=>false));
		
		$this->widgetSchema['mail_commande'] = new sfWidgetFormInputHidden();
		$this->widgetSchema['mail_colissimo'] = new sfWidgetFormInputHidden();
		
		$this->validatorSchema->setPostValidator(
			new sfValidatorCallback(array('callback' => array($this, 'champsObligatoires')))
		);
	}

	public function champsObligatoires($validator, $values)
	{
		if($values["type_commande"] == 1 && $values["devis_token"] == "")
		{
			$error = new sfValidatorError($validator, 'Vous devez uploader un devis pdf !');
			// throw an error bound to the val field
			throw new sfValidatorErrorSchema($validator, array('devis_token' => $error));
		}
		else if($values["type_commande"] == 2 && $values["telephone"] == "")
		{
			$error = new sfValidatorError($validator, 'Veuillez saisir un numéro de téléphone');
			// throw an error bound to the val field
			throw new sfValidatorErrorSchema($validator, array('telephone' => $error));
		}
		else if($values["type_commande"] == 2 && $values["commande_token"] == "" && $values["id_statut"] == 0)
		{
			$error = new sfValidatorError($validator, 'Vous devez saisir au moins un article !');
			// throw an error bound to the val field
			throw new sfValidatorErrorSchema($validator, array('commande_token' => $error));
		}
		
		if(($values["id_statut"] == 4 && strlen($values["numero_colissimo"]) < 13) || (strlen($values["numero_colissimo"]) > 0 && strlen($values["numero_colissimo"]) < 13))
		{
			$error = new sfValidatorError($validator, 'Vous devez saisir un numéro de colissimo valide (13 caractères) !');
			// throw an error bound to the val field
			throw new sfValidatorErrorSchema($validator, array('numero_colissimo' => $error));
		}
		
		return $values;
	}
}
