<?php

/**
 * CommandeTable
 * 
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class CommandeTable extends Doctrine_Table
{
    /**
     * Returns an instance of this class.
     *
     * @return object CommandeTable
     */
    public static function getInstance()
    {
        return Doctrine_Core::getTable('Commande');
    }
    
    /**
     * Supprime les articles d'une commande
     * @param unknown_type $id_commande
     */
    public static function supprimerArticle($id_commande)
    {
    	$sql = Doctrine_Core::getTable('CommandeArticle')
    					->createQuery("c")
    					->delete()
    					->andWhere("c.id_commande = ?", $id_commande);
    	
    	return $sql->execute();
    }
    
    public static function getLastOrderByCustomer($customer_id)
    {
        return Doctrine::getTable("Commande")
    			->createQuery("c")
    			->where("c.id_client = ?", $customer_id)
    			->orderBy("c.id_commande DESC")
                        ->fetchOne();
    }
    
    public static function countByCustomer($customer_id)
    {
    	return Doctrine_Core::getTable("Commande")
	    ->createQuery("c")
	    ->select("count(1)")
	    ->where("c.id_client = ?", $customer_id)
	    ->andWhere("c.id_statut IN (3, 4, 7, 8, 9)")
	    ->fetchArray();
    }
    
    public static function alreadyBuyArticle($customer_id, $id_article)
    {
    	return Doctrine_Core::getTable("Commande")
	    ->createQuery("c")
	    ->innerJoin("c.CommandeArticles ca")
	    ->where("c.id_client = ?", $customer_id)
	    ->andWhere("ca.id_article = ?", $id_article)
	    ->andWhere("c.id_statut IN (3, 4, 7, 8, 9)")
	    ->execute();
    }
}