<?php

/**
 * ConfigTable
 * 
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class ConfigTable extends Doctrine_Table
{
    /**
     * Returns an instance of this class.
     *
     * @return object ConfigTable
     */
    public static function getInstance()
    {
        return Doctrine_Core::getTable('Config');
    }
    
    public static function getMinimumCommande()
    {
    	$config = self::getInstance()
    				->createQuery('c')
    				->where('c.actif = ?', '1')
    				->andWhere('c.id_config = ?', sfConfig::get('app_configuration_minimum_commande'))
    				->execute();
    				
    	$config = $config[0];
    	
    	if($config instanceof Config)
    	{
    		if(is_numeric($config->getValeur()))
    		{
    			return $config->getValeur();
    		}
    		else
    		{
    			return 0;
    		}
    	}
    	else
    	{
    		return 0;
    	}
    }
    
    public static function getOptionVacances()
    {
    	$config = self::getInstance()
    				->createQuery('c')
    				->where('c.actif = ?', '1')
    				->andWhere('c.id_config = ?', sfConfig::get('app_configuration_option_vacances'))
    				->execute();
    				
    	$config = $config[0];
    	
    	if($config instanceof Config)
    	{
    		return $config->getValeur();
    	}
    	else
    	{
    		return false;
    	}
    }
    
    public static function getMinimumFraisDePort()
    {
    	$config = self::getInstance()
	    ->createQuery('c')
	    ->where('c.actif = ?', '1')
	    ->andWhere('c.id_config = ?', sfConfig::get('app_configuration_minimum_frais_de_port'))
	    ->execute();
    				
    	$config = $config[0];
    	
    	if ($config instanceof Config) {
	    if (is_numeric($config->getValeur())) {
		return (double) $config->getValeur();
	    } else {
		return 0;
	    }
    	} else {
    		return 0;
    	}
    }
    
    public static function getMinimumFraisDeGestion()
    {
    	$config = self::getInstance()
	    ->createQuery('c')
	    ->where('c.actif = ?', '1')
	    ->andWhere('c.id_config = ?', sfConfig::get('app_configuration_minimum_frais_de_gestion'))
	    ->execute();
    				
    	$config = $config[0];
    	
    	if ($config instanceof Config) {
	    if (is_numeric($config->getValeur())) {
		return (double) $config->getValeur();
	    } else {
		return 0;
	    }
    	} else {
    		return 0;
    	}
    }
    
    public static function getFraisDeGestion()
    {
    	$config = self::getInstance()
	    ->createQuery('c')
	    ->where('c.actif = ?', '1')
	    ->andWhere('c.id_config = ?', sfConfig::get('app_configuration_frais_de_gestion'))
	    ->execute();
    				
    	$config = $config[0];
    	
    	if ($config instanceof Config) {
	    if (is_numeric($config->getValeur())) {
		return (double) $config->getValeur();
	    } else {
		return 0;
	    }
    	} else {
    		return 0;
    	}
    }
}