<?php

/**
 * NettoyeurHautePressionTable
 * 
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class NettoyeurHautePressionTable extends Doctrine_Table
{
    /**
     * Returns an instance of this class.
     *
     * @return object NettoyeurHautePressionTable
     */
    public static function getInstance()
    {
        return Doctrine_Core::getTable('NettoyeurHautePression');
    }
    
    /**
     * Récpère une liste de nettoyeurs en fonction de la marque
     * @return Doctrine_Collection
     */
    public static function getListByMarque($id_marque)
    {
    	return Doctrine::getTable("NettoyeurHautePression")
    			->createQuery("n")
    			->where("n.id_marque = ?", $id_marque)
    			->orderBy("n.modele ASC")
    			->execute();
    }
    
    public static function getListVentePiecesDetacheesForSearchEngineByMarque($id_marque)
    {
    	return Doctrine::getTable("NettoyeurHautePression")
    			->createQuery("n")
    			->where("n.id_marque = ?", $id_marque)
    			->andWhere("n.visible_moteur_recherche = 1")
    			->andWhere("n.vente_pieces_detachees = 1")
    			->orderBy("n.modele ASC")
    			->execute();
    }
    
    public static function getListForSearchEngineByMarque($id_marque)
    {
    	return Doctrine::getTable("NettoyeurHautePression")
    			->createQuery("n")
    			->where("n.id_marque = ?", $id_marque)
    			->andWhere("n.visible_moteur_recherche = 1")
    			->orderBy("n.modele ASC")
    			->execute();
    }
    
	public function retrieveBackendNettoyeurList(Doctrine_Query $q)
    {
    	$rootAlias = $q->getRootAlias();
    	$q->leftJoin($rootAlias.'.Marque m');
    	return $q;
    }
    
    public static function getListByArticle($reference_ths_sage)
    {
    	return Doctrine_Query::create()
    			->from("NettoyeurHautePression n")
    			->innerJoin("n.Marque m")
    			->innerJoin("n.Associations a")
    			->innerJoin("a.AssociationArticles s")
    			->where("s.reference_ths_sage = ?", $reference_ths_sage)
    			->orderBy("m.libelle, n.modele")
    			->execute();
    }
    
    public static function getNettoyeurByMarqueModeleFromUrl($marque, $modele)
    {
    	$recherche = "%".$marque."/".$modele.".html";
    	$result = Doctrine_Query::create()
    			->from("NettoyeurHautePression n")
    			->where("n.url_article LIKE ?", $recherche)
    			->execute();
    
    	if(sizeof($result) > 0)
    	{
    		return $result[0];
    	}
    	else
    	{
    		return false;
    	}
    }
    
    public static function getListPromoEauFroide()
    {
    	return Doctrine_Query::create()
    			->from("NettoyeurHautePression n")
    			->innerJoin("n.Marque m")
    			->where("n.actif = 1")
    			->andWhere("n.promo = 1")
    			->andWhere("n.eau_froide = 1")
    			->orderBy("m.libelle, n.modele")
    			->execute();
    }
    
	public static function getListPromoEauChaude()
    {
    	return Doctrine_Query::create()
    			->from("NettoyeurHautePression n")
    			->innerJoin("n.Marque m")
    			->where("n.actif = 1")
    			->andWhere("n.promo = 1")
    			->andWhere("n.eau_chaude = 1")
    			->orderBy("m.libelle, n.modele")
    			->execute();
    }
    
	public static function getListPromoMoteurThermique()
    {
    	return Doctrine_Query::create()
    			->from("NettoyeurHautePression n")
    			->innerJoin("n.Marque m")
    			->where("n.actif = 1")
    			->andWhere("n.promo = 1")
    			->andWhere("n.moteur_thermique = 1")
    			->orderBy("m.libelle, n.modele")
    			->execute();
    }
    
    public static function getListExportRecapitulatifAssociation()
    {
    	return Doctrine_Query::create()
    			->select("n.modele, m.libelle, a.id_famille, aa.reference_ths_sage")
    			->from("NettoyeurHautePression n")
    			->innerJoin("n.Marque m")
    			->innerJoin("n.Associations a")
    			->innerJoin("a.AssociationArticle aa")
    			->orderBy("m.libelle, n.modele, a.id_famille")
    			->execute(array(), Doctrine::HYDRATE_ARRAY);
    }
    
	public static function getListRecapitulatifAssociation()
    {
    	return Doctrine_Query::create()
    			->select("n.modele, m.libelle, a.id_famille, aa.reference_ths_sage, aaa.reference_ths")
    			->from("NettoyeurHautePression n")
    			->innerJoin("n.Marque m")
    			->innerJoin("n.Associations a")
    			->innerJoin("a.AssociationArticle aa")
    			->innerJoin("aa.Article aaa")
    			->orderBy("m.libelle, n.modele, a.id_famille")
    			->execute(array(), Doctrine::HYDRATE_ARRAY);
    }
    
    public static function findNomenclaturesLieesParNettoyeur($id_nettoyeur)
    {
    	return Doctrine::getTable("Nomenclature")
    			->createQuery("n")
    			->innerJoin("n.NettoyeurHautePressionNomenclatures a")
    			->where("a.id_nettoyeur = ?", $id_nettoyeur)
    			->orderBy("n.reference ASC")
    			->execute();
    }
    
    public static function findNomenclaturesNonLieesParNettoyeur($id_nettoyeur)
    {
    	return Doctrine::getTable("Nomenclature")
    			->createQuery("n")
    			->where("n.id NOT IN (SELECT n2.id_nomenclature FROM NettoyeurHautePressionNomenclature n2 WHERE n2.id_nettoyeur = ?)", $id_nettoyeur)
    			->orderBy("n.reference ASC")
    			->execute();
    }
    
	public static function findAllEnabled()
	{
		return static::getInstance()
			    ->createQuery("p")
			    ->where("p.actif = 1")
			    ->execute();
	}
}