<?php

/**
 * AssociationTable
 * 
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class AssociationTable extends Doctrine_Table
{
    /**
     * Returns an instance of this class.
     *
     * @return object AssociationTable
     */
    public static function getInstance()
    {
        return Doctrine_Core::getTable('Association');
    }
    
    /**
     * Retourne la liste des blocs pour un nettoyeur
     * @param $id_nettoyeur
     * @return Doctrine_Collection
     */
    public static function getListByIdNettoyeur($id_nettoyeur)
    {
    	return Doctrine::getTable("Association")
    			->createQuery("a")
    			->leftJoin("a.AssociationArticles aa")
    			->leftJoin("a.Articles ar ON ar.reference_ths_sage = aa.reference_ths_sage")
    			->where("a.id_nettoyeur = ?", $id_nettoyeur)
    			->orderBy("a.id_famille ASC, a.ordre ASC, aa.ordre ASC, aa.reference_ths_sage ASC")
    			->execute();
    }
    
    /**
     * Supprime tous les associations du nettoyeur sauf les associations passés en paramètre
     * @param $id_nettoyeur
     * @param $listeIdAssociation
     */
	public static function deleteByIdNettoyeurExceptIdAssociations($id_nettoyeur, $listeIdAssociation = array())
    {
    	$q = Doctrine::getTable("Association")
    			->createQuery("a")
    			->delete()
    			->where("a.id_nettoyeur = ?", $id_nettoyeur);
    			
    	if(sizeof($listeIdAssociation) > 0)
    	{
    		$q->andWhereNotIn("a.id_association", $listeIdAssociation);
    	}
    	
    	return $q->execute();
    }
    
    public static function getListByIdNettoyeurForFrontend($id_nettoyeur)
    {
    	return Doctrine::getTable("Association")
    			->createQuery("a")
    			->innerJoin("a.Famille f")
    			->innerJoin("a.AssociationArticles aa")
    			->innerJoin("a.Articles ar ON ar.reference_ths_sage = aa.reference_ths_sage")
    			->where("a.id_nettoyeur = ?", $id_nettoyeur)
    			->orderBy("f.ordre ASC, a.ordre ASC, aa.ordre ASC, aa.reference_ths_sage ASC")
    			->execute();
    }
}