<?php

/**
 * BackupConfigTable
 * 
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class BackupConfigTable extends Doctrine_Table
{
    /**
     * Returns an instance of this class.
     *
     * @return object BackupConfigTable
     */
    public static function getInstance()
    {
        return Doctrine_Core::getTable('BackupConfig');
    }
    
    /**
     * Retourne un tableau des jours lié au type passé en apramètre
     * @param type $type
     * @return type
     */
    public static function getListDayByType($type)
    {
    	$list = Doctrine_Query::create()
                ->from("BackupConfig b")
                ->where('b.type = ?', $type)
                ->orderBy("b.day")
                ->execute();
        
    	$result = array();
        
    	foreach ($list as $element) {
            $result[$element->getDay()] = $element->getDay();
    	}
        
    	return $result;
    }
    
    public static function save($type, $days) 
    {
    	if (!is_array($days)) {
            return false;
    	}
    	
    	foreach ($days as $element) {
            $b = new BackupConfig();
            $b->setType($type);
            $b->setDay($element);
            $b->save();
    	}
    }
    
    public static function deleteAll($type)
    {
    	return Doctrine_Query::create()
                ->delete("BackupConfig b")
                ->where('b.type = ?', $type)
                ->execute();
    }
}