<?php

/**
 * Zone
 * 
 * This class has been auto-generated by the Doctrine ORM Framework
 * 
 * @package    sf_sandbox
 * @subpackage model
 * @author     Your name here
 * @version    SVN: $Id: Builder.php 7490 2010-03-29 19:53:27Z jwage $
 */
class Zone extends BaseZone
{
	/**
	 * Permet de savoir si les dépertements sélectionnés ont déjà été affecté ou non à d'autre zone
	 */
	public function existeDepartements($departementIds)
	{
		if(sizeof($departementIds) == 0)
		{
			return false;
		}
		
		$result = Doctrine_Query::create()
					->from('Zone z')
					->innerJoin('z.ZoneDepartement d')
					->where('z.id_zone != ?', $this->id_zone)
					->andWhere('z.id_transporteur = ?', $this->id_transporteur)
					->andWhereIn('d.id_departement', $departementIds)
					->execute();
		if(sizeof($result) > 0)
		{
			return true;
		}
		return false;
	}
	
	/**
	 * Ajoute des relations liées aux départements
	 */
	public function addDepartements($departementIds)
	{
		if($this->id_zone == "" || sizeof($departementIds) == 0)
		{
			return;
		}
		
		foreach($departementIds as $id)
		{
			$zoneDepartement = new ZoneDepartement();
			$zoneDepartement->id_zone = $this->id_zone;
			$zoneDepartement->id_departement = $id;
			$zoneDepartement->save();
		}
	}
	
	/**
	 * Supprime les relations liées aux départements
	 */
	public function deleteDepartements()
	{
		if($this->id_zone == "")
		{
			return;
		}
		return Doctrine_Query::create()
		    ->delete('ZoneDepartement')
		    ->addWhere('id_zone = ?', $this->id_zone)
		    ->execute();
	}
	
	/**
	 * Ajoute des relations liées aux tarifs
	 */
	public function addTarifs($tarifsIds)
	{
		if($this->id_zone == "")
		{
			return;
		}
		foreach($tarifsIds as $poids => $tarif)
		{
			if($tarif != "")
			{
				$zoneTarif = new ZoneTarif();
				$zoneTarif->id_zone = $this->id_zone;
				$zoneTarif->id_poids = $poids;
				$zoneTarif->tarif = str_replace(",", ".", $tarif);
				$zoneTarif->save();
			}
		}
	}
	
	/**
	 * Supprime les relations liées aux tarifs
	 */
	public function deleteTarifs()
	{
		if($this->id_zone == "")
		{
			return;
		}
		return Doctrine_Query::create()
		    ->delete('ZoneTarif')
		    ->addWhere('id_zone = ?', $this->id_zone)
		    ->execute();
	}
}